<?php
		/** function/method
		* Usage: hooking (registering) the plugin menu
		* Arg(0): null
		* Return: void
		*/
		function menu_about_single(){
		if ( is_admin() )
		add_submenu_page( 'spam-master', 'Support', 'Support', 'manage_options', 'spam-master-about', 'spam_master_about' );
		}

		///////////////////////
		// WORDPRESS ACTIONS //
		///////////////////////
		if( is_multisite() ) {
		add_action( 'admin_menu', 'menu_about_single' );
		}
		else{
		add_action( 'admin_menu', 'menu_about_single' );
		}

function spam_master_about(){
global $wpdb, $blog_id;

$plugin_master_name = constant('SPAM_MASTER_NAME');
$plugin_master_domain = constant('SPAM_MASTER_DOMAIN');

//Remote Ip
$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
//Remote Agent
if(isset($_SERVER['HTTP_USER_AGENT'])){
	$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
}
else{
	$remote_agent = 'Sniffer';
}
// Remote Referer
if(isset($_SERVER['HTTP_REFERER'])){
	$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
}
else{
	$remote_referer = 'Direct';
}
// DEST URL
if(isset($_SERVER['REQUEST_URI'])){
	$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
}
else{
	$dest_url = 'Weird';
}
//exempt admins from check
if(!function_exists('wp_get_current_user')) {
	include(ABSPATH . "wp-includes/pluggable.php"); 
}
// Current User
$current_user_id = get_current_user_id();
if(isset($current_user_id)){
	$current_user_id = $current_user_id;
}
else{
	$current_user_id = 'none';
}
?>
<div class="wrap">
<h1><?php echo $plugin_master_name; ?> <?php echo __('About', 'spam_master'); ?></h1>
<?php
//Add Controllers
require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterInvitationController.php');
$SpamMasterInvitationController = new SpamMasterInvitationController;
$is_invited = $SpamMasterInvitationController->SpamMasterInvitation();
echo $is_invited;

if(!class_exists('spam_master_menu_table')){
	require_once( WP_PLUGIN_DIR . '/spam-master/includes/admin/spam-master-admin-menu-table.php');
}
//Prepare Table of elements
$wp_list_table = new spam_master_menu_table();
//Table of elements
$wp_list_table->display();
//Send Message Post
if(isset($_POST['send_support_message'])){
	check_admin_referer( 'save-spam_master_send_support_message' );

	if(isset($_POST['spam_master_support_email']) && isset($_POST['spam_master_support_admin_email']) && isset($_POST['spam_master_support_subject']) && isset($_POST['spam_master_support_message'])){

		if( is_multisite() ){
			$spam_master_support_status = esc_html(substr(get_blog_option($blog_id, 'spam_master_status'),0,256));
			$spam_master_support_lic = esc_html(substr(get_blog_option($blog_id, 'spam_license_key'),0,64));
			$spam_master_support_type = esc_html(substr(get_blog_option($blog_id, 'spam_master_type'),0,256));
			$blogname = esc_html(substr(get_blog_option($blog_id, 'blogname'),0,256));
		}
		else{
			$spam_master_support_status = esc_html(substr(get_option('spam_master_status'),0,256));
			$spam_master_support_lic = esc_html(substr(get_option('spam_license_key'),0,64));
			$spam_master_support_type = esc_html(substr(get_option('spam_master_type'),0,256));
			$blogname = esc_html(substr(get_option('blogname'),0,256));
		}
		if(empty($blogname)){
			$blogname = 'empty blog name';
		}
		$spam_master_support_email = sanitize_text_field(substr($_POST['spam_master_support_email'], 0,256));
		$spam_master_support_admin_email = sanitize_text_field(substr($_POST['spam_master_support_admin_email'],0,256));
		$spam_master_support_subject = sanitize_text_field(substr($_POST['spam_master_support_subject'],0,360));
		$spam_master_support_message = sanitize_text_field(substr($_POST['spam_master_support_message'],0,360));

		$spam_master_learn_r_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX3JlcC5waHA=';
		$spam_master_report_post = array(
										'blog_license_key' => $spam_master_support_lic,
										'blog_type' => 'Support Request',
										'blog_primary' => $remote_ip,
										'blog_secondary' => 'Type: '.$spam_master_support_type.' - Status: '.$spam_master_support_status.' - Email: '.$spam_master_support_email.' - Admin Email: '.$spam_master_support_admin_email.' - Subject: '.$spam_master_support_subject.' - Message: '.$spam_master_support_message,
										'blog_name' => $blogname,
										'blog_agent' => $remote_agent
		);
		$response = wp_remote_post( base64_decode($spam_master_learn_r_url), array(
																					'method' => 'POST',
																					'timeout' => 90,
																					'body' => $spam_master_report_post
		));
		if ( is_wp_error( $response ) ) {
			$error_message = $response->get_error_message();
			//Log InUp Controller
			/////////////////////
			$spamkey = 'System';
			$spamco = 'localhost';
			$spamcou = 'localhost';
			$spamvalue = 'Error: Support Message Reporting. '.$error_message.'';
			$SpamMasterLogController = new SpamMasterLogController;
			$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
?>
<div id="message" class="error">
<p><?php echo __('Something went wrong, please get in touch with spammaster.org support ERROR: '.$error_message, 'spam_master'); ?></p>
</div>
<?php
		}
		else{
?>
<div id="message" class="updated fade">
<p><?php echo __('Support message successfully receive. Please check your email inbox or junk folder for an answer.', 'spam_master'); ?></p>
</div>
<?php
		}
		//Log InUp Controller
		$spamkey = 'System';
		$spamco = 'localhost';
		$spamcou = 'localhost';
		$spamvalue = 'Support Request Email successful sent in About page.';
		$SpamMasterLogController = new SpamMasterLogController;
		$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
	}
	else{
?>
<div id="message" class="error">
<p><?php echo __('ERROR: Please fill Email, Subject and Message', 'spam_master'); ?></p>
</div>
<?php
	}
}
?>
<table class="wp-list-table widefat fixed striped table-view-list" cellspacing="0">
	<thead>
		<tr>
			<th><img src="<?php echo plugins_url('../images/spammaster-wp-plugin-internal-banner.jpg', dirname(__FILE__)); ?>" alt="<?php echo $plugin_master_name; ?>" align="left" width="100%" /></th>
		</tr>
	</thead>

	<tbody>
		<tr>
			<td class="spam-master-text-center">
<h2><?php echo __('Spam Master munches, feeds and grows on spam ip’s, emails, domains and words. Join one of the top 5 world-wide, real-time online spam checking databases', 'spam_master'); ?>.</h2>
			</td>
		</tr>
		<tr class="alternate">
			<td><strong><?php echo __('Note', 'spam_master'); ?> <span class="dashicons dashicons-arrow-right-alt"></span> <?php echo __('spam_email@example.com:', 'spam_master'); ?></strong> <?php echo __('You can test your website spam submission in any form (login, registration, comment, contact form 7, woocommerce, etc.) by using the email', 'spam_master'); ?> <strong><?php echo __('spam_email@example.com', 'spam_master'); ?></strong>. <?php echo __('Afterwards check the plugin Firewall page', 'spam_master'); ?>.</td>
		</tr>
		<tr class="alternate">
			<td><strong><?php echo __('Note', 'spam_master'); ?> <span class="dashicons dashicons-arrow-right-alt"></span> <?php echo __('Inactive:', 'spam_master'); ?></strong> <?php echo __('When you first install Spam Master the default status is Inactive, offline. Go to the Settings page and click', 'spam_master'); ?> <strong><?php echo __('Generate Free License', 'spam_master'); ?></strong>. <?php echo __(' button to quickly start your online connection to Spam Master RBL Free server Cluster', 'spam_master'); ?>.</td>
		</tr>
		<tr class="alternate">
			<td><strong><?php echo __('Note', 'spam_master'); ?> <span class="dashicons dashicons-arrow-right-alt"></span> <?php echo __('Malfunction 3:', 'spam_master'); ?></strong> <?php echo __('When auto creating a free license by clicking Generate Free License you might get a', 'spam_master'); ?> <strong><?php echo __('Malfunction 3 error', 'spam_master'); ?></strong>. <?php echo __('This usually occurs because of your server php version. If that\'s the case you can login to', 'spam_master'); ?> <a href="https://www.spammaster.org" target="_blank" title="<?php echo $plugin_master_domain; ?>"><?php echo $plugin_master_domain; ?></a> <?php echo __('and get a free license', 'spam_master'); ?>.</td>
		</tr>
		<tr class="alternate">
			<td><strong><?php echo __('Note', 'spam_master'); ?> <span class="dashicons dashicons-arrow-right-alt"></span> <?php echo __('Unstable:', 'spam_master'); ?></strong> <?php echo __('If you are connecting to the Free server cluster you might, hopefully not, get an occasional', 'spam_master'); ?> <strong><?php echo __('Unstable Connection', 'spam_master'); ?></strong>. <?php echo __('We apologize for that, there\'s probably a high demand of spam check requests to our free servers.', 'spam_master'); ?> <?php echo __('We monthly pull out personal resources to invest in our free server cluster, sometimes they are short. To fix this click the Re-Sync button. You can check the Free Server Cluster status', 'spam_master'); ?> <a href="https://www.spammaster.org/rbl-servers-status/" title="<?php echo __('Free Server Cluster Status', 'spam_master'); ?>" target="_blank"><?php echo __('here', 'spam_master'); ?></a>.</td>
		</tr>
		<tr class="alternate">
			<td><strong><?php echo __('Note', 'spam_master'); ?> <span class="dashicons dashicons-arrow-right-alt"></span> <?php echo __('Unstable:', 'spam_master'); ?></strong> <?php echo __('If you are connecting to the Free server cluster you might, hopefully not, get an occasional', 'spam_master'); ?> <strong><?php echo __('Unstable Connection', 'spam_master'); ?></strong>. <?php echo __('We apologize for that, there\'s probably a high demand of spam check requests to our free servers.', 'spam_master'); ?> <?php echo __('We monthly pull out personal resources to invest in our free server cluster, sometimes they are short. To fix this click the Re-Sync button. You can check the Free Server Cluster status', 'spam_master'); ?> <a href="https://www.spammaster.org/rbl-servers-status/" title="<?php echo __('Free Server Cluster Status', 'spam_master'); ?>" target="_blank"><?php echo __('here', 'spam_master'); ?></a>.</td>
		</tr>
		<tr class="alternate">
			<td><?php echo __('Spam Master is the first Saas with real-time checks provided free (with free license). This service implies high demand, heavy duty server connections, please consider supporting the project with a pro license that connects to our premium business server cluster.', 'spam_master'); ?></td>
		</tr>
<?php
if( is_multisite() ) {
	$spam_master_status = get_blog_option($blog_id, 'spam_master_status');
	$spam_master_type = get_blog_option($blog_id, 'spam_master_type');
	$spam_master_license = get_blog_option($blog_id, 'spam_license_key');
	$admin_email = substr(get_blog_option($blog_id, 'admin_email'),0,128);
}
else{
	$spam_master_status = get_option('spam_master_status');
	$spam_master_type = get_option('spam_master_type');
	$spam_master_license = get_option('spam_license_key');
	$admin_email = substr(get_option('admin_email'),0,128);
}
if($spam_master_status == 'VALID'){
?>
		<tr class="alternate">
			<td><?php echo __('If you enjoy the service provided Spam Master, please', 'spam_master'); ?> <a href="https://wordpress.org/plugins/spam-master/" target="_blank" title="Visit Website"><?php echo __('Rate us *****', 'spam_master'); ?></a> <?php echo __('on wordpress.org', 'spam_master'); ?>.</td>
		</tr>
<?php
}
?>
	</tbody>
</table>

<div class="spam-master-pad-table"></div>

<form method="post" width='1'>
<fieldset class="options">
<?php $sec_nonce = wp_nonce_field( 'save-spam_master_send_support_message' ); ?>
<table class="wp-list-table widefat fixed striped table-view-list" cellspacing="0">
	<thead>
		<tr>
			<th colspan="3"><h2><img class="spam-master-admin-img" src="<?php echo plugins_url('../images/spammaster-logo.png', dirname(__FILE__)); ?>" /><?php echo __('&nbsp;Support & Contact', 'spam_master'); ?></h2></th>
		</tr>
	</thead>

	<tfoot>
		<th colspan="3">
			<button type="submit" name="send_support_message" id="send_support_message" class="btn-spammaster blue roundedspam" href="#" title="<?php echo __('Send Message', 'spam_master'); ?>"><?php echo __('Send Message', 'spam_master'); ?></button>
		</th>
	</tfoot>

	<tbody>
		<tr>
			<td colspan="3">Please make sure to check your inbox after sending your support request. If you have a Pro License you can expect a fast answer.</td>
		</tr>
		<tr>
			<td><strong><?php echo __('Type', 'spam_master'); ?>:</strong> <input class="spam-master-100" type="text" name="spam_master_support_type" value="<?php echo $spam_master_type; ?>" disabled></td>
			<td><strong><?php echo __('Status', 'spam_master'); ?>:</strong> <input class="spam-master-100" type="text" name="spam_master_support_status" value="<?php echo $spam_master_status; ?>" disabled></td>
			<td><strong><?php echo __('License', 'spam_master'); ?>:</strong> <input class="spam-master-100" type="text" name="spam_master_support_lic" value="<?php echo $spam_master_license; ?>" disabled></td>
		</tr>
		<tr>
			<td><strong><?php echo __('Email', 'spam_master'); ?>:</strong> <input class="spam-master-100" type="email" name="spam_master_support_email" value="<?php echo $admin_email; ?>" required> <input type="hidden" class="spam-master-hidden" name="spam_master_support_admin_email" value="<?php echo $admin_email; ?>"></td>
			<td><strong><?php echo __('Subject', 'spam_master'); ?>:</strong> <input class="spam-master-100" type="text" name="spam_master_support_subject" value="" required></td>
			<td><strong><?php echo __('Message', 'spam_master'); ?>Message:</strong> <textarea class="spam-master-100" name="spam_master_support_message" value="" required></textarea></td>
		</tr>
	</tbody>
</table>
</fieldset>
</form>
<?php
//Footer
require_once( WP_PLUGIN_DIR . '/spam-master/includes/admin/spam-master-admin-footer.php');
?>
</div>
<?php
}
