<?php
global $wpdb, $blog_id;
if( is_multisite() ){
	//Load Tables
	$table_threats = $wpdb->get_blog_prefix($blog_id)."spam_master_threats";
	$table_keys = $wpdb->get_blog_prefix($blog_id)."spam_master_keys";
}
else{
	//Load Tables
	$table_threats = $wpdb->prefix."spam_master_threats";
	$table_keys = $wpdb->prefix."spam_master_keys";
}
//Add Controllers
require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
//Time Frames
$current_time = current_time( 'mysql' );
$minus_12months_time = date('Y-m-d h:i:s', strtotime("-12 months", strtotime($current_time)));
$minus_3months_time = date('Y-m-d h:i:s', strtotime("-3 months", strtotime($current_time)));

//Clean Up Buffer
$wpdb->query( 
			$wpdb->prepare( 
							"DELETE FROM $table_threats
							WHERE time <= %s",
							$minus_12months_time
							)
			);
//Log InUp Controller
$spamkey = 'System';
$remote_ip = 'localhost';
$spamco = 'localhost';
$spamcou = 'localhost';
$remote_referer = 'localhost';
$dest_url = 'localhost';
$remote_agent = 'localhost';
$current_user_id = 'localhost';
$spamvalue = 'Clean-Up of Spam Buffer cron successfully run.';
$SpamMasterLogController = new SpamMasterLogController;
$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
//Clean Up Comments & Clean-up Logs
if( is_multisite() ){
$spam_master_comments_clean = get_blog_option($blog_id, 'spam_master_comments_clean');
$spam_master_logs_firewall_clean = get_blog_option($blog_id, 'spam_master_logs_firewall_clean');
$spam_master_logs_registration_clean = get_blog_option($blog_id, 'spam_master_logs_registration_clean');
$spam_master_logs_comment_clean = get_blog_option($blog_id, 'spam_master_logs_comment_clean');
$spam_master_logs_contact_form_7_clean = get_blog_option($blog_id, 'spam_master_logs_contact_form_7_clean');
$spam_master_logs_woocommerce_clean = get_blog_option($blog_id, 'spam_master_logs_woocommerce_clean');
$spam_master_logs_system_clean = get_blog_option($blog_id, 'spam_master_logs_system_clean');
$spam_master_logs_honeypot_clean = get_blog_option($blog_id, 'spam_master_logs_honeypot_clean');
$spam_master_logs_recaptcha_clean = get_blog_option($blog_id, 'spam_master_logs_recaptcha_clean');
$spam_master_free_unstable = get_blog_option($blog_id, 'spam_master_free_unstable');
$spam_master_unstable_notice = get_blog_option($blog_id, 'spam_master_unstable_notice');

	if($spam_master_comments_clean == 'true'){
		$blog_prefix = $wpdb->get_blog_prefix();
		$result_comments_status = $wpdb->get_results("SELECT comment_ID,comment_author_IP,comment_author_email,comment_approved FROM {$blog_prefix}comments WHERE comment_approved = '0' OR comment_approved = '1' OR comment_approved = 'spam' OR comment_approved = 'trash'");
		foreach($result_comments_status as $status){
			$status_id = $status->comment_ID;
			$status_ip = $status->comment_author_IP;
			$status_email = $status->comment_author_email;
			$status_status = $status->comment_approved;

			$is_buffer_threat = $wpdb->get_results(
								$wpdb->prepare( 
												"SELECT threat 
												FROM $table_threats
												WHERE threat = %s OR threat = %s", 
												$status_ip, $status_email
								));
			if(!empty($is_buffer_threat)){
				wp_delete_comment( $status_id, false );
			}
		}
		//Clean old trashed comments
		$wpdb->query( 
					$wpdb->prepare( 
									"DELETE FROM {$blog_prefix}comments
									WHERE 
									(comment_approved = '0' OR comment_approved = '1' OR comment_approved = 'spam' OR comment_approved = 'trash')
									AND
									comment_date <= %s",
									$minus_3months_time
									)
					);
		//Log InUp Controller
		$spamkey = 'System';
		$remote_ip = 'localhost';
		$spamco = 'localhost';
		$spamcou = 'localhost';
		$remote_referer = 'localhost';
		$dest_url = 'localhost';
		$remote_agent = 'localhost';
		$current_user_id = 'localhost';
		$spamvalue = 'Clean-Up of old spam and trashed comments cron successfully run.';
		$SpamMasterLogController = new SpamMasterLogController;
		$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
	}
}
else{
$spam_master_comments_clean = get_option('spam_master_comments_clean');
$spam_master_logs_firewall_clean = get_option('spam_master_logs_firewall_clean');
$spam_master_logs_registration_clean = get_option('spam_master_logs_registration_clean');
$spam_master_logs_comment_clean = get_option('spam_master_logs_comment_clean');
$spam_master_logs_contact_form_7_clean = get_option('spam_master_logs_contact_form_7_clean');
$spam_master_logs_woocommerce_clean = get_option('spam_master_logs_woocommerce_clean');
$spam_master_logs_system_clean = get_option('spam_master_logs_system_clean');
$spam_master_logs_honeypot_clean = get_option('spam_master_logs_honeypot_clean');
$spam_master_logs_recaptcha_clean = get_option('spam_master_logs_recaptcha_clean');
$spam_master_free_unstable = get_option('spam_master_free_unstable');
$spam_master_unstable_notice = get_option('spam_master_unstable_notice');

	if($spam_master_comments_clean == 'true'){
	$table_prefix = $wpdb->base_prefix;
	$result_comments_status = $wpdb->get_results("SELECT comment_ID,comment_author_IP,comment_author_email,comment_approved FROM {$table_prefix}comments WHERE comment_approved = '0' OR comment_approved = '1' OR comment_approved = 'spam' OR comment_approved = 'trash'");
		foreach($result_comments_status as $status){
			$status_id = $status->comment_ID;
			$status_ip = $status->comment_author_IP;
			$status_email = $status->comment_author_email;
			$status_status = $status->comment_approved;

			$is_buffer_threat = $wpdb->get_results(
								$wpdb->prepare( 
												"SELECT threat 
												FROM $table_threats
												WHERE threat = %s OR threat = %s", 
												$status_ip, $status_email
								));
			if(!empty($is_buffer_threat)){
				wp_delete_comment( $status_id, false );
			}
		}
		//Clean old trashed comments
		$wpdb->query( 
					$wpdb->prepare( 
									"DELETE FROM {$table_prefix}comments
									WHERE 
									(comment_approved = '0' OR comment_approved = '1' OR comment_approved = 'spam' OR comment_approved = 'trash')
									AND
									comment_date <= %s",
									$minus_3months_time
									)
					);
		//Log InUp Controller
		$spamkey = 'System';
		$remote_ip = 'localhost';
		$spamco = 'localhost';
		$spamcou = 'localhost';
		$remote_referer = 'localhost';
		$dest_url = 'localhost';
		$remote_agent = 'localhost';
		$current_user_id = 'localhost';
		$spamvalue = 'Clean-Up of old spam and trashed comments cron successfully run.';
		$SpamMasterLogController = new SpamMasterLogController;
		$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
	}
}

//Clean Up Firewall Logs
if($spam_master_logs_firewall_clean == '0'){
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old firewall logs cron did not run because it\'s set to infinite.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}
else{
	$minus_fire_months_time = date('Y-m-d h:i:s', strtotime("-".$spam_master_logs_firewall_clean." days", strtotime($current_time)));

	$wpdb->query( 
				$wpdb->prepare( 
								"DELETE FROM $table_keys
								WHERE spamkey = 'Firewall' AND time <= %s",
								$minus_fire_months_time
								)
				);
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old firewall logs cron successfully run.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}

//Clean Up Registration Logs
if($spam_master_logs_registration_clean == '0'){
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old registration logs cron did not run because it\'s set to infinite.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}
else{
	$minus_reg_months_time = date('Y-m-d h:i:s', strtotime("-".$spam_master_logs_registration_clean." days", strtotime($current_time)));
	
	$wpdb->query( 
				$wpdb->prepare( 
								"DELETE FROM $table_keys
								WHERE spamkey = 'Registration' AND time <= %s",
								$minus_reg_months_time
								)
				);
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old registration logs cron successfully run.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}
//Clean Up Comment Logs
if($spam_master_logs_comment_clean == '0'){
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old comment logs cron did not run because it\'s set to infinite.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}
else{
	$minus_com_months_time = date('Y-m-d h:i:s', strtotime("-".$spam_master_logs_comment_clean." days", strtotime($current_time)));
	$wpdb->query( 
				$wpdb->prepare( 
								"DELETE FROM $table_keys
								WHERE spamkey = 'Comment' AND time <= %s",
								$minus_com_months_time
								)
				);
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old comment logs cron successfully run.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}
//Clean Up Contact Form Logs
if($spam_master_logs_contact_form_7_clean == '0'){
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old contact form logs cron did not run because it\'s set to infinite.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}
else{
	$minus_con_months_time = date('Y-m-d h:i:s', strtotime("-".$spam_master_logs_contact_form_7_clean." days", strtotime($current_time)));
	$wpdb->query( 
				$wpdb->prepare( 
								"DELETE FROM $table_keys
								WHERE spamkey = 'Contact-Form' AND time <= %s",
								$minus_con_months_time
								)
				);
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old contact form logs cron successfully run.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}
//Clean Up Woocommerce Logs
if($spam_master_logs_woocommerce_clean == '0'){
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old woocommerce logs cron did not run because it\'s set to infinite.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}
else{
	$minus_woo_months_time = date('Y-m-d h:i:s', strtotime("-".$spam_master_logs_woocommerce_clean." days", strtotime($current_time)));
	$wpdb->query( 
				$wpdb->prepare( 
								"DELETE FROM $table_keys
								WHERE spamkey = 'Woocommerce' AND time <= %s",
								$minus_woo_months_time
								)
				);
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old woocommerce logs cron successfully run.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}
//Clean Up System Logs
if($spam_master_logs_system_clean == '0'){
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old system logs cron did not run because it\'s set to infinite.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}
else{
	$minus_sys_months_time = date('Y-m-d h:i:s', strtotime("-".$spam_master_logs_system_clean." days", strtotime($current_time)));
	$wpdb->query( 
				$wpdb->prepare( 
								"DELETE FROM $table_keys
								WHERE spamkey = 'System' AND time <= %s",
								$minus_sys_months_time
								)
				);
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old system logs cron successfully run.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}
//Clean Up Honeypot Logs
if($spam_master_logs_honeypot_clean == '0'){
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old honeypot logs cron did not run because it\'s set to infinite.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}
else{
	$minus_sys_months_time = date('Y-m-d h:i:s', strtotime("-".$spam_master_logs_honeypot_clean." days", strtotime($current_time)));
	$wpdb->query( 
				$wpdb->prepare( 
								"DELETE FROM $table_keys
								WHERE spamkey = 'Honeypot' AND time <= %s",
								$minus_sys_months_time
								)
				);
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old honeypot logs cron successfully run.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}
//Clean Up reCaptcha Logs
if($spam_master_logs_recaptcha_clean == '0'){
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old recaptcha logs cron did not run because it\'s set to infinite.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}
else{
	$minus_sys_months_time = date('Y-m-d h:i:s', strtotime("-".$spam_master_logs_recaptcha_clean." days", strtotime($current_time)));
	$wpdb->query( 
				$wpdb->prepare( 
								"DELETE FROM $table_keys
								WHERE spamkey = 'reCaptcha' AND time <= %s",
								$minus_sys_months_time
								)
				);
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old recaptcha logs cron successfully run.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}

//Delete all mock-up emails from threats
$spam_master_mock_emails = $wpdb->get_results(
							"SELECT id FROM $table_threats
							WHERE threat LIKE 'login_bot@%' OR threat LIKE 'registration@%' OR threat LIKE 'honey_bot@%' OR threat LIKE 'comment@%'"
							);	
//proceed if first result is not empty										
if(!empty($spam_master_mock_emails)){
	//Now lets delete id via foreach
	$count_delete_login_bot_ids = 0;
	foreach($spam_master_mock_emails as $id_to_delete){
		//get id's
		$id_delete = $id_to_delete->id;
		$spam_master_email_delete_now = $wpdb->delete( $table_threats, array(
										'id' => $id_delete,
										));
		$count_delete_login_bot_ids++;
	}
	//Log InUp Controller
	$spamkey = 'System';
	$remote_ip = 'localhost';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$remote_referer = 'localhost';
	$dest_url = 'localhost';
	$remote_agent = 'localhost';
	$current_user_id = 'localhost';
	$spamvalue = 'Clean-Up of old mock-up emails cron successfully run. Count: '.$count_delete_login_bot_ids;
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
}

//Need to make sure unstable notice is set to 0 to warn users
$spam_master_current_date = current_time('Y-m-d');
if($spam_master_current_date >= $spam_master_free_unstable && $spam_master_unstable_notice != '1'){
	if( is_multisite() ){
		update_blog_option($blog_id, 'spam_master_unstable_notice', '0');
	}
	else{
		update_option('spam_master_unstable_notice', '0');
	}
}

//Moving server entries from firewall
$spam_master_server_entries = $wpdb->get_results(
								"SELECT id FROM $table_keys
								WHERE spamkey = 'Firewall' AND LOCATE('WordPress/', spamagen)"
								);
//proceed if first result is not empty										
if(!empty($spam_master_server_entries)){
	foreach($spam_master_server_entries as $id_to_move){
		$move_now = $id_to_move->id;
		$data_system = [ 'spamkey' => 'System', 'spamvalue' => 'Scrapping Keys.'];
		$where_system = [ 'id' => $move_now ];
		$wpdb->update( $table_keys, $data_system, $where_system );
	}
}
?>
