<?php
global $wpdb, $blog_id;
//add message to wordpress in case theres no post message update
if( is_multisite() ){
	$spam_master_message = esc_html(get_blog_option( $blog_id, 'spam_master_message'));
}
else{
	$spam_master_message = esc_html(get_option('spam_master_message'));
}

//Remote Ip
$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
//Remote Agent
if(isset($_SERVER['HTTP_USER_AGENT'])){
	$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
}
else{
	$remote_agent = 'Sniffer';
}
// Remote Referer
if(isset($_SERVER['HTTP_REFERER'])){
	$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
}
else{
	$remote_referer = 'Direct';
}
// DEST URL
if(isset($_SERVER['REQUEST_URI'])){
	$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
}
else{
	$dest_url = 'Weird';
}
//exempt admins from check
if(!function_exists('wp_get_current_user')) {
	include(ABSPATH . "wp-includes/pluggable.php"); 
}
// Current User
$current_user_id = get_current_user_id();
if(isset($current_user_id)){
	$current_user_id = $current_user_id;
}
else{
	$current_user_id = 'none';
}

//POST Message
if (isset($_POST['update_message'])){
	check_admin_referer( 'save-settings_spam_master_message' );
	// Update Message
	if (isset($_POST['spam_master_message'])){
		if ($spam_master_message = sanitize_text_field($_POST['spam_master_message'])){
			if( is_multisite() ){
			update_blog_option($blog_id, 'spam_master_message', $spam_master_message);
			}
			else {
			update_option('spam_master_message', $spam_master_message);
			}
		}
		//Add Controllers
		require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
		//Log InUp Controller
		$spamkey = 'System';
		$spamco = 'localhost';
		$spamcou = 'localhost';
		$spamvalue = 'Settings: Spam Master Message successfully updated.';
		$SpamMasterLogController = new SpamMasterLogController;
		$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
	}
?>
<div id="message" class="updated fade">
<p><?php echo __('Message Saved & Refreshed', 'spam_master'); ?></p>
</div>
<?php
//end message post
}
?>
<div class="spam-master-pad-table"></div>
<form method="post" width='1'>
<fieldset class="options">
<?php $sec_nonce = wp_nonce_field( 'save-settings_spam_master_message' ); ?>
<table class="wp-list-table widefat fixed striped table-view-list" cellspacing="0">
	<thead>
		<tr>
			<th><h2><img class="spam-master-admin-img" src="<?php echo plugins_url('../images/spammaster-logo.png', dirname(__FILE__)); ?>" /><?php echo __('&nbsp;Edit Block Message', 'spam_master'); ?></h2></th>
		</tr>
	</thead>

	<tfoot>
		<tr>
			<th><button type="submit" name="update_message" id="update_message" class="btn-spammaster blue roundedspam" href="#" title="<?php echo __('Save & Refresh', 'spam_master'); ?>"><?php echo __('Save & Refresh', 'spam_master'); ?></button></th>
		</tr>
	</tfoot>

	<tbody>
		<tr class="alternate">
			<td class="spam-master-middle">
				<p><?php echo __('This message is displayed to users when they get blocked. Try to keep it short', 'spam_master'); ?>.</p>
			</td>
		</tr>
		<tr>
			<td class="spam-master-middle">
				<textarea class="spam-master-100" name='spam_master_message' rows='3'><?php echo $spam_master_message; ?></textarea>
			</td>
		</tr>
	</tbody>
</table>
</fieldset>
</form>
