<?php
if(!class_exists('WP_List_Table')){
	require_once( get_home_path() . 'wp-admin/includes/class-wp-list-table.php' );
}
class spam_master_admin_table_inactive extends WP_List_Table {
	/**
	 * Display the rows of records in the table
	 * @return string, echo the markup of the rows
	 */
function display() {
global $wpdb, $blog_id;

$plugin_master_name = constant('SPAM_MASTER_NAME');
$plugin_master_domain = constant('SPAM_MASTER_DOMAIN');
if(isset($_POST['generate_free_spam_master_license'])){
	//Remote Ip
	$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
	//Remote Agent
	if(isset($_SERVER['HTTP_USER_AGENT'])){
		$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
	}
	else{
		$remote_agent = 'Sniffer';
	}
	// Remote Referer
	if(isset($_SERVER['HTTP_REFERER'])){
		$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
	}
	else{
		$remote_referer = 'Direct';
	}
	// DEST URL
	if(isset($_SERVER['REQUEST_URI'])){
		$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
	}
	else{
		$dest_url = 'Weird';
	}
	//exempt admins from check
	if(!function_exists('wp_get_current_user')) {
		include(ABSPATH . "wp-includes/pluggable.php"); 
	}
	// Current User
	$current_user_id = get_current_user_id();
	if(isset($current_user_id)){
		$current_user_id = $current_user_id;
	}
	else{
		$current_user_id = 'none';
	}
	//Add Controllers
	require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
	check_admin_referer( 'save-settings_generate_free_spam_master_license' );
	$spam_master_cron = "AUT";
	//Log InUp Controller
	$spamkey = 'System';
	$spamco = 'localhost';
	$spamcou = 'localhost';
	$spamvalue = 'Settings: Free License Auto Generated.';
	$SpamMasterLogController = new SpamMasterLogController;
	$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
	$platform = "Wordpress";
	$spam_master_version = constant('SPAM_MASTER_VERSION');
	$spam_master_type_set = "FREE";
	//create lic hash
	$spam_master_lic_hash = substr(md5(uniqid(mt_rand(), true)),0,64);
	if(empty($spam_master_lic_hash)){
		$spam_master_lic_hash = 'md5-'.date('YmdHis');
	}
	$web_address = get_site_url();
	$address_unclean = $web_address;
	$address_long = preg_replace('#^https?://#', '', $address_unclean);
	$address = substr($address_long,0,256);
	@$spam_master_server_ip = substr($_SERVER['SERVER_ADDR'],0,48);
	if(empty($spam_master_server_ip) || $spam_master_server_ip == '0'){
		@$spam_master_server_ip = substr('I '.gethostbyname($_SERVER['SERVER_NAME']),0,48);
	}
	@$spam_master_server_hostname = substr(gethostbyaddr($_SERVER['SERVER_ADDR']),0,256);
	if(empty($spam_master_server_hostname) || $spam_master_server_hostname == '0'){
		@$spam_master_server_hostname = substr('H '.gethostbyname($_SERVER['SERVER_NAME']),0,256);
	}
	$spam_master_alert_level_date_set = date('Y-m-d H:i:s');
	$spam_my_nounce = 'PW9pdXNkbmVXMndzUw==';
	if( is_multisite() ){
		update_blog_option($blog_id, 'spam_license_key', $spam_master_lic_hash);
		$wordpress = substr(get_bloginfo('version'),0,12);
		$spam_master_multisite = "YES";
		$spam_master_multisite_number = get_blog_count();
		$spam_master_multisite_joined = substr($spam_master_multisite . ' - ' . $spam_master_multisite_number,0,11);
		$blog = substr(get_blog_option($blog_id, 'blogname'),0,256);
		if(empty($blog)){
			$blog = 'Wp multi';
		}
		$admin_email = substr(get_blog_option($blog_id, 'admin_email'),0,128);
		if(empty($admin_email)){
			$admin_email = 'weird-no-email@'.date('YmdHis').'.wp';
		}
	}
	else{
		update_option('spam_license_key', $spam_master_lic_hash);
		$wordpress = substr(get_bloginfo('version'),0,12);
		$spam_master_multisite = "NO";
		$spam_master_multisite_number = "0";
		$spam_master_multisite_joined = substr($spam_master_multisite . ' - ' . $spam_master_multisite_number,0,11);
		$blog = substr(get_option('blogname'),0,256);
		if(empty($blog)){
			$blog = 'Wp single';
		}
		$admin_email = substr(get_option('admin_email'),0,128);
		if(empty($admin_email)){
			$admin_email = 'weird-no-email@'.date('YmdHis').'.wp';
		}
	}
	//remote post and response
	$spam_master_license_post = array(
										'spam_license_key' => $spam_master_lic_hash,
										'spam_trial_nounce' => $spam_my_nounce,
										'platform' => $platform,
										'platform_version' => $wordpress,
										'platform_type' => $spam_master_multisite_joined,
										'spam_master_version' => $spam_master_version,
										'spam_master_type' => $spam_master_type_set,
										'blog_name' => $blog,
										'blog_address' => $address,
										'blog_email' => $admin_email,
										'blog_hostname' => $spam_master_server_hostname,
										'blog_ip' => $spam_master_server_ip,
										'spam_master_cron' => $spam_master_cron
	);
	$spam_master_license_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGljZW5zZS9saWNfdHJpYWwucGhw';
	$response = wp_remote_post( base64_decode($spam_master_license_url), array(
																				'method' => 'POST',
																				'timeout' => 90,
																				'body' => $spam_master_license_post
	));
	if ( is_wp_error( $response ) ) {
		$error_message = $response->get_error_message();
		//Log InUp Controller
		$spamkey = 'System';
		$spamco = 'localhost';
		$spamcou = 'localhost';
		$spamvalue = 'Error: Auto Generate Free License. '.$error_message.'';
		$SpamMasterLogController = new SpamMasterLogController;
		$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
		echo "Something went wrong, please get in touch with TechGasp Support with error: $error_message";
	}
	else {
		$data = json_decode( wp_remote_retrieve_body( $response ), true );
		if(empty($data)){
			$spam_master_type = 'EMPTY';
			$spam_master_status = 'INACTIVE';
			$response_key = $spam_master_status;
			$spam_master_attached = 'EMPTY';
			$spam_master_expires = 'EMPTY';
			$spam_master_protection_total_number = '0';
			$spam_master_alert_level = '';
			$spam_master_alert_level_date = '';
			$spam_master_alert_level_p_text = '';
			if( is_multisite() ){
				update_blog_option($blog_id, 'spam_master_type', $spam_master_type);
				update_blog_option($blog_id, 'spam_master_status', $spam_master_status);
				update_blog_option($blog_id, 'spam_master_attached', $spam_master_attached);
				update_blog_option($blog_id, 'spam_master_expires', $spam_master_expires);
				update_blog_option($blog_id, 'spam_master_protection_total_number', $spam_master_protection_total_number);
				update_blog_option($blog_id, 'spam_master_alert_level', $spam_master_alert_level);
				update_blog_option($blog_id, 'spam_master_alert_level_date', $spam_master_alert_level_date);
				update_blog_option($blog_id, 'spam_master_alert_level_p_text', $spam_master_alert_level_p_text);
			}
			else{
				update_option('spam_master_type', $spam_master_type);
				update_option('spam_master_status', $spam_master_status);
				update_option('spam_master_attached', $spam_master_attached);
				update_option('spam_master_expires', $spam_master_expires);
				update_option('spam_master_protection_total_number', $spam_master_protection_total_number);
				update_option('spam_master_alert_level', $spam_master_alert_level);
				update_option('spam_master_alert_level_date', $spam_master_alert_level_date);
				update_option('spam_master_alert_level_p_text', $spam_master_alert_level_p_text);
			}
		}
		else{
			$spam_master_type = $data['type'];
			$spam_master_status = $data['status'];
			$response_key = $spam_master_status;
			$spam_master_attached = $data['attached'];
			$spam_master_expires = $data['expires'];
			$spam_master_protection_total_number = $data['threats'];
			$spam_master_alert_level = $data['alert'];
			$spam_master_alert_level_date = $spam_master_alert_level_date_set;
			$spam_master_alert_level_p_text = $data['percent'];
			if( is_multisite() ){
				update_blog_option( $blog_id, 'spam_master_type', $spam_master_type);
				update_blog_option( $blog_id, 'spam_master_status', $spam_master_status);
				update_blog_option($blog_id, 'spam_master_attached', $spam_master_attached);
				update_blog_option($blog_id, 'spam_master_expires', $spam_master_expires);
				update_blog_option( $blog_id, 'spam_master_protection_total_number', $spam_master_protection_total_number);
				update_blog_option($blog_id, 'spam_master_alert_level', $spam_master_alert_level);
				update_blog_option($blog_id, 'spam_master_alert_level_date', $spam_master_alert_level_date);
				update_blog_option($blog_id, 'spam_master_alert_level_p_text', $spam_master_alert_level_p_text);
			}
			else{
				update_option('spam_master_type', $spam_master_type);
				update_option('spam_master_status', $spam_master_status);
				update_option('spam_master_attached', $spam_master_attached);
				update_option('spam_master_expires', $spam_master_expires);
				update_option('spam_master_protection_total_number', $spam_master_protection_total_number);
				update_option('spam_master_alert_level', $spam_master_alert_level);
				update_option('spam_master_alert_level_date', $spam_master_alert_level_date);
				update_option('spam_master_alert_level_p_text', $spam_master_alert_level_p_text);
			}
			require_once(plugin_dir_path( __FILE__ ) . '../emails/spam-master-admin-emails-mail-auto-free.php');
		}
	}
?>
<div id="message" class="updated fade">
<p><?php _e('Congratulations! Automatic License Generated. Please wait refreshing...', 'spam_master'); ?></p>
</div>
<?php
echo '<META HTTP-EQUIV="REFRESH" CONTENT="3">';
}
?>
<table class="wp-list-table widefat fixed striped table-view-list" cellspacing="0">
	<thead>
		<tr>
			<th colspan="3"><!-- <img src="<?php echo plugins_url('../images/spammaster-wp-plugin-internal-banner.jpg', dirname(__FILE__)); ?>" alt="<?php echo $plugin_master_name; ?>" align="left" width="100%" />--></th>
		</tr>
	</thead>

	<tbody>
		<tr>
			<td class="spam-master-text-center" colspan="3">
<h2><?php echo __('Spam Master munches, feeds and grows on spam ip’s, emails, domains and words. Join one of the top 5 world-wide, real-time online spam checking databases', 'spam_master'); ?> <a href="https://www.spammaster.org" target="_blank" title="<?php echo $plugin_master_domain; ?>"><?php echo $plugin_master_domain; ?></a>.</h2>
			</td>
		</tr>
		<tr class="alternate">
			<td></td>
			<td class="spam-master-text-jcenter">
				<div>
					<div style="display: inline-block;">
						<form method="post" id="generate_free_spam_master_license" width="1">
							<fieldset class="options">
								<?php $sec_nonce = wp_nonce_field( 'save-settings_generate_free_spam_master_license' ); ?>
								<div class="spam-master-card spam-master-free-card">
									<div class="spam-master-overlay"></div>
									<div class="spam-master-circle">
										<span class="dashicons dashicons-database spam-master-admin-f70y"></span>
									</div>
									<p><?php echo __('Free Server Cluster', 'spam_master'); ?></p>
									<p><?php echo __('Free RBL Server Connection', 'spam_master'); ?></p>
									<p><?php echo __('Auto Generates License', 'spam_master'); ?></p>
									<p><span class="dashicons dashicons-admin-post"></span> <?php echo __('Full Functionality', 'spam_master'); ?></p>
									<p><button type="submit" name="generate_free_spam_master_license" id="generate_free_spam_master_license" href="#" class="btn-spammaster orange roundedspam"><?php echo __('Generate Free License', 'spam_master'); ?></button></p>
								</div>
							</fieldset>
						</form>
					</div>
					<div style="display: inline-block;">
						<div class="spam-master-card spam-master-pro-card">
							<div class="spam-master-overlay"></div>
							<div class="spam-master-circle">
								<span class="dashicons dashicons-database-add spam-master-admin-f70g"></span>
							</div>
							<p><?php echo __('Business Server Cluster', 'spam_master'); ?></p>
							<p><?php echo __('Premium RBL Server Connection', 'spam_master'); ?></p>
							<p><?php echo __('24/7 Support', 'spam_master'); ?></p>
							<p><span class="dashicons dashicons-admin-post"></span> <?php echo __('Full Functionality', 'spam_master'); ?></p>
							<p><a href="https://www.techgasp.com/downloads/spam-master-license/" target="_blank" class="btn-spammaster green roundedspam"><?php echo __('Buy Pro License', 'spam_master'); ?></a></p>
						</div>
					</div>
				</div>
			</td>
			<td></td>
		</tr>
	</tbody>
</table>
<div class="spam-master-pad-table"></div>
<?php
		}
}
