<?php
global $wpdb, $blog_id;

if( is_multisite() ){
	$blogs = $wpdb->get_col( "SELECT blog_id FROM $wpdb->blogs;" );
	foreach ( $blogs as $id ) {
		$table_keys_trunc = $wpdb->get_blog_prefix($id)."spam_master_keys";
		$wpdb->query("TRUNCATE TABLE $table_keys_trunc");
		$table_threats_trunc = $wpdb->get_blog_prefix($id)."spam_master_threats";
		$wpdb->query("TRUNCATE TABLE $table_threats_trunc");
		$table_white_trunc = $wpdb->get_blog_prefix($id)."spam_master_white";
		$wpdb->query("TRUNCATE TABLE $table_white_trunc");
		//Are integrations present?
		if ( is_plugin_active( 'contact-form-7/wp-contact-form-7.php' ) ) {
			update_blog_option($id, 'spam_master_integrations_contact_form_7', 'true' );
		}
		if ( is_plugin_active( 'woocommerce/woocommerce.php' ) ) {
			update_blog_option($id, 'spam_master_integrations_woocommerce', 'true' );
		}
		$table_threats = $wpdb->get_blog_prefix($id)."spam_master_threats";
		update_blog_option($id, 'spam_master_upgrade_to_6_3_2', '1');
	}
}
else{
	$table_keys_trunc = $wpdb->prefix."spam_master_keys";
	$wpdb->query("TRUNCATE TABLE $table_keys_trunc");
	$table_threats_trunc = $wpdb->prefix."spam_master_threats";
	$wpdb->query("TRUNCATE TABLE $table_threats_trunc");
	$table_white_trunc = $wpdb->prefix."spam_master_white";
	$wpdb->query("TRUNCATE TABLE $table_white_trunc");
	//Are integrations present?
	if ( is_plugin_active( 'contact-form-7/wp-contact-form-7.php' ) ) {
		update_option('spam_master_integrations_contact_form_7', 'true' );
	}
	if ( is_plugin_active( 'woocommerce/woocommerce.php' ) ) {
		update_option('spam_master_integrations_woocommerce', 'true' );
	}
	$table_threats = $wpdb->prefix."spam_master_threats";
	update_option('spam_master_upgrade_to_6_3_2', '1');
}
//Add Controllers
require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterBufferController.php');
require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
//Test Controllers with test data 1
//Spam Buffer Controller
$SpamMasterBufferController = new SpamMasterBufferController;
$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();
//Log InUp Controller
$spamkey = 'Firewall';
$remote_ip = '78.29.33.111';
$spamco = 'RU';
$spamcou = 'Russia';
$remote_referer = 'Direct';
$dest_url = 'localhost';
$remote_agent = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/85.0.4183.121 Safari/537.36';
$current_user_id = 'none';
$spamvalue = 'Firewall Trigger Blocked in Spam Buffer. Email: inflow1980@mail.ru';
$SpamMasterLogController = new SpamMasterLogController;
$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
$wpdb->insert( $table_threats, array( 'time' => current_time( 'mysql' ), 'threat' => '78.29.33.111', 'spamco' => 'RU', 'spamcou' => 'Russia' ));
$wpdb->insert( $table_threats, array( 'time' => current_time( 'mysql' ), 'threat' => 'inflow1980@mail.ru', 'spamco' => 'email', 'spamcou' => 'Email' ));

//Test Controllers with test data 2
//Log InUp Controller
$spamkey = 'Firewall';
$remote_ip = '75.41.125.42';
$spamco = 'US';
$spamcou = 'United States';
$remote_referer = 'Direct';
$dest_url = 'localhost';
$remote_agent = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/87.0.4280.88 Safari/537.36';
$current_user_id = 'none';
$spamvalue = 'Firewall Trigger Approved in Spam Buffer.';
$SpamMasterLogController = new SpamMasterLogController;
$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

//Test Controllers with test data 3
//Spam Buffer Controller
$SpamMasterBufferController = new SpamMasterBufferController;
$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();
//Log InUp Controller
$spamkey = 'Firewall';
$remote_ip = '14.126.206.171';
$spamco = 'CN';
$spamcou = 'China';
$remote_referer = 'Direct';
$dest_url = 'localhost';
$remote_agent = 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)';
$current_user_id = 'none';
$spamvalue = 'Firewall Trigger Blocked in Spam Buffer.';
$SpamMasterLogController = new SpamMasterLogController;
$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
$wpdb->insert( $table_threats, array( 'time' => current_time( 'mysql' ), 'threat' => '14.126.206.171', 'spamco' => 'CN', 'spamcou' => 'China' ));

//Log InUp Controller
$spamkey = 'System';
$remote_ip = 'localhost';
$spamco = 'localhost';
$spamcou = 'localhost';
$remote_referer = 'localhost';
$dest_url = 'localhost';
$remote_agent = 'localhost';
$current_user_id = 'localhost';
$spamvalue = 'Plugin Activation successfully run to version 6.3.2. Database Improved, Cleaned & Synchronized. Logging Resumed.';
$SpamMasterLogController = new SpamMasterLogController;
$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
?>
