<?php
global $wpdb, $blog_id;
if(is_multisite()){
	//Firewall delete expired transients
	$sql_firewall_transients_timeout = "delete from t1, t2
										using {$wpdb->sitemeta} t1
										join {$wpdb->sitemeta} t2 on t2.meta_key = replace(t1.meta_key, '_timeout', '')
										where (t1.meta_key like '\_transient\_timeout\_spam_master_firewall_ip%' or t1.meta_key like '\_site\_transient\_timeout\_spam_master_firewall_ip%');";
	$wpdb->query($sql_firewall_transients_timeout);

	$sql_firewall_transients = "delete from {$wpdb->sitemeta}
								where (
								meta_key like '\_transient\_timeout\_spam_master_firewall_ip%'
								or meta_key like '\_site\_transient\_timeout\_spam_master_firewall_ip%');";
	$wpdb->query($sql_firewall_transients);

	//Invalid delete expired transients
	$sql_invalid_transients_timeout = "delete from t1, t2
										using {$wpdb->sitemeta} t1
										join {$wpdb->sitemeta} t2 on t2.meta_key = replace(t1.meta_key, '_timeout', '')
										where (t1.meta_key like '\_transient\_timeout\_spam_master_invalid_email%' or t1.meta_key like '\_site\_transient\_timeout\_spam_master_invalid_email%');";
	$wpdb->query($sql_invalid_transients_timeout);

	$sql_invalid_transients = "delete from {$wpdb->sitemeta}
								where (
								meta_key like '\_transient\_timeout\_spam_master_invalid_email%'
								or meta_key like '\_site\_transient\_timeout\_spam_master_invalid_email%');";
	$wpdb->query($sql_invalid_transients);

	//R-check tables
	$blogs = $wpdb->get_col( "SELECT blog_id FROM $wpdb->blogs;" );
	$spam_master_db_version = "1.0";
	$charset_collate = $wpdb->get_charset_collate();
	foreach ( $blogs as $id ) {
		//Delete Blacklist
		@delete_blog_option($id, 'blacklist_keys');
		delete_blog_option($id, 'blacklist_keys_bk');
		//Replace White List in DB
		$spam_master_whitelist = get_blog_option($id, 'spam_master_whitelist');
		if(!empty($spam_master_array_whitelist)){
			$spam_master_array_whitelist = array_merge(explode(" ", $spam_master_whitelist));
			$table_white_insert = $wpdb->get_blog_prefix($id)."spam_master_white";
			foreach($spam_master_array_whitelist as $threat){
				$wpdb->replace( $table_white_insert, array( 'time' => current_time( 'mysql' ), 'white' => $threat ));
			}
		}
		//Delete White List
		delete_blog_option($id, 'spam_master_whitelist');
		update_blog_option($id, 'spam_master_upgrade_to_6', '1');
	}
}
else{
	//Firewall delete expired transients
	$sql_firewall_transients_timeout = "delete from t1, t2
										using {$wpdb->options} t1
										join {$wpdb->options} t2 on t2.option_name = replace(t1.option_name, '_timeout', '')
										where (t1.option_name like '\_transient\_timeout\_spam_master_firewall_ip%' or t1.option_name like '\_site\_transient\_timeout\_spam_master_firewall_ip%');";
	$wpdb->query($sql_firewall_transients_timeout);

	$sql_firewall_transients = "delete from {$wpdb->options}
								where (
								option_name like '\_transient\_timeout\_spam_master_firewall_ip%'
								or option_name like '\_site\_transient\_timeout\_spam_master_firewall_ip%');";
	$wpdb->query($sql_firewall_transients);

	//Invalid delete expired transients
	$sql_invalid_transients_timeout = "delete from t1, t2
										using {$wpdb->options} t1
										join {$wpdb->options} t2 on t2.option_name = replace(t1.option_name, '_timeout', '')
										where (t1.option_name like '\_transient\_timeout\_spam_master_invalid_email%' or t1.option_name like '\_site\_transient\_timeout\_spam_master_invalid_email%');";
	$wpdb->query($sql_invalid_transients_timeout);

	$sql_invalid_transients = "delete from {$wpdb->options}
								where (
								option_name like '\_transient\_timeout\_spam_master_invalid_email%'
								or option_name like '\_site\_transient\_timeout\_spam_master_invalid_email%');";
	$wpdb->query($sql_invalid_transients);

	//Delete Blacklist
	@delete_option('blacklist_keys');
	delete_option('blacklist_keys_bk');
	//Replace White List in DB
	$spam_master_whitelist = get_option('spam_master_whitelist');
	if(!empty($spam_master_array_whitelist)){
		$spam_master_array_whitelist = array_merge(explode(" ", $spam_master_whitelist));
		$table_white = $wpdb->prefix."spam_master_white";
		foreach($spam_master_array_whitelist as $threat){
			$wpdb->replace( $table_white, 
									array( 'time' => current_time( 'mysql' ), 'white' => $threat ) 
						);
		}
	}
	//Delete White List
	delete_option('spam_master_whitelist');
	update_option('spam_master_upgrade_to_6', '1');
}
//Add Controllers
require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
//Log InUp Controller
$spamkey = 'System';
$remote_ip = 'localhost';
$spamco = 'localhost';
$spamcou = 'localhost';
$remote_referer = 'localhost';
$dest_url = 'localhost';
$remote_agent = 'localhost';
$current_user_id = 'localhost';
$spamvalue = 'Plugin Activation successfully run to version 6.0.';
$SpamMasterLogController = new SpamMasterLogController;
$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
?>
