<?php
class SpamMasterBufferController {

	protected $remote_ip;
	protected $blog_threat_email;
	protected $spamco;
	protected $spamcou;

	public function SpamMasterBufferSearch($remote_ip, $blog_threat_email) {
		global $wpdb, $blog_id;

		if( is_multisite() ){
			$response_key = get_blog_option($blog_id, 'spam_master_status');
			$table_threats = $wpdb->get_blog_prefix($blog_id)."spam_master_threats";
		}
		else{
			$response_key = get_option('spam_master_status');
			$table_threats = $wpdb->prefix."spam_master_threats";
		}

		if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
			if(!empty($remote_ip)){
				$is_buffer_threat = $wpdb->get_results(
										$wpdb->prepare( 
														"SELECT threat 
														FROM $table_threats
														WHERE threat = %s", 
														$remote_ip
				));
				if(!empty($is_buffer_threat)){
					return "BUFFER";
				}
			}
			if(!empty($blog_threat_email)){
				$is_buffer_threat = $wpdb->get_results(
										$wpdb->prepare( 
														"SELECT threat 
														FROM $table_threats
														WHERE threat = %s", 
														$blog_threat_email
				));
				if(!empty($is_buffer_threat)){
					return "BUFFER";
				}
			}
		}
	}

	public function SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou) {
		global $wpdb, $blog_id;

		if( is_multisite() ){
			$response_key = get_blog_option($blog_id, 'spam_master_status');
			$table_threats = $wpdb->get_blog_prefix($blog_id)."spam_master_threats";
		}
		else{
			$response_key = get_option('spam_master_status');
			$table_threats = $wpdb->prefix."spam_master_threats";
		}
		
		if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
			if(!empty($remote_ip)){
				$wpdb->insert( $table_threats, array( 'time' => current_time( 'mysql' ), 'threat' => $remote_ip, 'spamco' => $spamco, 'spamcou' => $spamcou ));
			}
			if(!empty($blog_threat_email)){
				$wpdb->insert( $table_threats, array( 'time' => current_time( 'mysql' ), 'threat' => $blog_threat_email, 'spamco' => $spamco, 'spamcou' => $spamcou ));
			}
		}
	}

	public function SpamMasterBufferCount() {
		global $wpdb, $blog_id;

		if( is_multisite() ){
			$table_prefix = $wpdb->get_blog_prefix($blog_id);
		}
		else{
			$table_prefix = $wpdb->base_prefix;
		}

		$count = $wpdb->query("UPDATE {$table_prefix}options SET option_value=option_value + 1 WHERE option_name='spam_master_block_count'");
	}

}
?>
