<?php
class SpamMasterFloodController {

	protected $spamkey;
	protected $remote_ip;

	public function SpamMasterAlert3($spamkey) {
		global $wpdb, $blog_id;

		if( is_multisite() ){
			$response_key = get_blog_option($blog_id, 'spam_master_status');
			$table_keys = $wpdb->get_blog_prefix($blog_id)."spam_master_keys";
		}
		else{
			$response_key = get_option('spam_master_status');
			$table_keys = $wpdb->prefix."spam_master_keys";
		}

		if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
			$spam_master_last_honey =  $wpdb->get_var(
											$wpdb->prepare( 
															"SELECT time FROM $table_keys WHERE spamkey = %s ORDER BY time DESC LIMIT 1",
															$spamkey
			));

			$flood_date_plus_3 = date('Y-m-d H:i:s', strtotime($spam_master_last_honey . '+ 3 minute'));
			$flood_date = current_time('mysql');

			if($flood_date_plus_3 >= $flood_date){
				return "ALERT_3";
			}
		}
	}

	public function SpamMasterFlood($spamkey, $remote_ip) {
		global $wpdb, $blog_id;

		if( is_multisite() ){
			$response_key = get_blog_option($blog_id, 'spam_master_status');
			$table_keys = $wpdb->get_blog_prefix($blog_id)."spam_master_keys";
		}
		else{
			$response_key = get_option('spam_master_status');
			$table_keys = $wpdb->prefix."spam_master_keys";
		}

		if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
			$is_count =  $wpdb->get_var(
										$wpdb->prepare( 
														"SELECT COUNT(*) FROM $table_keys WHERE spamkey = %s AND spamip = %s AND time > DATE_SUB(NOW(), INTERVAL 1 MINUTE)",
														$spamkey, $remote_ip
			));

			if($is_count >= '50'){
				return $is_count;
			}
		}
	}

}
?>
