<?php
add_action( 'wp_loaded', 'spam_master_full_notice' );
function spam_master_full_notice(){
global $wpdb, $blog_id;

	//Add Controllers
	require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
	if( is_multisite() ){
		$admin_email = get_blog_option($blog_id, 'admin_email');
		$blogname = get_blog_option($blog_id, 'blogname');
		if(empty($blogname)){
			$blogname = 'your blog';
		}
		$spam_master_emails_extra_email = get_blog_option($blog_id, 'spam_master_emails_extra_email');
		$spam_master_emails_extra_email_list = get_blog_option($blog_id, 'spam_master_emails_extra_email_list');
		$spam_master_expires = get_blog_option($blog_id, 'spam_master_expires');
		$spam_master_free_notice = get_blog_option($blog_id, 'spam_master_free_notice');
		$spam_master_attached = get_blog_option($blog_id, 'spam_master_attached');
	}
	else{
		$admin_email = get_option('admin_email');
		$blogname = get_option('blogname');
		if(empty($blogname)){
			$blogname = 'your blog';
		}
		$spam_master_emails_extra_email = get_option('spam_master_emails_extra_email');
		$spam_master_emails_extra_email_list = get_option('spam_master_emails_extra_email_list');
		$spam_master_expires = get_option('spam_master_expires');
		$spam_master_free_notice = get_option('spam_master_free_notice');
		$spam_master_attached = get_option('spam_master_attached');
	}

	//Get date
	$spam_master_emails_current_date = current_time('Y-m-d');
	//Plus 7 Days
	$spam_master_expires_plus_7 = date('Y-m-d', strtotime('+7 days', strtotime($spam_master_expires)) );
	//Check Notice
	if($spam_master_emails_current_date >= $spam_master_expires_plus_7 && $spam_master_free_notice != '1'){
		if( is_multisite() ){
			update_blog_option($blog_id, 'spam_master_free_notice', '1');
		}
		else{
			update_option('spam_master_free_notice', '1');
		}

		//get extra emails
		if($spam_master_emails_extra_email == 'true'){
			if(!empty($spam_master_emails_extra_email_list)){
				$spam_master_more_emails = ','.$spam_master_emails_extra_email_list;
			}
			else{
				$spam_master_more_emails = '';
			}
		}
		else{
			$spam_master_more_emails = '';
		}
		//get attached
		if(!empty($spam_master_attached)){
			if ($spam_master_attached == $admin_email){
				$spam_master_attached_add = '';
			}
			else{
				$spam_master_attached_add = ','.$spam_master_attached;
			}
		}
		else{
			$spam_master_attached_add = '';
		}

		//email user
		//set mail html
		add_filter( 'wp_mail_content_type', 'spam_master_send_user_notice_full_html' );
		function spam_master_send_user_notice_full_html() {
			return 'text/html';
		}
		//Email Subject Title Header
		$spam_master_subject_title = 'Thank You!!!';
		$spam_master_html = '<!DOCTYPE html><html>';
		$spam_master_header = '<head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /><title>'.$spam_master_subject_title.'</title></head>';
		$spam_master_body = '<body leftmargin="0" marginwidth="0" topmargin="0" marginheight="0" offset="0" style="background-color: #f6f6f6; font-family: &apos;Helvetica Neue&apos;, Helvetica, Arial, &apos;Lucida Grande&apos;, sans-serif;">';
		$spam_master_table_header = '<div style="width:100%; -webkit-text-size-adjust:none !important; margin:0; padding: 70px 0 70px 0;">
<table border="0" cellpadding="0" cellspacing="0" height="100%" width="100%">
<tr>
<td align="center" valign="top">
<table border="0" cellpadding="0" cellspacing="0" width="520" id="template_container" style="box-shadow:0 0 0 1px #f3f3f3 !important; border-radius:3px !important; background-color: #ffffff; border: 1px solid #e9e9e9; border-radius:3px !important; padding: 20px;">
<tr>
<td align="center" valign="top">
<table border="0" cellpadding="0" cellspacing="0" width="520" id="template_header" style=" color: #00000; border-top-left-radius:3px !important; border-top-right-radius:3px !important; border-bottom: 0; font-weight:bold; line-height:100%; text-align: center; vertical-align:middle;" bgcolor="#ffffff">
<tr>
<td>
<h1 style="color: #000000; margin:0; padding: 28px 24px; display:block; font-family: &apos;Helvetica Neue&apos;, Helvetica, Arial, &apos;Lucida Grande&apos;, sans-serif; font-size:32px; font-weight: 500; line-height: 1.2;">
'.$spam_master_subject_title.'
</h1></td></tr></table></td></tr>';
$spam_master_table_body = '<tr>
<td align="center" valign="top">
<table border="0" cellpadding="0" cellspacing="0" width="520" id="template_body">
<tr>
<td valign="top" style="border-radius:3px !important; font-family: &apos;Helvetica Neue&apos;, Helvetica, Arial, &apos;Lucida Grande&apos;, sans-serif;">
<table border="0" cellpadding="20" cellspacing="0" width="100%">
<tr>
<td valign="top">
<div style="color: #000000; font-size:14px; font-family: &apos;Helvetica Neue&apos;, Helvetica, Arial, &apos;Lucida Grande&apos;, sans-serif; line-height:150%; text-align:left;">';
//Email Content
$spam_master_table_content = '<p>Thank you for using Spam Master in '.$blogname.', for 7 days now. Spam Master is one of the highest rated and safest wordpress protection plugins with millions of threats listed in real time blocklist databases... growing daily.</p>
<p>This service is provided totally <strong>FREE</strong>, if you have a few minutes, please share the love on wordpress.org and rate us:</p>
<ul>
<li><a href="https://www.wordpress.org/plugins/spam-master/" target="_blank">share the love on WordPress.org</a></li>
</ul>
<p>This is a one time email, Thank you very much.</p>
<p>SpamMaster Team</p>';
$spam_master_table_content_close = '</div>
</td>
</tr>
</table>
</td>
</tr>
</table>
</td>
</tr>';
$spam_master_table_footer_start = '<tr>
<td align="center" valign="top">
<table border="0" cellpadding="10" cellspacing="0" width="600" id="template_footer" style="border-top:0; -webkit-border-radius:3px;">
<tr>
<td valign="top">
<table border="0" cellpadding="10" cellspacing="0" width="100%">
<tr>
<td colspan="2" valign="middle" id="credit" style="border:0; color: #000000; font-family: &apos;Helvetica Neue&apos;, Helvetica, Arial, &apos;Lucida Grande&apos;, sans-serif; font-size:14px; line-height:125%; text-align:center;">';
$spam_master_table_footer_content = '<p><a href="https://www.wordpress.org/plugins/spam-master/" target="_blank">Share the love, please rate us on WordPress.org</a></p>';
$spam_master_email_close = '</td>
</tr>
</table>
</td>
</tr>
</table>
</td>
</tr>
</table>
</td>
</tr>
</table>
</div>
</body>
</html>';
		//send email
		$from = $admin_email;
		$to = $admin_email.$spam_master_more_emails.$spam_master_attached_add;
		$subject = $spam_master_subject_title;
		$headers = array ('From' => $from, 'To' => $to, 'Subject' => $subject);
		$message = $spam_master_html.
					$spam_master_header.
					$spam_master_body.
					$spam_master_table_header.
					$spam_master_table_body.
					$spam_master_table_content.
					$spam_master_table_content_close.
					$spam_master_table_footer_start.
					$spam_master_table_footer_content.
					$spam_master_email_close;
		wp_mail( $to, $subject, $message, $headers );
		// Reset content-type to avoid conflicts
		remove_filter( 'wp_mail_content_type', 'spam_master_send_user_notice_full_html' );

		//Log InUp Controller
		$spamkey = 'System';
		$remote_ip = 'localhost';
		$spamco = 'localhost';
		$spamcou = 'localhost';
		$remote_referer = 'localhost';
		$dest_url = 'localhost';
		$remote_agent = 'localhost';
		$current_user_id = 'localhost';
		$spamvalue = 'Report: License email thank you successfully sent.';
		$SpamMasterLogController = new SpamMasterLogController;
		$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
	}
}
?>
