<?php
if(!class_exists('WP_List_Table')){
	require_once( get_home_path() . 'wp-admin/includes/class-wp-list-table.php' );
}
class spam_master_firewall_table_blocked extends WP_List_Table {
	/**
	 * Constructor, we override the parent to pass our own arguments
	 * We usually focus on three parameters: singular and plural labels, as well as whether the class supports AJAX.
	 */
	 function __construct() {
		 parent::__construct( array(
		'singular'=> 'singular_form', //Singular label
		'plural' => 'plural_form', //plural label, also this well be one of the table css class
		'ajax'	=> false //We won't support Ajax for this table
		) );
	 }

	/**
	 * Define the columns that are going to be used in the table
	 * @return array $columns, the array of columns to use with the table
	 */
	function get_columns() {
		if (!isset($_REQUEST['s'])) {
			$columns = array(
							'col_firewall_result' => __('Firewall'),
							'col_firewall_time' => __('Date'),
							'col_firewall_ip' => __('Ip'),
							'col_firewall_co' => __('Country'),
							'col_firewall_count' => __('Inspect <span class="dashicons dashicons-arrow-down-alt"></span>'),
							'col_firewall_refe' => __('From'),
							'col_firewall_dest' => __('To'),
							'col_firewall_agen' => __('Agent'),
							'col_firewall_user' => __('User'),
							'col_firewall_value' => __('Details'),
							'col_firewall_block' => __('Block?'),
							'col_firewall_white' => __('White?'),
			);
			return $columns;
		}
		else{
			$columns = array(
							'col_firewall_result' => __('Firewall'),
							'col_firewall_time' => __('Date'),
							'col_firewall_ip' => __('Ip'),
							'col_firewall_co' => __('Country'),
							'col_firewall_refe' => __('From'),
							'col_firewall_dest' => __('To'),
							'col_firewall_agen' => __('Agent'),
							'col_firewall_user' => __('User'),
							'col_firewall_value' => __('Details'),
			);
			return $columns;
		}
	}

	public function get_hidden_columns(){
		// Setup Hidden columns and return them
		return array();
	}
	/**
	 * Decide which columns to activate the sorting functionality on
	 * @return array $sortable, the array of columns that can be sorted by the user
	 */
	public function get_sortable_columns(){
		if (!isset($_REQUEST['s'])) {
			$sortable_columns = array(
									'col_firewall_time'	=>	array('time',false),
									'col_firewall_ip'		=>	array('spamip',false),
									'col_firewall_co'		=>	array('spamco',false),
									'col_firewall_refe'	=>	array('spamrefe',false),
									'col_firewall_dest'	=>	array('spamdest',false),
									'col_firewall_agen'	=>	array('spamagen',false),
									'col_firewall_user'	=>	array('spamuser',false),
									'col_firewall_value'	=>	array('spamvalue',false),
									
									
								);
			return $sortable_columns;
		}
		else{
			$sortable_columns = array(
									'col_firewall_time'	=>	array('time',false),
									'col_firewall_ip'		=>	array('spamip',false),
									'col_firewall_co'		=>	array('spamco',false),
									'col_firewall_refe'	=>	array('spamrefe',false),
									'col_firewall_dest'	=>	array('spamdest',false),
									'col_firewall_agen'	=>	array('spamagen',false),
									'col_firewall_user'	=>	array('spamuser',false),
									'col_firewall_value'	=>	array('spamvalue',false),
								);
			return $sortable_columns;
		}
	}

	/** * 
	Retrieve records data from the database
	* * @param int $per_page
	* @param int $page_number
	* * @return mixed
	*/
	public static function get_records($per_page, $page_number){
	global $wpdb;

		$table_spam_master_keys = $wpdb->prefix."spam_master_keys";
		$spam_master_server_entries = $wpdb->get_results(
													"SELECT id FROM $table_spam_master_keys
													WHERE spamkey = 'Firewall' AND LOCATE('WordPress/', spamagen)"
		);									
		if(!empty($spam_master_server_entries)){
			foreach($spam_master_server_entries as $id_to_move){
				$move_now = $id_to_move->id;
				$data_system = [ 'spamkey' => 'System', 'spamvalue' => 'Scrapping Keys.'];
				$where_system = [ 'id' => $move_now ];
				$wpdb->update( $table_spam_master_keys, $data_system, $where_system );
			}
		}

		if (isset($_REQUEST['s'])) {
			$sql = "SELECT * FROM {$table_spam_master_keys}";
			$search_system = esc_sql($_REQUEST['s']);
			$sql.= " WHERE (time LIKE '%".$search_system."%' OR spamip LIKE '%".$search_system."%' OR spamcou LIKE '%".$search_system."%' OR spamagen LIKE '%".$search_system."%' OR spamuser LIKE '%".$search_system."%' OR spamvalue LIKE '%".$search_system."%') AND spamkey != 'System'";
		}
		else{
			$search_system = false;
			$sql = "SELECT * FROM {$table_spam_master_keys} WHERE id IN (
					SELECT MAX(id)
					FROM {$table_spam_master_keys}
					WHERE spamkey != 'System' GROUP BY spamip
					)";
		}
		if (!empty($_REQUEST['orderby'])) {
			$sql.= ' ORDER BY ' . esc_sql($_REQUEST['orderby']);
			$sql.= !empty($_REQUEST['order']) ? ' ' . esc_sql($_REQUEST['order']) : ' DESC';
		}
		else{
			$sql.= ' ORDER BY id';
			$sql.= !empty($_REQUEST['order']) ? ' ' . esc_sql($_REQUEST['order']) : ' DESC';
		}
		$sql.= " LIMIT $per_page";
		$sql.= ' OFFSET ' . ($page_number - 1) * $per_page;
		$result = $wpdb->get_results($sql, 'ARRAY_A');
		return $result;
	}

	/**
	 * Prepare the table with different parameters, pagination, columns and table elements
	 */
	public function prepare_items(){
		// $this->_column_headers = $this->get_column_info();
		$columns = $this->get_columns();
		$hidden = $this->get_hidden_columns();
		$sortable = $this->get_sortable_columns();
		$this->_column_headers = array(
										$columns,
										$hidden,
										$sortable
										);
		/** Process bulk action */
		$this->process_bulk_action();
		$per_page = $this->get_items_per_page('records_per_page', 25);
		$current_page = $this->get_pagenum();
		$total_items = self::record_count();
		$data = self::get_records($per_page, $current_page);
		$this->set_pagination_args([
									'total_items' => $total_items, //WE have to calculate the total number of items
									'per_page' => $per_page // WE have to determine how many items to show on a page
		]);
		$this->items = $data;
	}

	/**
	 * Display the rows of records in the table
	 * @return string, echo the markup of the rows
	 */
	public function display_rows() {
		global $wpdb, $blog_id;

		if( is_multisite() ){
			$blogname = substr(get_blog_option($blog_id, 'blogname'),0,256);
			$response_key = get_blog_option($blog_id, 'spam_master_status');
			$spam_license_key = esc_html(substr(get_blog_option($blog_id, 'spam_license_key'),0,64));
		}
		else{
			$blogname = substr(get_option('blogname'),0,256);
			$response_key = get_option('spam_master_status');
			$spam_license_key = esc_html(substr(get_option('spam_license_key'),0,64));
		}
		if(empty($blogname)){
			$blogname = 'empty blog name';
		}
		//Tables
		$table_spam_master_keys = $wpdb->prefix."spam_master_keys";
		$table_spam_master_threats = $wpdb->prefix."spam_master_threats";
		$table_spam_master_white = $wpdb->prefix."spam_master_white";
		//Remote Ip
		$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
		//Remote Agent
		if(isset($_SERVER['HTTP_USER_AGENT'])){
			$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
		}
		else{
			$remote_agent = 'Sniffer';
		}
		// Remote Referer
		if(isset($_SERVER['HTTP_REFERER'])){
			$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
		}
		else{
			$remote_referer = 'Direct';
		}
		// DEST URL
		if(isset($_SERVER['REQUEST_URI'])){
			$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
		}
		else{
			$dest_url = 'Weird';
		}
		//exempt admins from check
		if(!function_exists('wp_get_current_user')) {
			include(ABSPATH . "wp-includes/pluggable.php"); 
		}
		// Current User
		$current_user_id = get_current_user_id();
		if(isset($current_user_id)){
			$current_user_id = $current_user_id;
		}
		else{
			$current_user_id = 'none';
		}

		//Get the records registered in the prepare_items method
		$records = $this->items;
		//Get the columns registered in the get_columns and get_sortable_columns methods
		list( $columns, $hidden ) = $this->get_column_info();
		//Loop for each record
		if(!empty($records)){
			foreach($records as $key){

				//Prepare Ip
				$spamip = $key['spamip'];
				//Prepare Result & First Action
				$spam_ip_block = $wpdb->get_var( "SELECT id FROM $table_spam_master_threats WHERE threat = '".$spamip."'" );
				if(empty($spam_ip_block)){
					$spam_result = '<span class="dashicons dashicons-yes-alt spam-master-admin-f48 spam-master-admin-green" title="'.__('Pass', 'spam_master').'"></span>';					
					$spam_action_buffer = $spam_action_buffer = '<a href="'.wp_nonce_url(admin_url( 'admin.php?page=spam-master-firewall&firewall=fire&spamaddition='.$spamip.''), 'save-settings_spam_master_fire_firewall').'" id="spammasteraddconfirm" title="'.__('Add to Spam?', 'spam_master').'"><span class="spam-master-admin-flex-pl4"><span class="dashicons dashicons-thumbs-down spam-master-admin-f48 spam-master-admin-red"></span></span></a>';
					//Prepare Action White
					$spam_white = $wpdb->get_var( "SELECT id FROM $table_spam_master_white WHERE white = '".$spamip."'" );
					if(empty($spam_white)){
						$white_get_flag = $wpdb->get_results( 
											$wpdb->prepare( 
															"SELECT spamco,spamcou FROM $table_spam_master_keys WHERE spamco != 'localhost' AND spamco != 'none' AND spamip = %s ORDER BY id DESC",
															$spamip
						));
						if(!empty($white_get_flag)){
							foreach($white_get_flag as $white_flag){
								$whiteco = $white_flag->spamco;
								$whitecou = $white_flag->spamcou;
								$spam_action_white = '<a href="'.wp_nonce_url(admin_url( 'admin.php?page=spam-master-firewall&firewall=fire&whiteaddition='.$spamip.'&whiteco='.$whiteco.'&whitecou='.$whitecou.''), 'save-settings_spam_master_fire_firewall').'" id="spammasterwhiteaddconfirm" title="'.__('Add to Whitelist?', 'spam_master').'"><span class="spam-master-admin-flex-pl4"><span class="dashicons dashicons-shield-alt spam-master-admin-f48 spam-master-admin-green"></span></span></a>';
							}
						}
						else{
							$spam_action_white = '<a href="'.wp_nonce_url(admin_url( 'admin.php?page=spam-master-firewall&firewall=fire&whiteaddition='.$spamip.'&whiteco=_unknown&whitecou=_unknown'), 'save-settings_spam_master_fire_firewall').'" id="spammasterwhiteaddconfirm" title="'.__('Add to Whitelist?', 'spam_master').'"><span class="spam-master-admin-flex-pl4"><span class="dashicons dashicons-shield-alt spam-master-admin-f48 spam-master-admin-green"></span></span></a>';
						}
					}
					else{
						$spam_action_white = '<a href="'.wp_nonce_url(admin_url( 'admin.php?page=spam-master-firewall&firewall=fire&whiteremoval='.$spamip.''), 'save-settings_spam_master_fire_firewall').'" id="spammasterwhiteremoveconfirm" title="'.__('Remove from Whitelist?', 'spam_master').'"><span class="spam-master-admin-flex-pl4"><span class="dashicons dashicons-superhero spam-master-admin-f48 spam-master-admin-green"></span></span></a>';
					}
				}
				else{
					$spam_result = '<span class="dashicons dashicons-tagcloud spam-master-admin-f48 spam-master-admin-red" title="Block"></span>';
					$spam_action_buffer = '<a href="'.wp_nonce_url(admin_url( 'admin.php?page=spam-master-firewall&firewall=fire&spamremoval='.$spamip.''), 'save-settings_spam_master_fire_firewall').'"  id="spammasterremoveconfirm" title="'.__('Remove from Spam?', 'spam_master').'"><span class="spam-master-admin-flex-pl4"><span class="dashicons dashicons-thumbs-up spam-master-admin-f48 spam-master-admin-green"></span></span></a>';
					$spam_action_white = '<span class="dashicons dashicons-privacy spam-master-admin-f48" title="'.__('Remove from Spam First', 'spam_master').'"></span>';
				}
				//Prepare Time
				$time = $key['time'];
				//Prepare CO
				$spamco = $key['spamco'];
				$spamcou = $key['spamcou'];
				if($spamip == 'localhost' || $spamip == 'none'){
					if($spamco == 'localhost'){
						$flag = '<img class="spam-master-middle spam-master-admin-f48" src="'.plugins_url('../../images/flags/_localhost.png', dirname(__FILE__)).'" title="'.__('This is Your Server', 'spam_master').'"/>';
					}
					if($spamco == 'none'){
						$flag = '<img class="spam-master-middle spam-master-admin-f48" src="'.plugins_url('../../images/flags/_unknown.png', dirname(__FILE__)).'" title="'.__('No flag', 'spam_master').'"/>';
					}
				}
				else{
				

				$spam_get_flag = $wpdb->get_results( 
									$wpdb->prepare( 
													"SELECT spamip,spamco,spamcou FROM $table_spam_master_keys WHERE spamco != 'localhost' AND spamip != 'localhost' AND spamip != 'none' AND spamip = %s GROUP BY spamip",
													$spamip
				));
				if(!empty($spam_get_flag)){
					foreach($spam_get_flag as $flag_data){
						$data_spamip = $flag_data->spamip;
						$data_co = $flag_data->spamco;
						$data_cou = $flag_data->spamcou;		
						$flag = '<img class="spam-master-middle spam-master-admin-f48" src="'.plugins_url('../../images/flags/'.$data_co.'.png', dirname(__FILE__)).'" title="'.$data_cou.'" alt="'.$data_cou.'"/>';

						}
					}
					else{
						if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
							if ( (filter_var($spamip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6)) || (filter_var($spamip, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)) ){
								//Report data
								$spam_master_learn_r_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX3JlcC5waHA=';
								$spam_master_report_post = array(
																	'blog_license_key' => $spam_license_key,
																	'blog_type' => 'Logs System CO Report',
																	'blog_primary' => substr($spamip, 0,256),
																	'blog_secondary' => 'Remote Ip: '.$_SERVER['REMOTE_ADDR'],
																	'blog_name' => $blogname,
																	'blog_agent' => $remote_agent
								);
								$response = wp_remote_post( base64_decode($spam_master_learn_r_url), array(
																											'method' => 'POST',
																											'timeout' => 90,
																											'body' => $spam_master_report_post
								));
								if ( is_wp_error( $response ) ) {
									$flag = '<img class="spam-master-middle spam-master-admin-f48" src="'.plugins_url('../../images/flags/_unknown.png', dirname(__FILE__)).'" title="'.__('No flag, internal Ip. It gets populated with a flag if there\'s an external check from this Ip to spammaster.org server.', 'spam_master').'"/>';
								}
								else{
									$data = json_decode( wp_remote_retrieve_body( $response ), true );
									//Insert flag for ip
									$spamco = $data['co'];
									$spamcou = $data['cou'];
									$remote_ip = $spamip;
									//Log InUp Controller
									/////////////////////
									$spamkey = 'System';
									$spamvalue = 'Logs System CO Report successful.';
									$SpamMasterLogController = new SpamMasterLogController;
									$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
									$flag = '<img class="spam-master-middle spam-master-admin-f48" src="'.plugins_url('../../images/flags/'.$spamco.'.png', dirname(__FILE__)).'" title="'.$spamcou.'" alt="'.$spamcou.'"/>';
								}
							}
							else{
								$flag = '<img class="spam-master-middle spam-master-admin-f48" src="'.plugins_url('../../images/flags/_unknown.png', dirname(__FILE__)).'" title="'.__('No flag, internal Ip. It gets populated with a flag if there\'s an external check from this Ip to spammaster.org server.', 'spam_master').'"/>';
							}
						}
						else{
							$flag = '<img class="spam-master-middle spam-master-admin-f48" src="'.plugins_url('../../images/flags/_unknown.png', dirname(__FILE__)).'" title="'.__('No flag, internal Ip. It gets populated with a flag if there\'s an external check from this Ip to spammaster.org server.', 'spam_master').'"/>';
						}
					}
				}
				//Prepare Count
				$spam_ip_count = $wpdb->get_var(
										$wpdb->prepare( 
														"SELECT COUNT(id) FROM $table_spam_master_keys WHERE spamip = %s AND spamkey != 'System'",
														$spamip
				));
				if($spam_ip_count >= '0' && $spam_ip_count <= '250'){
					$spam_ip_count_lenght = '25';
				}
				if($spam_ip_count >= '251' && $spam_ip_count <= '400'){
					$spam_ip_count_lenght = '40';
				}
				if($spam_ip_count >= '401' && $spam_ip_count <= '600'){
					$spam_ip_count_lenght = '60';
				}
				if($spam_ip_count >= '601' && $spam_ip_count <= '800'){
					$spam_ip_count_lenght = '80';
				}
				if($spam_ip_count >= '801'){
					$spam_ip_count_lenght = '100';
				}
				if(empty($spam_ip_block)){
					$spam_ip_count_style = 'g';
				}
				else{
					$spam_ip_count_style = 'r';
				}
				$spam_ip_count_result = '<div class="progress2 progress-moved"><div class="progress-bar'.$spam_ip_count_lenght.$spam_ip_count_style.'" ><a href="'.wp_nonce_url(admin_url( 'admin.php?page=spam-master-firewall&m=firewall&s='.$spamip.''), 'save-settings_spam_master_fire_firewall').'" title="'.__('View All', 'spam_master').'"><span class="spam-master-admin-flex-pl4"><span class="dashicons dashicons-search"></span> '.number_format($spam_ip_count).'</span></a></div></div>';
				//Prepare Refe
				$spamrefe = $key['spamrefe'];
				//Prepare Dest
				$spamdest = $key['spamdest'];
				//Prepare Agen
				$spamagen = $key['spamagen'];
				//Prepare User
				$spamuser = $key['spamuser'];
				if($spamuser == 'localhost' || $spamuser == 'none' || $spamuser == '0'){
					$spam_combined_user = 'none';

				}
				else{
					$spam_new_user = get_userdata($spamuser);
					$spam_username = $spam_new_user->user_login;
					$spam_avatar = get_avatar( $spamuser, 64 );
					$spam_combined_user = '<a href="'.admin_url( 'user-edit.php?user_id='.$spamuser.'').'" title="'.__('Edit User', 'spam_master').'"><span class="spam-master-admin-firewall-table">'.get_avatar( $spamuser, 48 ).'</span></a><a href="'.admin_url( 'user-edit.php?user_id='.$spamuser.'').'" title="'.__('Edit User', 'spam_master').'">'.$spam_username.'</a>';
				}
				//Prepare Value
				$spamvalue = $key['spamvalue'];

				//Open the line
				static $row_class = '';
				$row_class = ( $row_class == '' ? ' class="alternate"' : '' );
				echo '<tr '.$row_class.'>';
				foreach ( $columns as $column_name => $column_display_name ) {

					//Style attributes for each col
					$class = 'class="'.$column_name. ' column-'.$column_name.'"';
					$style = '';
					if ( in_array( $column_name, $hidden ) )
					$style = ' class="spam-master-hidden"';
					$attributes = 'class="spam-master-middle';
					//Display the cell
					if (!isset($_REQUEST['s'])) {
						switch ( $column_name ) {
							case 'col_firewall_result':	echo '<td '.$attributes.'">'.stripslashes($spam_result).'</td>';break;
							case 'col_firewall_time':	echo '<td '.$attributes.'">'.stripslashes($time).'</td>';break;
							case 'col_firewall_ip':	echo '<td '.$attributes.'">'.stripslashes($spamip).'</td>';break;
							case 'col_firewall_co':	echo '<td '.$attributes.'">'.stripslashes($flag).'</td>';break;
							case 'col_firewall_count':	echo '<td '.$attributes.'">'.$spam_ip_count_result.'</td>';break;
							case 'col_firewall_refe':	echo '<td '.$attributes.'">'.stripslashes(mb_substr($spamrefe, 0, 75)).'</td>';break;
							case 'col_firewall_dest':	echo '<td '.$attributes.'">'.stripslashes(mb_substr($spamdest, 0, 75)).'</td>';break;
							case 'col_firewall_agen':	echo '<td '.$attributes.'">'.stripslashes(mb_substr($spamagen, 0, 75)).'</td>';break;
							case 'col_firewall_user':	echo '<td '.$attributes.'">'.$spam_combined_user.'</td>';break;
							case 'col_firewall_value':	echo '<td '.$attributes.'">'.stripslashes(wp_strip_all_tags(mb_substr($spamvalue, 0, 75))).'</td>';break;
							case 'col_firewall_block':	echo '<td '.$attributes.'">'.$spam_action_buffer.'</td>';break;
							case 'col_firewall_white':	echo '<td '.$attributes.'">'.$spam_action_white.'</td>';break;
						}
					}
					else{
						switch ( $column_name ) {
							case 'col_firewall_result':	echo '<td '.$attributes.'">'.stripslashes($spam_result).'</td>';break;
							case 'col_firewall_time':	echo '<td '.$attributes.'">'.stripslashes($time).'</td>';break;
							case 'col_firewall_ip':	echo '<td '.$attributes.'">'.stripslashes($spamip).'</td>';break;
							case 'col_firewall_co':	echo '<td '.$attributes.'">'.stripslashes($flag).'</td>';break;
							case 'col_firewall_refe':	echo '<td '.$attributes.'">'.stripslashes($spamrefe).'</td>';break;
							case 'col_firewall_dest':	echo '<td '.$attributes.'">'.stripslashes($spamdest).'</td>';break;
							case 'col_firewall_agen':	echo '<td '.$attributes.'">'.stripslashes($spamagen).'</td>';break;
							case 'col_firewall_user':	echo '<td '.$attributes.'">'.$spam_combined_user.'</td>';break;
							case 'col_firewall_value':	echo '<td '.$attributes.'">'.stripslashes(wp_strip_all_tags($spamvalue)).'</td>';break;
						}
					}
				}
				echo '</tr>';
			}
		}
	}

	/** 
	* Returns the count of records in the database. 
	* * @return null|string 
	*/
	public static function record_count(){
	global $wpdb;
		$table_spam_master_keys = $wpdb->prefix."spam_master_keys";
		if (isset($_REQUEST['s'])) {
			$search_system = esc_sql($_REQUEST['s']);
			$sql = "SELECT COUNT(*) FROM {$table_spam_master_keys}";
			$sql.= " WHERE (time LIKE '%".$search_system."%' OR spamip LIKE '%".$search_system."%' OR spamcou LIKE '%".$search_system."%' OR spamagen LIKE '%".$search_system."%' OR spamuser LIKE '%".$search_system."%' OR spamvalue LIKE '%".$search_system."%') AND spamkey != 'System'";
		}
		else{
			$search_system = false;
			$sql = "SELECT COUNT(*) FROM {$table_spam_master_keys} WHERE id IN (
					SELECT MAX(id)
					FROM {$table_spam_master_keys}
					WHERE spamkey != 'System' GROUP BY spamip
					)";
		}
		return $wpdb->get_var($sql);
	}

    public function search_box( $text, $input_id ) {
        if ( empty( $_REQUEST['s'] ) && ! $this->has_items() ) {
            return;
        }
 
        $input_id = $input_id . '-search-input';
 
        if ( ! empty( $_REQUEST['orderby'] ) ) {
            echo '<input type="hidden" name="orderby" value="' . esc_attr( $_REQUEST['orderby'] ) . '" />';
        }
        if ( ! empty( $_REQUEST['order'] ) ) {
            echo '<input type="hidden" name="order" value="' . esc_attr( $_REQUEST['order'] ) . '" />';
        }
        if ( ! empty( $_REQUEST['post_mime_type'] ) ) {
            echo '<input type="hidden" name="post_mime_type" value="' . esc_attr( $_REQUEST['post_mime_type'] ) . '" />';
        }
        if ( ! empty( $_REQUEST['detached'] ) ) {
            echo '<input type="hidden" name="detached" value="' . esc_attr( $_REQUEST['detached'] ) . '" />';
        }
        ?>
<p class="search-box">
	<label class="screen-reader-text" for="<?php echo esc_attr( $input_id ); ?>"><?php echo $text; ?>:</label>
	<input type="search" id="<?php echo esc_attr( $input_id ); ?>" name="s" value="<?php _admin_search_query(); ?>" />
	<?php submit_button( $text, '', '', false, array( 'id' => 'search-submit' ) ); ?>
	<?php if (isset($_REQUEST['s'])) {
		echo '<a class="button-primary" href="'.wp_nonce_url(admin_url( 'admin.php?page=spam-master-firewall&m=firewall'), 'save-settings_spam_master_fire_firewall').'" title="'.__('Back to Firewall', 'spam_master').'">'.__('Back', 'spam_master').'</a>';
	}
	?>
</p>
        <?php
    }

}
