<?php
function menu_anal_single(){
	if ( is_admin() )
		add_submenu_page( 'spam-master', 'Firewall', 'Firewall', 'manage_options', 'spam-master-firewall', 'spam_master_firewall' );
}
///////////////////////
// WORDPRESS ACTIONS //
///////////////////////
if( is_multisite() ) {
	add_action( 'admin_menu', 'menu_anal_single' );
}
else {
	add_action( 'admin_menu', 'menu_anal_single' );
}

function spam_master_confirm_click(){
	echo '<script type="text/javascript">
	var spammasterremove = document.getElementById("spammasterremoveconfirm");
	if (spammasterremove !== null) spammasterremove.onclick = function(){
		return confirm("Are you sure you want to Remove this IP from Spam Buffer & RBL Servers?");
	};
	var spammasteradd = document.getElementById("spammasteraddconfirm");
	if (spammasteradd !== null) spammasteradd.onclick = function(){
		return confirm("Are you sure you want to Add this IP to Spam Buffer & RBL Servers?");
	};


	var spammasterwhiteremove = document.getElementById("spammasterwhiteremoveconfirm");
	if (spammasterwhiteremove !== null) spammasterwhiteremove.onclick = function(){
		return confirm("Are you sure you want to Remove this IP from Whitelist & RBL Servers?");
	};
	var spammasterwhiteadd = document.getElementById("spammasterwhiteaddconfirm");
	if (spammasterwhiteadd !== null) spammasterwhiteadd.onclick = function(){
		return confirm("Are you sure you want to Add this IP to Whitelist & RBL Servers?");
	};
	</script>';
}
add_action('admin_footer', 'spam_master_confirm_click');

function spam_master_firewall(){
global $wp_nonce, $wpdb, $blog_id;
$plugin_master_name = constant('SPAM_MASTER_NAME');
$plugin_master_domain = constant('SPAM_MASTER_DOMAIN');
//get menu page
if(isset($_GET['m'])){
	$selected_menu = $_GET['m'];
}
else{
	$selected_menu = 'firewall';
}
//Add Controllers
require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');

//Remote Ip
$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
//Remote Agent
if(isset($_SERVER['HTTP_USER_AGENT'])){
	$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
}
else{
	$remote_agent = 'Sniffer';
}
// Remote Referer
if(isset($_SERVER['HTTP_REFERER'])){
	$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
}
else{
	$remote_referer = 'Direct';
}
// DEST URL
if(isset($_SERVER['REQUEST_URI'])){
	$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
}
else{
	$dest_url = 'Weird';
}
//exempt admins from check
if(!function_exists('wp_get_current_user')) {
	include(ABSPATH . "wp-includes/pluggable.php"); 
}
// Current User
$current_user_id = get_current_user_id();
if(isset($current_user_id)){
	$current_user_id = $current_user_id;
}
else{
	$current_user_id = 'none';
}
?>
<div class="wrap">
<h1><?php echo $plugin_master_name; ?> Firewall</h1>
<?php
//Add Controllers
require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterInvitationController.php');
$SpamMasterInvitationController = new SpamMasterInvitationController;
$is_invited = $SpamMasterInvitationController->SpamMasterInvitation();
echo $is_invited;

if(!class_exists('spam_master_menu_table')){
	require_once( WP_PLUGIN_DIR . '/spam-master/includes/admin/spam-master-admin-menu-table.php');
}
//Prepare Table of elements
$wp_list_table = new spam_master_menu_table();
//Table of elements
$wp_list_table->display();

if( is_multisite() ){
	$blogname = substr(get_blog_option($blog_id, 'blogname'),0,256);
	$response_key = get_blog_option($blog_id, 'spam_master_status');
	$spam_license_key = esc_html(substr(get_blog_option($blog_id, 'spam_license_key'),0,64));
	//Load Tables
	$table_spam_master_white = $wpdb->get_blog_prefix($blog_id)."spam_master_white";
	$table_spam_master_threats = $wpdb->get_blog_prefix($blog_id)."spam_master_threats";
	$table_spam_master_keys = $wpdb->get_blog_prefix($blog_id)."spam_master_keys";
}
else{
	$blogname = substr(get_option('blogname'),0,256);
	$response_key = get_option('spam_master_status');
	$spam_license_key = esc_html(substr(get_option('spam_license_key'),0,64));
	//Load Tables
	$table_spam_master_white = $wpdb->prefix."spam_master_white";
	$table_spam_master_threats = $wpdb->prefix."spam_master_threats";
	$table_spam_master_keys = $wpdb->prefix."spam_master_keys";
}
if(empty($blogname)){
	$blogname = 'empty blog name';
}

////////////////
/// FIREWALL ///
////////////////
if($selected_menu == 'firewall'){

	/////////////////////////////
	//Prepare POST Spam Removal//
	if(isset($_REQUEST['spamremoval']) && !empty($_REQUEST['spamremoval']) && $_REQUEST['firewall'] == 'fire'){
		$spam_master_interact = sanitize_text_field($_REQUEST['spamremoval']);

		if ( (!filter_var($spam_master_interact, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6)) && (!filter_var($spam_master_interact, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)) ){
?>
<div id="message" class="error">
<p><?php echo __('Error! Could not validate your Email, IPV6 or IPV4 for Spam Buffer deletion. Please insert a valid Email or Ip.', 'spam_master'); ?></p>
</div>
<?php
		}
		else{
			//Check if spam exists
			$exists_buffer = $wpdb->get_var( 
							$wpdb->prepare( 
											"SELECT threat FROM $table_spam_master_threats WHERE threat = %s",
											$spam_master_interact
			));
			if($exists_buffer){
				//Log InUp Controller
				$spamkey = 'System';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Firewall Spam Buffer successful removed entry '.$spam_master_interact.' and all Emails associated.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
				//Search for all emails in keys spamvalue and delete
				$spam_get_emails = $wpdb->get_results( 
											$wpdb->prepare( 
															"SELECT REGEXP_SUBSTR(spamvalue, '([a-zA-Z0-9._%+\-]+)@([a-zA-Z0-9.-]+)\.([a-zA-Z]{2,4})') AS emails FROM $table_spam_master_keys WHERE spamkey != 'System' AND spamip = %s AND LOCATE('@', spamvalue)", $spam_master_interact
				));
				if(!empty($spam_get_emails)){
					foreach($spam_get_emails as $spam_delete_email){
						$spamemail = $spam_delete_email->emails;
						//Delete Ips from threats
						$wpdb->delete( $table_spam_master_threats, array( 'threat' => $spamemail ) );
					}
				}
				//Delete from threats
				$wpdb->delete( $table_spam_master_threats, array( 'threat' => $spam_master_interact ) );

				if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
					//Report data
					$spam_emails_if_any = $wpdb->get_var( 
													$wpdb->prepare( 
																	"SELECT GROUP_CONCAT(DISTINCT(REGEXP_SUBSTR(spamvalue, '([a-zA-Z0-9._%+\-]+)@([a-zA-Z0-9.-]+)\.([a-zA-Z]{2,4})')) SEPARATOR '-') AS emails FROM $table_spam_master_keys WHERE spamkey != 'System' AND spamip = %s AND LOCATE('@', spamvalue)", $spam_master_interact
					));
					if(empty($spam_emails_if_any)){
						$spam_emails_if_any = 'none';
					}
					$spam_master_learn_r_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX3JlcC5waHA=';
					$spam_master_report_post = array(
													'blog_license_key' => $spam_license_key,
													'blog_type' => 'Spam Buffer Removal',
													'blog_primary' => substr($spam_master_interact, 0,256),
													'blog_secondary' => $spam_emails_if_any.' - Remote Ip: '.$remote_ip,
													'blog_name' => $blogname,
													'blog_agent' => $remote_agent
					);
					$response = wp_remote_post( base64_decode($spam_master_learn_r_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_report_post
					));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Firewall Spam Buffer Removal RBL Reporting. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
?>
<div id="message" class="error">
<p><?php echo __('Something went wrong, please get in touch with spammaster.org support ERROR: '.$error_message, 'spam_master'); ?></p>
</div>
<?php
					}
					else{
?>
<div id="message" class="updated fade">
<p><?php echo __($spam_master_interact . ' Ip and Associated Emails Removed from Spam Buffer & Reported to RBL Servers.', 'spam_master'); ?></p>
</div>
<?php
					}
				}
				else{
?>
<div id="message" class="error">
<p><?php echo __($spam_master_interact . ' Ip and Associated Emails Removed from Spam Buffer. License ERROR, no connection, could not report to RBL Servers.', 'spam_master'); ?></p>
</div>
<?php
				}
			}
			else{
?>
<div id="message" class="error">
<p><?php echo __($spam_master_interact . ' already removed from Spam Buffer.', 'spam_master'); ?></p>
</div>
<?php
			}
		}
	}

	//////////////////////////////
	//Prepare POST Spam Addition//
	if(isset($_REQUEST['spamaddition']) && !empty($_REQUEST['spamaddition']) && $_REQUEST['firewall'] == 'fire'){
		$spam_master_interact = sanitize_text_field($_REQUEST['spamaddition']);

		if ( (!filter_var($spam_master_interact, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6)) && (!filter_var($spam_master_interact, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)) ){
?>
<div id="message" class="error">
<p><?php echo __('Error! Could not validate your Email, IPV6 or IPV4 for Spam Buffer deletion. Please insert a valid Email or Ip.', 'spam_master'); ?></p>
</div>
<?php
		}
		else{
			//Check if spam exists
			$exists_buffer = $wpdb->get_var( 
										$wpdb->prepare( 
														"SELECT threat FROM $table_spam_master_threats WHERE threat = %s",
														$spam_master_interact
			));
			if($exists_buffer){
?>
<div id="message" class="error">
<p><?php echo __($spam_master_interact . ' already exists in Spam Buffer.', 'spam_master'); ?></p>
</div>
<?php
			}
			else{
				//Log InUp Controller
				$spamkey = 'System';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Firewall Spam Buffer successful added entry '.$spam_master_interact.' and all Emails associated.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
				//Search for all emails in keys spamvalue and delete
				$spam_get_emails = $wpdb->get_results( 
												$wpdb->prepare( 
																"SELECT DISTINCT(REGEXP_SUBSTR(spamvalue, '([a-zA-Z0-9._%+\-]+)@([a-zA-Z0-9.-]+)\.([a-zA-Z]{2,4})')) AS emails FROM $table_spam_master_keys WHERE spamkey != 'System' AND spamip = %s AND LOCATE('@', spamvalue)", $spam_master_interact
				));
				if(!empty($spam_get_emails)){
					foreach($spam_get_emails as $spam_delete_email){
						$spamemail = $spam_delete_email->emails;
						//Insert Emails to threats
						$wpdb->insert( $table_spam_master_threats, array( 'time' => current_time( 'mysql' ), 'threat' => $spamemail, 'spamco' => 'email', 'spamcou' => 'Email' ));
					}
				}
				//Insert to threats but get spamco & spamcou
				$spam_get_flag = $wpdb->get_results( 
									$wpdb->prepare( 
													"SELECT spamco,spamcou FROM $table_spam_master_keys WHERE spamco != 'localhost' AND spamco != 'none' AND spamip = %s ORDER BY id DESC LIMIT 1",
													$spam_master_interact
				));
				if(!empty($spam_get_flag)){
					foreach($spam_get_flag as $flag_data){
						$data_co = $flag_data->spamco;
						$data_cou = $flag_data->spamcou;
						$wpdb->insert( $table_spam_master_threats, array( 'time' => current_time( 'mysql' ), 'threat' => $spam_master_interact, 'spamco' => $data_co, 'spamcou' => $data_cou ));
					}
				}
				else{
					$wpdb->insert( $table_spam_master_threats, array( 'time' => current_time( 'mysql' ), 'threat' => $spam_master_interact, 'spamco' => '_unknown', 'spamcou' => '_unknown' ));
				}

				if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
					//Report data
					$spam_emails_if_any = $wpdb->get_var( 
													$wpdb->prepare( 
																	"SELECT GROUP_CONCAT(DISTINCT(REGEXP_SUBSTR(spamvalue, '([a-zA-Z0-9._%+\-]+)@([a-zA-Z0-9.-]+)\.([a-zA-Z]{2,4})')) SEPARATOR '-') AS emails FROM $table_spam_master_keys WHERE spamkey != 'System' AND spamip = %s AND LOCATE('@', spamvalue)", $spam_master_interact
					));
					if(empty($spam_emails_if_any)){
						$spam_emails_if_any = 'none';
					}
					$spam_master_learn_r_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX3JlcC5waHA=';
					$spam_master_report_post = array(
													'blog_license_key' => $spam_license_key,
													'blog_type' => 'Spam Buffer Addition',
													'blog_primary' => substr($spam_master_interact, 0,256),
													'blog_secondary' => $spam_emails_if_any.' - Remote Ip: '.$remote_ip,
													'blog_name' => $blogname,
													'blog_agent' => $remote_agent
					);
					$response = wp_remote_post( base64_decode($spam_master_learn_r_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_report_post
					));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Firewall Spam Buffer Addition RBL Reporting. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
?>
<div id="message" class="error">
<p><?php echo __('Something went wrong, please get in touch with spammaster.org support ERROR: '.$error_message, 'spam_master'); ?></p>
</div>
<?php
					}
					else{
?>
<div id="message" class="updated fade">
<p><?php echo __($spam_master_interact . ' Ip and Associated Emails Added to Spam Buffer & Reported to RBL Servers.', 'spam_master'); ?></p>
</div>
<?php
					}
				}
				else{
?>
<div id="message" class="error">
<p><?php echo __($spam_master_interact . ' Ip and Associated Emails Added to Spam Buffer. License ERROR, no connection, could not report to RBL Servers.', 'spam_master'); ?></p>
</div>
<?php
				}
			}
		}
	}
	//////////////////////////////
	//Prepare POST White Removal//
	if(isset($_REQUEST['whiteremoval']) && !empty($_REQUEST['whiteremoval']) && $_REQUEST['firewall'] == 'fire'){
		$spam_master_interact = sanitize_text_field($_REQUEST['whiteremoval']);

		if ( (!filter_var($spam_master_interact, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6)) && (!filter_var($spam_master_interact, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)) ){
?>
<div id="message" class="error">
<p><?php echo __('Error! Could not validate your Email, IPV6 or IPV4 for whitelist deletion. Please insert a valid Email or Ip.', 'spam_master'); ?></p>
</div>
<?php
		}
		else{
			//First check whitelist to see if exists
			$exists_white = $wpdb->get_var(
							$wpdb->prepare("SELECT white FROM $table_spam_master_white WHERE white = %s",
							$spam_master_interact
							));
			//Exists error
			if($exists_white){
				//Log InUp Controller
				$spamkey = 'System';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Firewall Whitelist successful delete entry '.$spam_master_interact.' and all Emails associated.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
				//Search for all emails in keys spamvalue and delete
				$spam_get_emails = $wpdb->get_results( 
									$wpdb->prepare( 
													"SELECT REGEXP_SUBSTR(spamvalue, '([a-zA-Z0-9._%+\-]+)@([a-zA-Z0-9.-]+)\.([a-zA-Z]{2,4})') AS emails FROM $table_spam_master_keys WHERE spamkey != 'System' AND spamip = %s AND LOCATE('@', spamvalue)", $spam_master_interact
				));
				if(!empty($spam_get_emails)){
					foreach($spam_get_emails as $spam_delete_email){
						$spamemail = $spam_delete_email->emails;
						//Delete from white if any
						$wpdb->delete( $table_spam_master_white, array( 'white' => $spamemail ) );
					}
				}
				//Delete from white
				$wpdb->delete( $table_spam_master_white, array( 'white' => $spam_master_interact ) );

				if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
					//Report data
					$spam_emails_if_any = $wpdb->get_var( 
													$wpdb->prepare( 
																	"SELECT GROUP_CONCAT(DISTINCT(REGEXP_SUBSTR(spamvalue, '([a-zA-Z0-9._%+\-]+)@([a-zA-Z0-9.-]+)\.([a-zA-Z]{2,4})')) SEPARATOR '-') AS emails FROM $table_spam_master_keys WHERE spamkey != 'System' AND spamip = %s AND LOCATE('@', spamvalue)", $spam_master_interact
					));
					if(empty($spam_emails_if_any)){
						$spam_emails_if_any = 'none';
					}
					$spam_master_learn_r_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX3JlcC5waHA=';
					$spam_master_report_post = array(
													'blog_license_key' => $spam_license_key,
													'blog_type' => 'Whitelist Removal Firewall',
													'blog_primary' => substr($spam_master_interact, 0,256),
													'blog_secondary' => $spam_emails_if_any.' - Remote Ip: '.$remote_ip,
													'blog_name' => $blogname,
													'blog_agent' => $remote_agent
					);
					$response = wp_remote_post( base64_decode($spam_master_learn_r_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_report_post
					));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Firewall Whitelist Removal RBL Reporting. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
?>
<div id="message" class="error">
<p><?php echo __('Something went wrong, please get in touch with spammaster.org support ERROR: '.$error_message, 'spam_master'); ?></p>
</div>
<?php
					}
					else{
?>
<div id="message" class="updated fade">
<p><?php echo __($spam_master_interact . ' Ip and Associated Emails Removed from Whitelist & Reported to RBL Servers.', 'spam_master'); ?></p>
</div>
<?php
					}
				}
				else{
?>
<div id="message" class="error">
<p><?php echo __($spam_master_interact . ' Ip and Associated Emails Removed from Whitelist. License ERROR, no connection, could not report to RBL Servers.', 'spam_master'); ?></p>
</div>
<?php
				}
			}
			else{
?>
<div id="message" class="error">
<p><?php echo __($spam_master_interact . ' already removed from Whitelist.', 'spam_master'); ?></p>
</div>
<?php
			}
		}
	}
	///////////////////////////////
	//Prepare POST White Addition//
	if(isset($_REQUEST['whiteaddition']) && !empty($_REQUEST['whiteaddition']) && $_REQUEST['firewall'] == 'fire'){
		$spam_master_interact = sanitize_text_field($_REQUEST['whiteaddition']);
		if ( (!filter_var($spam_master_interact, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6)) && (!filter_var($spam_master_interact, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)) ){
?>
<div id="message" class="error">
<p><?php _e('Error! Could not validate your Email, IPV6 or IPV4 for whitelist addition. Please insert a valid Email or Ip.', 'spam_master'); ?></p>
</div>
<?php
		}
		else{
			//First check whitelist to see if exists
			$exists_white = $wpdb->get_var(
							$wpdb->prepare("SELECT white FROM $table_spam_master_white WHERE white = %s",
							$spam_master_interact
							));
			//Exists error
			if($exists_white){
?>
<div id="message" class="error">
<p><?php echo __($spam_master_interact . ' already exists in whitelist.', 'spam_master'); ?></p>
</div>
<?php
				//Exists but lets delete from threats
				$wpdb->delete( $table_spam_master_threats, array( 'threat' => $spam_master_interact ) );
			}
			else{
				//Log InUp Controller
				$spamkey = 'System';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Firewall Whitelist successful add entry '.$spam_master_interact.' and all Emails associated.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
				//Search for all emails in keys spamvalue and insert
				$white_get_emails = $wpdb->get_results( 
									$wpdb->prepare( 
													"SELECT DISTINCT(REGEXP_SUBSTR(spamvalue, '([a-zA-Z0-9._%+\-]+)@([a-zA-Z0-9.-]+)\.([a-zA-Z]{2,4})')) AS emails FROM $table_spam_master_keys WHERE spamkey != 'System' AND spamip = %s AND LOCATE('@', spamvalue)", $spam_master_interact
				));
				if(!empty($white_get_emails)){
					foreach($white_get_emails as $white_insert_email){
						$whiteemail = $white_insert_email->emails;
						$wpdb->insert( $table_spam_master_white, array( 'time' => current_time( 'mysql' ), 'white' => $whiteemail, 'whiteco' => 'email', 'whitecou' => 'Email' ));
						//Delete Emails from threats
						$wpdb->delete( $table_spam_master_threats, array( 'threat' => $whiteemail ) );
						
					}
				}
				//Delete from threats
				$wpdb->delete( $table_spam_master_threats, array( 'threat' => $spam_master_interact ) );
				//Insert to white but get spamco & spamcou
				$spam_get_flag = $wpdb->get_results( 
									$wpdb->prepare( 
													"SELECT spamco,spamcou FROM $table_spam_master_keys WHERE spamco != 'localhost' AND spamco != 'none' AND spamip = %s ORDER BY id DESC LIMIT 1",
													$spam_master_interact
				));
				if(!empty($spam_get_flag)){
					foreach($spam_get_flag as $flag_data){
						$data_co = $flag_data->spamco;
						$data_cou = $flag_data->spamcou;
						$wpdb->insert( $table_spam_master_white, array( 'time' => current_time( 'mysql' ), 'white' => $spam_master_interact, 'whiteco' => $data_co, 'whitecou' => $data_cou ));
					}
				}
				else{
					$wpdb->insert( $table_spam_master_white, array( 'time' => current_time( 'mysql' ), 'white' => $spam_master_interact, 'whiteco' => '_unknown', 'whitecou' => '_unknown' ));
				}


				if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
					//Report data
					$spam_emails_if_any = $wpdb->get_var( 
													$wpdb->prepare( 
																	"SELECT GROUP_CONCAT(DISTINCT(REGEXP_SUBSTR(spamvalue, '([a-zA-Z0-9._%+\-]+)@([a-zA-Z0-9.-]+)\.([a-zA-Z]{2,4})')) SEPARATOR '-') AS emails FROM $table_spam_master_keys WHERE spamkey != 'System' AND spamip = %s AND LOCATE('@', spamvalue)", $spam_master_interact
					));
					if(empty($spam_emails_if_any)){
						$spam_emails_if_any = 'none';
					}
					$spam_master_learn_r_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX3JlcC5waHA=';
					$spam_master_report_post = array(
													'blog_license_key' => $spam_license_key,
													'blog_type' => 'Whitelist Addition Firewall',
													'blog_primary' => substr($spam_master_interact, 0,256),
													'blog_secondary' => $spam_emails_if_any.' - Remote Ip: '.$remote_ip,
													'blog_name' => $blogname,
													'blog_agent' => $remote_agent
					);
					$response = wp_remote_post( base64_decode($spam_master_learn_r_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_report_post
					));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Firewall Whitelist Addition RBL Reporting. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
?>
<div id="message" class="error">
<p><?php echo __('Something went wrong, please get in touch with spammaster.org support ERROR: '.$error_message, 'spam_master'); ?></p>
</div>
<?php
					}
					else{
?>
<div id="message" class="updated fade">
<p><?php echo __($spam_master_interact . ' Ip and Associated Emails Added to Whitelist & Reported to RBL Servers.', 'spam_master'); ?></p>
</div>
<?php
					}
				}
				else{
?>
<div id="message" class="error">
<p><?php echo __($spam_master_interact . ' Ip and Associated Emails Added to Whitelist. License ERROR, no connection, could not report to RBL Servers.', 'spam_master'); ?></p>
</div>
<?php
				}
			}
		}
	}

	if(!class_exists('spam_master_firewall_table_blocked')){
		require_once( WP_PLUGIN_DIR . '/spam-master/includes/firewall/firewall/spam-master-admin-firewall-table-blocked.php');
	}
	//Prepare Table of elements
	$wp_list_table = new spam_master_firewall_table_blocked();
	$wp_list_table->prepare_items();
	?>
	<form method="get">
	<input type="hidden" name="page" value="<?php echo esc_attr($_REQUEST['page']); ?>" />
	<input type="hidden" name="m" value="firewall" />
	<?php
	$wp_list_table->search_box('search', '-search-input');
	//Table of elements
	$wp_list_table->display();
	?>
	</form>
	<?php

}
//////////////
/// SYSTEM ///
//////////////
if($selected_menu == 'system'){

	if(!class_exists('spam_master_system_table_blocked')){
		require_once( WP_PLUGIN_DIR . '/spam-master/includes/firewall/system/spam-master-admin-system-table-blocked.php');
	}
	//Prepare Table of elements
	$wp_list_table = new spam_master_system_table_blocked();
	$wp_list_table->prepare_items();
	?>
	<form method="get">
	<input type="hidden" name="page" value="<?php echo esc_attr($_REQUEST['page']); ?>" />
	<input type="hidden" name="m" value="system" />
	<?php
	$wp_list_table->search_box('search', '-search-input');
	//Table of elements
	$wp_list_table->display();
	?>
	</form>
	<?php

}
/////////////
/// STATS ///
/////////////
if($selected_menu == 'stats'){
	if(!class_exists('spam_master_statistics_table')){
		require_once( WP_PLUGIN_DIR . '/spam-master/includes/firewall/statistics/spam-master-admin-statistics-table.php');
	}
	//Prepare Table of elements
	$wp_list_table = new spam_master_statistics_table();
	//Table of elements
	$wp_list_table->display();
}

//Footer
require_once( WP_PLUGIN_DIR . '/spam-master/includes/admin/spam-master-admin-footer.php');
?>
</div>
<?php
}
