<?php
if(!class_exists('WP_List_Table')){
	require_once( get_home_path() . 'wp-admin/includes/class-wp-list-table.php' );
}
class spam_master_statistics_table extends WP_List_Table {

function display(){
global $wpdb, $blog_id;
$blog_prefix = $wpdb->get_blog_prefix();
$table_prefix = $wpdb->base_prefix;
if( is_multisite() ){
$response_key = get_blog_option($blog_id, 'spam_master_status');
$spam_master_type = get_blog_option($blog_id, 'spam_master_type');
$firewall_active = get_blog_option($blog_id, 'spam_master_firewall_on');
}
else{
$response_key = get_option('spam_master_status');
$spam_master_type = get_option('spam_master_type');
$firewall_active = get_option('spam_master_firewall_on');
}

//Tables
$spam_master_threats = $wpdb->prefix."spam_master_threats";
$spam_master_white = $wpdb->prefix."spam_master_white";
$spam_master_keys = $wpdb->prefix."spam_master_keys";

//Prepare 31 Days
$spam_master_today = current_time( 'mysql' );
$spam_master_today_minus_7 = date('Y-m-d h:i:s',strtotime($spam_master_today . "-7 days"));

//Graph Firewall
$total_firewall = $wpdb->get_results(
					$wpdb->prepare(
									"SELECT DAY(time) AS day, MONTH(time) AS month, COUNT(spamkey) AS total FROM $spam_master_keys WHERE (time BETWEEN %s AND %s) AND spamkey = 'Firewall' GROUP BY DAY(time) ORDER BY id DESC",
									$spam_master_today_minus_7, $spam_master_today
));
if(!empty($total_firewall)){
	?>
<table class="wp-list-table widefat fixed striped table-view-list" cellspacing="0">
	<thead>
		<tr></tr>
	</thead>

	<tfoot>
		<tr></tr>
	</tfoot>

	<tbody>
		<tr>
<script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
<script type="text/javascript">
      google.charts.load('current', {'packages':['corechart']});
      google.charts.setOnLoadCallback(drawChart);

      function drawChart() {
        var data = google.visualization.arrayToDataTable([
          ['Day', 'Entries'],
			<?php 
			foreach($total_firewall as $spam_firewall){
			$day_firewall = $spam_firewall->day;
			$month_firewall = $spam_firewall->month;
			$value_firewall = $spam_firewall->total;
			?>
			['<?php echo $day_firewall . ' ' . date("M", mktime(0, 0, 0, $month_firewall, 10)); ?>', <?php echo $value_firewall; ?>],
			<?php
			}
			?>
        ]);

        var options = {
          title: '7 Days - Firewall Entries',
          chartArea: {
	        width: "90%",
			},
          curveType: 'function',
          legend: { position: 'bottom' },
          series: {
			0: { color: '#E8052B', pointSize: '10'}
		   },
			logScale:true,
        };

        var chart = new google.visualization.LineChart(document.getElementById('curve_chart'));

        chart.draw(data, options);
      }
</script>
<div id="curve_chart" class="spam-master-admin-firewall-curve-chart"></div>
		</tr>
	</tbody>
</table>
<div class="spam-master-pad-table"></div>
<?php
}
else{
?>
<div class="spam-master-pad-table"></div>
<?php
}

//Graph System
$total_system = $wpdb->get_results(
					$wpdb->prepare(
									"SELECT DAY(time) AS day, MONTH(time) AS month, COUNT(spamkey) AS total FROM $spam_master_keys WHERE (time BETWEEN %s AND %s) AND spamkey = 'System' GROUP BY DAY(time) ORDER BY id DESC",
									$spam_master_today_minus_7, $spam_master_today
));
if(!empty($total_system)){
?>
<table class="wp-list-table widefat fixed striped table-view-list" cellspacing="0">
	<thead>
		<tr></tr>
	</thead>

	<tfoot>
		<tr></tr>
	</tfoot>

	<tbody>
		<tr>
<script type="text/javascript">
      google.charts.load('current', {'packages':['corechart']});
      google.charts.setOnLoadCallback(drawChart);

      function drawChart() {
        var data = google.visualization.arrayToDataTable([
          ['Day', 'Entries'],
			<?php 
			foreach($total_system as $spam_system){
			$day_system = $spam_system->day;
			$month_system = $spam_system->month;
			$value_system = $spam_system->total;
			?>
			['<?php echo $day_system  .' ' . date("M", mktime(0, 0, 0, $month_system, 10)); ?>', <?php echo $value_system; ?>],
			<?php
			}
			?>
        ]);

        var options = {
          title: '7 Days - System Entries',
          chartArea: {
	        width: "90%",
			},
          curveType: 'function',
          legend: { position: 'bottom' },
          series: {
			0: { color: '#E8052B', pointSize: '10'}
		   },
			logScale:true,
        };

        var chart = new google.visualization.LineChart(document.getElementById('curve_chart_1'));

        chart.draw(data, options);
      }
</script>
<div id="curve_chart_1" class="spam-master-admin-firewall-curve-chart"></div>
		</tr>
	</tbody>
</table>
<div class="spam-master-pad-table"></div>
<?php
}
else{
	?>
<div class="spam-master-pad-table"></div>
	<?php
}

//DB Checks
$spam_master_firewall_total_blocked = $wpdb->get_var( "SELECT COUNT(*) FROM $spam_master_keys WHERE spamkey != 'System'" );
$spam_master_registrations_total_blocked = $wpdb->get_var( "SELECT COUNT(*) FROM $spam_master_keys WHERE spamkey = 'Registration'" );
$spam_master_comments_total_blocked = $wpdb->get_var( "SELECT COUNT(*) FROM $spam_master_keys WHERE spamkey = 'Comment'" );
$spam_master_contact_total_blocked = $wpdb->get_var( "SELECT COUNT(*) FROM $spam_master_keys WHERE spamkey = 'Contact-Form'" );
$spam_master_honeypot_total_blocked = $wpdb->get_var( "SELECT COUNT(*) FROM $spam_master_keys WHERE spamkey = 'Honeypot'" );
$spam_master_recaptcha_total_blocked = $wpdb->get_var( "SELECT COUNT(*) FROM $spam_master_keys WHERE spamkey = 'recaptcha'" );
$spam_master_woocommerce_total_blocked = $wpdb->get_var( "SELECT COUNT(*) FROM $spam_master_keys WHERE spamkey = 'Woocommerce'" );
$spam_master_system_total = $wpdb->get_var( "SELECT COUNT(*) FROM $spam_master_keys WHERE spamkey = 'System'" );
$spam_master_buffer_total = $wpdb->get_var( "SELECT COUNT(*) FROM $spam_master_threats" );
$spam_master_logs_total = $wpdb->get_var( "SELECT COUNT(*) FROM $spam_master_keys" );
$spam_master_whitelist_total = $wpdb->get_var( "SELECT COUNT(*) FROM $spam_master_white" );

///STATUS VALID
if ($response_key == 'VALID'){
	if($firewall_active == 'true'){
		$firewall_color = 'spam-master-top-admin-green';
		$firewall_status = __('ONLINE', 'spam_master');
	}
	else{
		$firewall_color = 'spam-master-top-admin-green';
		$firewall_status = __('OFFLINE, ACTIVATE FIREWALL IN PROTECTION TOOLS', 'spam_master');
	}
	$full_rbl_color = 'spam-master-top-admin-green';
	$full_rbl_status = __('OPTIMAL CONNECTION', 'spam_master');
	$learning_color = 'spam-master-top-admin-green';
	$learning_status = __('ONLINE', 'spam_master');
	$alert_color = 'spam-master-top-admin-green';
	$protection_number_color = 'spam-master-top-admin-green';
	if( is_multisite() ){
		$alert_level = get_blog_option($blog_id, 'spam_master_alert_level');
		$alert_date = get_blog_option($blog_id, 'spam_master_alert_level_date');
		$spam_master_user_registrations = $wpdb->get_var("SELECT COUNT(umeta_id) FROM {$table_prefix}usermeta WHERE meta_key='primary_blog' AND meta_value={$blog_id}");
		$spam_master_block_count = get_blog_option($blog_id, 'spam_master_block_count');
		$protection_total_number = get_blog_option($blog_id, 'spam_master_protection_total_number');
	}
	else{
		$alert_level = get_option('spam_master_alert_level');
		$alert_date = get_option('spam_master_alert_level_date');
		$spam_master_user_registrations = $wpdb->get_var("SELECT COUNT(ID) FROM $wpdb->users");
		$spam_master_block_count = get_option('spam_master_block_count');
		$protection_total_number = get_option('spam_master_protection_total_number');
	}
}
///MALFUNCTION_1
if ($response_key == 'MALFUNCTION_1'){
	if($firewall_active == 'true'){
		$firewall_color = 'spam-master-top-admin-orange';
		$firewall_status = __('ONLINE', 'spam_master');
	}
	else{
		$firewall_color = 'spam-master-top-admin-orange';
		$firewall_status = __('OFFLINE, ACTIVATE FIREWALL IN PROTECTION TOOLS', 'spam_master');
	}
	$full_rbl_color = 'spam-master-top-admin-orange';
	$full_rbl_status = __('MALFUNCTION_1 CONNECTION', 'spam_master');
	$learning_color = 'spam-master-top-admin-orange';
	$learning_status = __('MALFUNCTION_1 ONLINE', 'spam_master');
	$alert_color = 'spam-master-top-admin-orange';
	$protection_number_color = 'spam-master-top-admin-orange';
	if( is_multisite() ){
		$alert_level = get_blog_option($blog_id, 'spam_master_alert_level');
		$alert_date = get_blog_option($blog_id, 'spam_master_alert_level_date');
		$spam_master_user_registrations = $wpdb->get_var("SELECT COUNT(umeta_id) FROM {$table_prefix}usermeta WHERE meta_key='primary_blog' AND meta_value={$blog_id}");
		$spam_master_block_count = get_blog_option($blog_id, 'spam_master_block_count');
		$protection_total_number = get_blog_option($blog_id, 'spam_master_protection_total_number');
	}
	else{
		$alert_level = get_option('spam_master_alert_level');
		$alert_date = get_option('spam_master_alert_level_date');
		$spam_master_user_registrations = $wpdb->get_var("SELECT COUNT(ID) FROM $wpdb->users");
		$spam_master_block_count = get_option('spam_master_block_count');
		$protection_total_number = get_option('spam_master_protection_total_number');
	}
}
///MALFUNCTION_2
if ($response_key == 'MALFUNCTION_2'){
	if($firewall_active == 'true'){
		$firewall_color = 'spam-master-top-admin-orangina';
		$firewall_status = __('ONLINE', 'spam_master');
	}
	else{
		$firewall_color = 'spam-master-top-admin-orangina';
		$firewall_status = __('OFFLINE, ACTIVATE FIREWALL IN PROTECTION TOOLS', 'spam_master');
	}
	$full_rbl_color = 'spam-master-top-admin-orangina';
	$full_rbl_status = __('MALFUNCTION_2 CONNECTION', 'spam_master');
	$learning_color = 'spam-master-top-admin-orangina';
	$learning_status = __('MALFUNCTION_2 ONLINE', 'spam_master');
	$alert_color = 'spam-master-top-admin-orangina';
	$protection_number_color = 'spam-master-top-admin-orangina';
	if( is_multisite() ){
		$alert_level = get_blog_option($blog_id, 'spam_master_alert_level');
		$alert_date = get_blog_option($blog_id, 'spam_master_alert_level_date');
		$spam_master_user_registrations = $wpdb->get_var("SELECT COUNT(umeta_id) FROM {$table_prefix}usermeta WHERE meta_key='primary_blog' AND meta_value={$blog_id}");
		$spam_master_block_count = get_blog_option($blog_id, 'spam_master_block_count');
		$protection_total_number = get_blog_option($blog_id, 'spam_master_protection_total_number');
	}
	else{
		$alert_level = get_option('spam_master_alert_level');
		$alert_date = get_option('spam_master_alert_level_date');
		$spam_master_user_registrations = $wpdb->get_var("SELECT COUNT(ID) FROM $wpdb->users");
		$spam_master_block_count = get_option('spam_master_block_count');
		$protection_total_number = get_option('spam_master_protection_total_number');
	}
}
///MALFUNCTION_3
if ($response_key == 'MALFUNCTION_3'){
	if($firewall_active == 'true'){
		$firewall_color = 'spam-master-top-admin-red';
		$firewall_status = __('OFFLINE', 'spam_master');
	}
	else{
		$firewall_color = 'spam-master-top-admin-red';
		$firewall_status = __('OFFLINE', 'spam_master');
	}
	$full_rbl_color = 'spam-master-top-admin-red';
	$full_rbl_status = __('MALFUNCTION_3 CONNECTION', 'spam_master');
	$learning_color = 'spam-master-top-admin-red';
	$learning_status = __('MALFUNCTION_3 OFFLINE', 'spam_master');
	$alert_color = 'spam-master-top-admin-red';
	$alert_level = __('MALFUNCTION_3 OFFLINE', 'spam_master');
	$alert_date = __('No Sync date', 'spam_master');
	$protection_total_number = '0';
	$protection_number_color = 'spam-master-top-admin-red';
	if( is_multisite() ){
		$spam_master_user_registrations = $wpdb->get_var("SELECT COUNT(umeta_id) FROM {$table_prefix}usermeta WHERE meta_key='primary_blog' AND meta_value={$blog_id}");
		$spam_master_block_count = get_blog_option($blog_id, 'spam_master_block_count');
	}
	else{
		$spam_master_user_registrations = $wpdb->get_var("SELECT COUNT(ID) FROM $wpdb->users");
		$spam_master_block_count = get_option('spam_master_block_count');
	}
}
//STATUS EXPIRED
if ($response_key == 'EXPIRED'){
	if($firewall_active == 'true'){
		$firewall_color = 'spam-master-top-admin-red';
		$firewall_status = __('OFFLINE', 'spam_master');
	}
	else{
		$firewall_color = 'spam-master-top-admin-red';
		$firewall_status = __('OFFLINE', 'spam_master');
	}
	$full_rbl_color = 'spam-master-top-admin-red';
	$full_rbl_status = __('DISCONNECTED', 'spam_master');
	$learning_color = 'spam-master-top-admin-red';
	$learning_status = __('OFFLINE', 'spam_master');
	$alert_color = 'spam-master-top-admin-red';
	$alert_level = __('DISCONNECTED', 'spam_master');
	$alert_date = __('No Sync date', 'spam_master');
	$protection_number_color = 'spam-master-top-admin-red';
	$protection_total_number = '0';
	if( is_multisite() ){
		$spam_master_user_registrations = $wpdb->get_var("SELECT COUNT(umeta_id) FROM {$table_prefix}usermeta WHERE meta_key='primary_blog' AND meta_value={$blog_id}");
		$spam_master_block_count = get_blog_option($blog_id, 'spam_master_block_count');
	}
	else{
		$spam_master_user_registrations = $wpdb->get_var("SELECT COUNT(ID) FROM $wpdb->users");
		$spam_master_block_count = get_option('spam_master_block_count');
	}
}
//STATUS INACTIVE, NO LICENSE SENT YET
if ($response_key == 'INACTIVE'){
	if($firewall_active == 'true'){
		$firewall_color = 'spam-master-top-admin-yellow';
		$firewall_status = __('OFFLINE', 'spam_master');
	}
	else{
		$firewall_color = 'spam-master-top-admin-yellow';
		$firewall_status = __('OFFLINE', 'spam_master');
	}
	$full_rbl_color = 'spam-master-top-admin-yellow';
	$full_rbl_status = __('DISCONNECTED', 'spam_master');
	$learning_color = 'spam-master-top-admin-yellow';
	$learning_status = __('OFFLINE', 'spam_master');
	$alert_color = 'spam-master-top-admin-yellow';
	$alert_level = __('DISCONNECTED', 'spam_master');
	$alert_date = __('No Sync date', 'spam_master');
	$protection_number_color = 'spam-master-top-admin-yellow';
	$protection_total_number = '0';
	if( is_multisite() ){
		$spam_master_user_registrations = $wpdb->get_var("SELECT COUNT(umeta_id) FROM {$table_prefix}usermeta WHERE meta_key='primary_blog' AND meta_value={$blog_id}");
		$spam_master_block_count = get_blog_option($blog_id, 'spam_master_block_count');
	}
	else{
		$spam_master_user_registrations = $wpdb->get_var("SELECT COUNT(ID) FROM $wpdb->users");
		$spam_master_block_count = get_option('spam_master_block_count');
	}
}
//STATUS UNSTABLE, NO LICENSE SENT YET
if ($response_key == 'UNSTABLE'){
	if($firewall_active == 'true'){
		$firewall_color = 'spam-master-top-admin-yellow';
		$firewall_status = __('OFFLINE', 'spam_master');
	}
	else{
		$firewall_color = 'spam-master-top-admin-shadow-yellow';
		$firewall_status = __('OFFLINE', 'spam_master');
	}
	$full_rbl_color = 'spam-master-top-admin-yellow';
	$full_rbl_status = __('DISCONNECTED', 'spam_master');
	$learning_color = 'spam-master-top-admin-yellow';
	$learning_status = __('OFFLINE', 'spam_master');
	$alert_color = 'spam-master-top-admin-yellow';
	$alert_level = __('DISCONNECTED', 'spam_master');
	$alert_date = __('No Sync date', 'spam_master');
	$protection_number_color = 'spam-master-top-admin-yellow';
	$protection_total_number = '0';
	if( is_multisite() ){
		$spam_master_user_registrations = $wpdb->get_var("SELECT COUNT(umeta_id) FROM {$table_prefix}usermeta WHERE meta_key='primary_blog' AND meta_value={$blog_id}");
		$spam_master_block_count = get_blog_option($blog_id, 'spam_master_block_count');
	}
	else{
		$spam_master_user_registrations = $wpdb->get_var("SELECT COUNT(ID) FROM $wpdb->users");
		$spam_master_block_count = get_option('spam_master_block_count');
	}
}
//IF EMPTY DATA SET 0 for graph
if(empty($spam_master_user_registrations)){
	$spam_master_user_registrations = '0';
}
if(empty($spam_master_block_count)){
	$spam_master_block_count = '0';
}
if(empty($spam_master_firewall_total_blocked)){
	$spam_master_firewall_total_blocked = '0';
}
if(empty($spam_master_registrations_total_blocked)){
	$spam_master_registrations_total_blocked = '0';
}
if(empty($spam_master_comments_total_blocked)){
	$spam_master_comments_total_blocked = '0';
}
if(empty($spam_master_contact_total_blocked)){
	$spam_master_contact_total_blocked = '0';
}
if(empty($spam_master_honeypot_total_blocked)){
	$spam_master_honeypot_total_blocked = '0';
}
if(empty($spam_master_recaptcha_total_blocked)){
	$spam_master_recaptcha_total_blocked = '0';
}
if(empty($spam_master_woocommerce_total_blocked)){
	$spam_master_woocommerce_total_blocked = '0';
}
if(empty($spam_master_logs_total)){
	$spam_master_logs_total = '0';
}
if(empty($spam_master_system_total)){
	$spam_master_system_total = '0';
}
if(empty($spam_master_buffer_total)){
	$spam_master_buffer_total = '0';
}
if(empty($spam_master_whitelist_total)){
	$spam_master_whitelist_total = '0';
}
//SET TABLE DATA
?>
<table class="wp-list-table widefat fixed striped table-view-list" cellspacing="0">
	<thead>
		<tr>
			<th colspan="2">
					<script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
					<script type="text/javascript">
						google.charts.load('current', {'packages':['corechart']});
						google.charts.setOnLoadCallback(drawVisualization);


					function drawVisualization() {
					// Some raw data (not necessarily accurate)
					var data = google.visualization.arrayToDataTable([
					['', 'Users', 'Blocks', 'Firewall', 'Registrations', 'Comments', 'Contacts', 'Honeypot', 'reCaptcha', 'Woocommerce', 'WhiteList', 'Buffer', 'Logs'],
					['',
					<?php echo $spam_master_user_registrations; ?>, 
					<?php echo $spam_master_block_count; ?>, 
					<?php echo $spam_master_firewall_total_blocked; ?>, 
					<?php echo $spam_master_registrations_total_blocked; ?>, 
					<?php echo $spam_master_comments_total_blocked; ?>, 
					<?php echo $spam_master_contact_total_blocked; ?>, 
					<?php echo $spam_master_honeypot_total_blocked; ?>, 
					<?php echo $spam_master_recaptcha_total_blocked; ?>, 
					<?php echo $spam_master_woocommerce_total_blocked; ?>,
					<?php echo $spam_master_whitelist_total; ?>, 
					<?php echo $spam_master_buffer_total; ?>,  
					<?php echo $spam_master_logs_total; ?>]
					]);

					var options = {
					title : '',
					legend: { position: 'right', maxLines: 1, textStyle: {fontSize: 12} },
					logScale:true,
					colors:[
						'#078BB3',
						'#A20822',
						'#E8052B',
						'#E1532D',
						'#F2AE41',
						'#F2DD41',
						'#f8fc7b',
						'#5deff7',
						'#96588a',
						'#479052',
						'#5ab167',
						'#a5c5aa'
					],
					chartArea: {
						width:'80%',
						height:'90%',
					},
					};

					var chart = new google.visualization.ColumnChart(document.getElementById('chart_div'));
					chart.draw(data, options);
					}
					</script>
					<div id="chart_div" class="spam-master-admin-firewall-curve-chart"></div>
				</th>
		</tr>
	</thead>

	<tfoot>
		<tr>
			<th colspan="2"></th>
		</tr>
	</tfoot>

	<tbody>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Total Users', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-blue"><?php echo number_format($spam_master_user_registrations); ?> <?php echo __('Registered', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Total Blocks', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-blue"><?php echo number_format($spam_master_block_count); ?> <?php echo __('blocks since beginning of time', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Firewall', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-blue"><?php echo number_format($spam_master_firewall_total_blocked); ?> <?php echo __('entries in logs', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Registrations', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-blue"><?php echo number_format($spam_master_registrations_total_blocked); ?> <?php echo __('entries in logs', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Comments', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-blue"><?php echo number_format($spam_master_comments_total_blocked); ?> <?php echo __('entries in logs', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Contact Forms', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-blue"><?php echo number_format($spam_master_contact_total_blocked); ?> <?php echo __('entries in logs', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Honeypot', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-blue"><?php echo number_format($spam_master_honeypot_total_blocked); ?> <?php echo __('entries in logs', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('reCaptcha', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-blue"><?php echo number_format($spam_master_recaptcha_total_blocked); ?> <?php echo __('entries in logs', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Woocomerce', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-blue"><?php echo number_format($spam_master_woocommerce_total_blocked); ?> <?php echo __('entries in logs', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('System', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-blue"><?php echo number_format($spam_master_system_total); ?> <?php echo __('entries in logs', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Log Size Combined', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-blue"><?php echo number_format($spam_master_logs_total); ?> <?php echo __('entries in logs', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Spam Buffer', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-blue"><?php echo number_format($spam_master_buffer_total); ?> <?php echo __('entries', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('WhiteList', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-blue"><?php echo number_format($spam_master_whitelist_total); ?> <?php echo __('entries', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Protected Against', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font <?php echo $protection_number_color; ?>"><?php echo number_format($protection_total_number);?> <?php echo __('THREATS', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Threat Alert Level', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font <?php echo $alert_color; ?>"><?php echo __('DATE:', 'spam_master'); ?> <?php echo $alert_date;?> <?php echo __('- LEVEL:', 'spam_master'); ?> <?php echo $alert_level;?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Spam Learning', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font <?php echo $learning_color; ?>"><?php echo $learning_status; ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Firewall', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font <?php echo $firewall_color; ?>"><?php echo $firewall_status; ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
<?php
if(empty($spam_master_type) || $spam_master_type == 'INACTIVE' || $spam_master_type == 'EMPTY'){
?>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Primary RBL Server Cluster', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font <?php echo $full_rbl_color; ?>"><?php echo __('Cluster Status: INACTIVE - NO CONNECTION', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Secondary RBL Server Cluster', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font <?php echo $full_rbl_color; ?>"><?php echo __('Cluster Status: INACTIVE - NO CONNECTION', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Free RBL Server Cluster', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font <?php echo $full_rbl_color; ?>"><?php echo __('Cluster Status: INACTIVE - NO CONNECTION', 'spam_master'); ?></td>
		</tr>
<?php
}
if($spam_master_type == 'FREE' || $spam_master_type == 'TRIAL'){
?>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Primary RBL Server Cluster', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-red"><?php echo __('Cluster Status: DISCONNECTED - PRO LICENSE', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Secondary RBL Server Cluster', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-red"><?php echo __('Cluster Status: DISCONNECTED - PRO LICENSE', 'spam_master'); ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Free RBL Server Cluster', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font <?php echo $full_rbl_color; ?>"><?php echo __('Cluster Status: FREE CONNECTION', 'spam_master'); ?></td>
		</tr>
<?php
}
if($spam_master_type == 'FULL'){
?>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Primary RBL Server Cluster', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-green"><?php echo __('Cluster Status:', 'spam_master'); ?> <?php echo $full_rbl_status; ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
		<tr class="alternate">
			<td class="spam-master-admin-firewall-stats-td"><?php echo __('Secondary RBL Server Cluster', 'spam_master'); ?></td>
			<td class="spam-master-admin-firewall-stats-td-font spam-master-top-admin-green"><?php echo __('Cluster Status:', 'spam_master'); ?> <?php echo $full_rbl_status; ?></td>
		</tr>
		<tr>
			<td class="spam-master-admin-firewall-stats-td"></td>
			<td class="spam-master-admin-firewall-stats-td"></td>
		</tr>
<?php
}
?>
	</tbody>
</table>
<?php
		}
}
?>
