<?php
class spam_master_other_protection_table_firewall extends WP_List_Table {
	/**
	 * Display the rows of records in the table
	 * @return string, echo the markup of the rows
	 */
function display() {
global $wp_nonce, $current_user, $wpdb, $blog_id;

if(isset($_POST['update_firewall'])){

check_admin_referer( 'save-settings_spam_master_other_protection_table_firewall' );

//Remote Ip
$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
//Remote Agent
if(isset($_SERVER['HTTP_USER_AGENT'])){
	$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
}
else{
	$remote_agent = 'Sniffer';
}
// Remote Referer
if(isset($_SERVER['HTTP_REFERER'])){
	$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
}
else{
	$remote_referer = 'Direct';
}
// DEST URL
if(isset($_SERVER['REQUEST_URI'])){
	$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
}
else{
	$dest_url = 'Weird';
}
//exempt admins from check
if(!function_exists('wp_get_current_user')) {
	include(ABSPATH . "wp-includes/pluggable.php"); 
}
// Current User
$current_user_id = get_current_user_id();
if(isset($current_user_id)){
	$current_user_id = $current_user_id;
}
else{
	$current_user_id = 'none';
}
//Add Controllers
require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
//Log InUp Controller
$spamkey = 'System';
$spamco = 'localhost';
$spamcou = 'localhost';
$spamvalue = 'Protection Tools: Firewall updated.';
$SpamMasterLogController = new SpamMasterLogController;
$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

	if(is_multisite()){
		if (isset($_POST['spam_master_firewall_on'])){
			update_blog_option($blog_id, 'spam_master_firewall_on', sanitize_text_field($_POST['spam_master_firewall_on']) );
		}
		else{
			update_blog_option($blog_id, 'spam_master_firewall_on', 'true' );
		}
	}
	else{
		if (isset($_POST['spam_master_firewall_on'])){
			update_option('spam_master_firewall_on', sanitize_text_field($_POST['spam_master_firewall_on']) );
		}
		else{
			update_option('spam_master_firewall_on', 'true' );
		}
	}
?>
<div id="message" class="updated fade">
<p><?php echo __('Firewall Settings Saved!', 'spam_master'); ?></p>
</div>
<?php
}

if(is_multisite()){
	$spam_master_firewall_on = esc_html(get_blog_option($blog_id, 'spam_master_firewall_on'));
	$response_key = esc_html(get_blog_option($blog_id, 'spam_master_status'));
}
else{
	$spam_master_firewall_on = esc_html(get_option('spam_master_firewall_on'));
	$response_key = esc_html(get_option('spam_master_status'));
}
if(empty($response_key)){
	$response_key = "INACTIVE";
}
//generate statuses
if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
	if($spam_master_firewall_on == 'true'){
		$spam_master_firewall_status = '<td class="spam-master-middle-70 spam-master-top-admin-green" colspan="2"><font color="white"><b>ONLINE</b></font></td>';
	}
	else{
		$spam_master_firewall_status = '<td class="spam-master-middle-70 spam-master-top-admin-red" colspan="2"><font color="white"><b>OFFLINE</b></font></td>';
	}	
}
else{
	$spam_master_firewall_status = '<td class="spam-master-middle-70 spam-master-top-admin-red" colspan="2"><font color="white"><b>OFFLINE</b></font></td>';
}
?>
<form method="post" width='1'>
<fieldset class="options">
<?php $sec_nonce = wp_nonce_field( 'save-settings_spam_master_other_protection_table_firewall' ); ?>
<table class="wp-list-table widefat fixed striped table-view-list" cellspacing="0">
	<thead>
		<tr>
			<th colspan="3"><h2><img class="spam-master-admin-img" src="<?php echo plugins_url('../images/spammaster-logo.png', dirname(__FILE__)); ?>" /><?php echo __('&nbsp;Firewall', 'spam_master'); ?></h2></th>
		</tr>
	</thead>

	<tfoot>
		<tr><th colspan="3"><small><?php echo __('End Firewall Section', 'spam_master'); ?></small></th></tr>
	</tfoot>

	<tbody>
		<tr>
			<th colspan="3">
<p><?php echo __('The Firewall is a barrier designed to prevent unauthorized or unwanted communications between dangerous hosts and your website. It saves precious bandwidth for real users and blocks misfits. This setting is always On.', 'spam_master'); ?></p>
			</th>
		</tr>
		<tr>
			<td colspan="1">
				<input name="spam_master_firewall_on" id="spam_master_firewall_on" value="true" type="checkbox" <?php echo $spam_master_firewall_on == 'true' ? 'checked="checked"':''; ?> / disabled>
				<label for="spam_master_firewall_on"><b><?php echo __('Wordpress Firewall', 'spam_master'); ?></b></label>
			</td>
			<?php echo $spam_master_firewall_status; ?>
		</tr>
	</tbody>
</table>
<button type="submit" name="update_firewall" id="update_firewall" class="btn-spammaster blue roundedspam" href="#" title="<?php echo __('Save Firewall Settings', 'spam_master'); ?>"><?php echo __('Save Firewall Settings', 'spam_master'); ?></button>
</fieldset>
</form>
<?php
		}
}
