<?php
class spam_master_other_protection_table_rbl extends WP_List_Table {
	/**
	 * Display the rows of records in the table
	 * @return string, echo the markup of the rows
	 */
	function display() {
global $wp_nonce, $current_user, $wpdb, $blog_id;	
//GET RESPONSE KEY TO GENERATE
if( is_multisite() ){
$response_key = esc_html(get_blog_option($blog_id, 'spam_master_status'));
$spam_master_type = esc_html(get_blog_option($blog_id, 'spam_master_type'));
}
else{
$response_key = esc_html(get_option('spam_master_status'));
$spam_master_type = esc_html(get_option('spam_master_type'));
}
///STATUS VALID
if ($response_key == 'VALID'){
	if( is_multisite() ){
		$full_rbl_color = 'spam-master-top-admin-green';
		$full_rbl_status = __('OPTIMAL CONNECTION', 'spam_master');
	}
	else{
		$full_rbl_color = 'spam-master-top-admin-green';
		$full_rbl_status = __('OPTIMAL CONNECTION', 'spam_master');
	}
}
//STATUS MALFUNCTION_1
if ($response_key == 'MALFUNCTION_1'){
	if( is_multisite() ){
		$full_rbl_color = 'spam-master-top-admin-orange';
		$full_rbl_status = __('MALFUNCTION_1 CONNECTION', 'spam_master');
	}
	else{
		$full_rbl_color = 'spam-master-top-admin-orange';
		$full_rbl_status = __('MALFUNCTION_1 CONNECTION', 'spam_master');
	}
}
//STATUS MALFUNCTION_2
if ($response_key == 'MALFUNCTION_2'){
	if( is_multisite() ){
		$full_rbl_color = 'spam-master-top-admin-orangina';
		$full_rbl_status = __('MALFUNCTION_2 CONNECTION', 'spam_master');
	}
	else{
		$full_rbl_color = 'spam-master-top-admin-orangina';
		$full_rbl_status = __('MALFUNCTION_2 CONNECTION', 'spam_master');
	}
}
//STATUS MALFUNCTION_3
if ($response_key == 'MALFUNCTION_3'){
	if( is_multisite() ){
		$full_rbl_color = 'spam-master-top-admin-red';
		$full_rbl_status = __('MALFUNCTION_3 DISCONNECTED', 'spam_master');
	}
	else{
		$full_rbl_color = 'spam-master-top-admin-red';
		$full_rbl_status = __('MALFUNCTION_3 DISCONNECTED', 'spam_master');
	}
}
//STATUS EXPIRED
if ($response_key == 'EXPIRED'){
	if( is_multisite() ){
		$full_rbl_color = 'spam-master-top-admin-red';
		$full_rbl_status = __('DISCONNECTED', 'spam_master');
	}
	else{
		$full_rbl_color = 'spam-master-top-admin-red';
		$full_rbl_status = __('DISCONNECTED', 'spam_master');
	}
}
//STATUS INACTIVE, NO LICENSE SENT YET
if ($response_key == 'INACTIVE'){
	if( is_multisite() ){
		$full_rbl_color = 'spam-master-top-admin-yellow';
		$full_rbl_status = __('DISCONNECTED', 'spam_master');
	}
	else{
		$full_rbl_color = 'spam-master-top-admin-yellow';
		$full_rbl_status = __('DISCONNECTED', 'spam_master');
	}
}
//STATUS UNSTABLE, FREE SERVER
if ($response_key == 'INACTIVE'){
	if( is_multisite() ){
		$full_rbl_color = 'spam-master-top-admin-red';
		$full_rbl_status = __('DISCONNECTED', 'spam_master');
	}
	else{
		$full_rbl_color = 'spam-master-top-admin-red';
		$full_rbl_status = __('DISCONNECTED', 'spam_master');
	}
}
?>
<table class="wp-list-table widefat fixed striped table-view-list" cellspacing="0">
	<thead>
		<tr>
			<th colspan="2"><h2><img class="spam-master-admin-img" src="<?php echo plugins_url('../images/spammaster-logo.png', dirname(__FILE__)); ?>" /><?php echo __('&nbsp;RBL Servers', 'spam_master'); ?></h2></th>
		</tr>
	</thead>

	<tfoot>
		<tr><th colspan="2"><small><?php echo __('End RBL Servers Section', 'spam_master'); ?></small></th></tr>
	</tfoot>

	<tbody>
		<tr>
			<th colspan="2">
<p><?php echo __('RBL Servers status should be online if you have a valid RBL license. You can check detailed statistics of the servers status by clicking the button below.', 'spam_master'); ?></p>
<p><a class="btn-spammaster green roundedspam" href="https://www.spammaster.org/rbl-servers-status/" target="_blank" title="<?php echo __('Server Cluster Status', 'spam_master'); ?>"><?php echo __('Server Cluster Status', 'spam_master'); ?></a></p>
			</th>
		</tr>
<?php
if($spam_master_type == 'TRIAL' || $spam_master_type == 'FREE'){
?>
		<tr>
			<td class="spam-master-30"><?php echo __('Primary RBL Server Cluster', 'spam_master'); ?></td>
			<td class="spam-master-middle spam-master-top-admin-red"><font color="white"><b><?php echo __('DISCONNECTED - PRO LICENSE', 'spam_master'); ?></b></font>
			</td>
		<tr>
				<tr>
			<td class="spam-master-30"><?php echo __('Secondary RBL Server Cluster', 'spam_master'); ?></td>
			<td class="spam-master-middle spam-master-top-admin-red"><font color="white"><b><?php echo __('DISCONNECTED - PRO LICENSE', 'spam_master'); ?></b></font>
		</tr>
		<tr>
		<tr>
			<td class="spam-master-30"><?php echo __('Free RBL Server Cluster', 'spam_master'); ?></td>
			<td class="spam-master-middle <?php echo $full_rbl_color; ?>"><font color="white"><b><?php echo $full_rbl_status; ?></b></font>
		</tr>
<?php
}
if($spam_master_type == 'FULL'){
?>
		<tr>
			<td class="spam-master-30"><?php echo __('Primary RBL Business Server Cluster', 'spam_master'); ?></td>
			<td class="spam-master-middle <?php echo $full_rbl_color; ?>"><font color="white"><b><?php echo $full_rbl_status; ?></b></font>
		</tr>
		<tr>
			<td class="spam-master-30"><?php echo __('Secondary RBL Business Server Cluster', 'spam_master'); ?></td>
			<td class="spam-master-middle <?php echo $full_rbl_color; ?>"><font color="white"><b><?php echo $full_rbl_status; ?></b></font>
		</tr>
<?php
}
?>
	</tbody>
</table>
<?php
		}
}
