<?php
//post data if license status is valid
if(is_multisite()){
$response_key = get_blog_option($blog_id, 'spam_master_status');
$spam_master_comment_strict_on = get_blog_option($blog_id, 'spam_master_comment_strict_on');
}
else{
$response_key = get_option('spam_master_status');
$spam_master_comment_strict_on = get_option('spam_master_comment_strict_on');
}

//Set malfunctions as VALID
if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
	if($spam_master_comment_strict_on == 'true'){
		add_filter( 'pre_comment_approved', 'spam_master_comment_learning', 99, 2 );
		add_filter( 'pre_trackback_post', 'spam_master_comment_learning', 99, 2 );
		function spam_master_comment_learning($approved, $commentdata){
		global $wpdb, $blog_id;
			//create data to be posted
			if(is_multisite()){
				$blog_license_key = get_blog_option($blog_id, 'spam_license_key');
				$comment_russian_char = get_blog_option($blog_id, 'comment_russian_char');
				$comment_russian_char_set = get_blog_option($blog_id, 'spam_master_russian_char_set');
				$comment_chinese_char = get_blog_option($blog_id, 'comment_chinese_char');
				$comment_chinese_char_set = get_blog_option($blog_id, 'spam_master_chinese_char_set');
				$comment_asian_char = get_blog_option($blog_id, 'comment_asian_char');
				$comment_asian_char_set = get_blog_option($blog_id, 'spam_master_asian_char_set');
				$comment_arabic_char = get_blog_option($blog_id, 'comment_arabic_char');
				$comment_arabic_char_set = get_blog_option($blog_id, 'spam_master_arabic_char_set');
				$comment_spam_char = get_blog_option($blog_id, 'comment_spam_char');
				$comment_spam_char_set = get_blog_option($blog_id, 'spam_master_spam_char_set');
				$spam_master_alert_level = get_blog_option($blog_id, 'spam_master_alert_level');
				$spam_master_message = get_blog_option($blog_id, 'spam_master_message');
				
			}
			else{
				$blog_license_key = get_option('spam_license_key');
				$comment_russian_char = get_option('comment_russian_char');
				$comment_russian_char_set = get_option('spam_master_russian_char_set');
				$comment_chinese_char = get_option('comment_chinese_char');
				$comment_chinese_char_set = get_option('spam_master_chinese_char_set');
				$comment_asian_char = get_option('comment_asian_char');
				$comment_asian_char_set = get_option('spam_master_asian_char_set');
				$comment_arabic_char = get_option('comment_arabic_char');
				$comment_arabic_char_set = get_option('spam_master_arabic_char_set');
				$comment_spam_char = get_option('comment_spam_char');
				$comment_spam_char_set = get_option('spam_master_spam_char_set');
				$spam_master_alert_level = get_option('spam_master_alert_level');
				$spam_master_message = get_option('spam_master_message');
			}

			//Remote Ip
			$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
			//Remote Agent
			if(isset($_SERVER['HTTP_USER_AGENT'])){
				$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
			}
			else{
				$remote_agent = 'Sniffer';
			}
			// Remote Referer
			if(isset($_SERVER['HTTP_REFERER'])){
				$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
			}
			else{
				$remote_referer = 'Direct';
			}
			// DEST URL
			if(isset($_SERVER['REQUEST_URI'])){
				$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
			}
			else{
				$dest_url = 'Weird';
			}
			//exempt admins from check
			if(!function_exists('wp_get_current_user')) {
				include(ABSPATH . "wp-includes/pluggable.php"); 
			}
			// Current User
			$current_user_id = get_current_user_id();
			if(isset($current_user_id)){
				$current_user_id = $current_user_id;
			}
			else{
				$current_user_id = 'none';
			}

			//Add Controllers
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterBufferController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterFloodController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterWhiteController.php');

			//prepare threat buffer
			if (!empty($commentdata['comment_author_email'])) {
				if (filter_var($commentdata['comment_author_email'], FILTER_VALIDATE_EMAIL)) {
					$blog_threat_email = wp_strip_all_tags(substr($commentdata['comment_author_email'],0,256));
				}
				else{
					$blog_threat_email = 'comment@'.rand(10000000, 99999999).'.wp';
				}
			}
			else{
				$blog_threat_email = 'comment@'.rand(10000000, 99999999).'.wp';
			}

			//Create data to be posted
			$spam_master_leaning_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2NvbV8yLnBocA==';
			$blog_license_key = substr($blog_license_key,0,64);
			$blog_web_address = get_site_url();
			$address_unclean = $blog_web_address;
			$address_long = preg_replace('#^https?://#', '', $address_unclean);
			$address = substr($address_long,0,256);
			@$blog_server_ip = substr($_SERVER['SERVER_ADDR'],0,48);
			//if empty ip
			if(empty($blog_server_ip) || $blog_server_ip == '0'){
				@$blog_server_ip = 'I '.substr(gethostbyname($_SERVER['SERVER_NAME']),0,48);
			}

			//check Trackback or Comment
			if(is_trackback()){
				@$request_array = 'HTTP_POST_VARS';
				$blog_threat_type = 'trackback';

				$blog_threat_email = 'trackback@'.date('YmdHis').'.wp';
				$tb_url = $_POST['url'];
				if(empty($tb_url)){
					$tb_url = 'empty url';
				}
				$title  = $_POST['title'];
				if(empty($title)){
					$title = 'empty title';
				}
				$excerpt = $_POST['excerpt'];
				if(empty($excerpt)){
					$excerpt = 'empty excerpt';
				}
				$join_tbs = 'URL: '.$tb_url.' - NAME: '.$title.' - TITLE: '.$title.' - EXC: '.$excerpt;
				$result_comment_content_trim = substr($join_tbs,0,360);
				$result_comment_content_clean = wp_strip_all_tags(stripslashes_deep($result_comment_content_trim), true);
			}
			else{
				$blog_threat_type = 'comment';
				//stop process if comment ip is the same as server address
				if($remote_ip == $_SERVER['SERVER_ADDR']){
					//Log InUp Controller
					/////////////////////
					$spamkey = 'Comment';
					$spamco = 'localhost';
					$spamcou = 'localhost';
					$spamvalue = 'Blocked because server Ip is the same as comment Ip. Weird!';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

					return new WP_Error( 'require_valid_comment', __( '<strong>ERROR</strong>: the comment ip is the same as the web server address.' ), 200 );
				}
				$result_comment_content_trim = substr($commentdata['comment_content'],0,360);
				$result_comment_content_clean = wp_strip_all_tags(stripslashes_deep($result_comment_content_trim), true);
			}

			//Spam White Controller
			////////////////////////
			$SpamMasterWhiteController = new SpamMasterWhiteController;
			$is_spamadmin = $SpamMasterWhiteController->SpamMasterWhiteAdmin();
			if(!empty($is_spamadmin)){
				//Log InUp Controller
				$spamkey = 'Comment';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Approved by capable user and exempt from spam check.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

				$approved = '1';
				return $approved;
			}

			//Spam White Controller
			////////////////////////
			$SpamMasterWhiteController = new SpamMasterWhiteController;
			$is_white = $SpamMasterWhiteController->SpamMasterWhiteSearch($remote_ip, $blog_threat_email);
			if(!empty($is_white)){
				//Log InUp Controller
				$spamkey = 'Comment';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Approved by whitelist and exempt from spam check.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

				$approved = '1';
				return $approved;
			}

			//Spam Buffer Controller
			////////////////////////
			$SpamMasterBufferController = new SpamMasterBufferController;
			$is_buffer = $SpamMasterBufferController->SpamMasterBufferSearch($remote_ip, $blog_threat_email);
			if(!empty($is_buffer)){
				//Log InUp Controller
				/////////////////////
				$spamkey = 'Comment';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Blocked in comment by Spam Buffer. Email: '.$blog_threat_email.', Text: '.$result_comment_content_clean.'';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

				//Spam Buffer Controller
				////////////////////////
				$SpamMasterBufferController = new SpamMasterBufferController;
				$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

				$approved = 'spam';
				return new WP_Error( 'require_valid_email', __( '<strong>SPAM MASTER</strong>'. $spam_master_message.'' ), 200 );
				return $approved;
			}

			//Alert 3
			if ($spam_master_alert_level == 'ALERT_3'){
				//Flood Controller
				///////////////////////
				$spamkey = 'Comment';
				$SpamMasterFloodController = new SpamMasterFloodController;
				$is_flood_3 = $SpamMasterFloodController->SpamMasterAlert3($spamkey);
				if(!empty($is_flood_3)){
					//Log InUp Controller
					/////////////////////
					$spamkey = 'Comment';
					$spamco = 'localhost';
					$spamcou = 'localhost';
					$spamvalue = 'Alert 2/3 warning, comment flooding detected. Administration Exploit Attempt.';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

					//Spam Buffer Controller
					////////////////////////
					$SpamMasterBufferController = new SpamMasterBufferController;
					$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

					$approved = 'spam';
					return new WP_Error( 'require_valid_email', __( '<strong>SPAM MASTER</strong> Flood detected. Please wait a few minutes.' ), 200 );
					return $approved;
				}
			}

			//Flood Controller
			///////////////////////
			$spamkey = 'Comment';
			$SpamMasterFloodController = new SpamMasterFloodController;
			$is_flood = $SpamMasterFloodController->SpamMasterFlood($spamkey, $remote_ip);
			if(!empty($is_flood)){
				$spam_master_learning_post = array(
													'blog_license_key' => $blog_license_key,
													'blog_threat_ip' => $remote_ip,
													'blog_threat_type' => $blog_threat_type,
													'blog_threat_email' => $blog_threat_email,
													'blog_threat_content' => 'Comment Flood Count: ' . $is_flood,
													'blog_threat_agent' => $remote_agent,
													'blog_threat_refe' => $remote_referer,
													'blog_threat_dest' => $dest_url,
													'blog_web_adress' => $address,
													'blog_server_ip' => $blog_server_ip
				);
				$response = wp_remote_post( base64_decode($spam_master_learn_h_url), array(
																							'method' => 'POST',
																							'timeout' => 90,
																							'body' => $spam_master_learning_post
				));
				if ( is_wp_error( $response ) ) {
					$error_message = $response->get_error_message();
					//Log InUp Controller
					/////////////////////
					$spamkey = 'System';
					$spamco = 'localhost';
					$spamcou = 'localhost';
					$spamvalue = 'Error: Comment Flood. '.$error_message.'';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
					echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
				}
				else{
					$data = json_decode( wp_remote_retrieve_body( $response ), true );
					if(empty($data['threat'])){
						$spamco = $data['co'];
						$spamcou = $data['cou'];
						//Log InUp Controller
						/////////////////////
						$spamkey = 'Comment';
						$spamvalue = 'Blocked in comment by online RBL. Flood Count :' . $is_flood.' Email: '.$blog_threat_email.', Text: '.$result_comment_content_clean.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
					}
					else{
						$remote_ip = $data['threat'];
						$spamco = $data['co'];
						$spamcou = $data['cou'];							
						//Log InUp Controller
						/////////////////////
						$spamkey = 'Comment';
						$spamvalue = 'Blocked in comment by online RBL. Flood Count :' . $is_flood.' Email: '.$blog_threat_email.', Text: '.$result_comment_content_clean.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
					}
					//Spam Buffer Controller
					////////////////////////
					$SpamMasterBufferController = new SpamMasterBufferController;
					$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

					//Spam Buffer Controller
					////////////////////////
					$SpamMasterBufferController = new SpamMasterBufferController;
					$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();
				}

				$approved = 'spam';
				return new WP_Error( 'require_valid_email', __( '<strong>SPAM MASTER</strong>'. $spam_master_message.'' ), 200 );
				return $approved;
			}

			///////////////////////////////////
			//lets do a quick character block//
			///////////////////////////////////
			if ($comment_russian_char == 'true' || $comment_chinese_char == 'true' || $comment_asian_char == 'true' || $comment_arabic_char == 'true' || $comment_spam_char == 'true'){

				if ($comment_russian_char == 'true'){
					$blacklist_russian_char_string = $comment_russian_char_set;
					$blacklist_russian_char_array = explode("\n", $blacklist_russian_char_string);
					$blacklist_russian_char_size = sizeof($blacklist_russian_char_array);
					// Analyse List
					for($i = 0; $i < $blacklist_russian_char_size; $i++){
						$blacklist_russian_char_current = trim($blacklist_russian_char_array[$i]);
						//check buffer
						if(stripos($commentdata['comment_content'], $blacklist_russian_char_current) !== false){
							//Report
							$spam_master_learning_post = array(
																'blog_license_key' => $blog_license_key,
																'blog_threat_ip' => $remote_ip,
																'blog_threat_type' => $blog_threat_type,
																'blog_threat_email' => $blog_threat_email,
																'blog_threat_content' => 'Cyrillic Char: '. $blacklist_russian_char_current . 'Text: ' .$result_comment_content_clean,
																'blog_threat_agent' => $remote_agent,
																'blog_threat_refe' => $remote_referer,
																'blog_threat_dest' => $dest_url,
																'blog_web_adress' => $address,
																'blog_server_ip' => $blog_server_ip
							);
							$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																										'method' => 'POST',
																										'timeout' => 90,
																										'body' => $spam_master_learning_post
							));
							if ( is_wp_error( $response ) ) {
								$error_message = $response->get_error_message();
								//Log InUp Controller
								/////////////////////
								$spamkey = 'System';
								$spamco = 'localhost';
								$spamcou = 'localhost';
								$spamvalue = 'Blocked Cyrillic Char comment with error: Learning Comment. '.$error_message.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								echo "Something went wrong, please get in touch with TechGasp Support: $error_message";

								$approved = 'spam';
								return new WP_Error( 'require_valid_email', __( '<strong>SPAM MASTER</strong>'. $spam_master_message.'' ), 200 );
							}
							else{
								$data = json_decode( wp_remote_retrieve_body( $response ), true );
								if(empty($data['threat'])){
									$spamco = $data['co'];
									$spamcou = $data['cou'];
									//Log InUp Controller
									/////////////////////
									$spamkey = 'Comment';
									$spamvalue = 'Blocked Cyrillic Char by online RBL. Char: ' . $blacklist_russian_char_current . ', Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
									$SpamMasterLogController = new SpamMasterLogController;
									$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								}
								else{
									$remote_ip = $data['threat'];
									$spamco = $data['co'];
									$spamcou = $data['cou'];
									//Log InUp Controller
									/////////////////////
									$spamkey = 'Comment';
									$spamvalue = 'Blocked Cyrillic Char by online RBL. Char: ' . $blacklist_russian_char_current . ', Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
									$SpamMasterLogController = new SpamMasterLogController;
									$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								}
								//Spam Buffer Controller
								////////////////////////
								$SpamMasterBufferController = new SpamMasterBufferController;
								$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

								//Spam Buffer Controller
								////////////////////////
								$SpamMasterBufferController = new SpamMasterBufferController;
								$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

								$approved = 'spam';
								return new WP_Error( 'require_valid_email', __( '<strong>SPAM MASTER</strong>'. $spam_master_message.'' ), 200 );
							}
						return $approved;
						//end stripos
						}
					//end for
					}
				}
				if ($comment_chinese_char == 'true'){
					$blacklist_chinese_char_string = $comment_chinese_char_set;
					$blacklist_chinese_char_array = explode("\n", $blacklist_chinese_char_string);
					$blacklist_chinese_char_size = sizeof($blacklist_chinese_char_array);
					// Analyse List
					for($i = 0; $i < $blacklist_chinese_char_size; $i++){
						$blacklist_chinese_char_current = trim($blacklist_chinese_char_array[$i]);
						//check buffer
						if(stripos($commentdata['comment_content'], $blacklist_chinese_char_current) !== false){
							//Report
							$spam_master_learning_post = array(
																'blog_license_key' => $blog_license_key,
																'blog_threat_ip' => $remote_ip,
																'blog_threat_type' => $blog_threat_type,
																'blog_threat_email' => $blog_threat_email,
																'blog_threat_content' => 'Chinese Char: '. $blacklist_chinese_char_current . 'Text: ' .$result_comment_content_clean,
																'blog_threat_agent' => $remote_agent,
																'blog_threat_refe' => $remote_referer,
																'blog_threat_dest' => $dest_url,
																'blog_web_adress' => $address,
																'blog_server_ip' => $blog_server_ip
							);
							$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																										'method' => 'POST',
																										'timeout' => 90,
																										'body' => $spam_master_learning_post
							));
							if ( is_wp_error( $response ) ) {
								$error_message = $response->get_error_message();
								//Log InUp Controller
								/////////////////////
								$spamkey = 'System';
								$spamco = 'localhost';
								$spamcou = 'localhost';
								$spamvalue = 'Blocked Chinese Char comment with error: Learning Comment. '.$error_message.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								echo "Something went wrong, please get in touch with TechGasp Support: $error_message";

								$approved = 'spam';
								return new WP_Error( 'require_valid_email', __( '<strong>SPAM MASTER</strong>'. $spam_master_message.'' ), 200 );
							}
							else{
								$data = json_decode( wp_remote_retrieve_body( $response ), true );
								if(empty($data['threat'])){
									$spamco = $data['co'];
									$spamcou = $data['cou'];
									//Log InUp Controller
									/////////////////////
									$spamkey = 'Comment';
									$spamvalue = 'Blocked Chinese Char by online RBL. Char: ' . $blacklist_chinese_char_current . ', Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
									$SpamMasterLogController = new SpamMasterLogController;
									$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								}
								else{
									$remote_ip = $data['threat'];
									$spamco = $data['co'];
									$spamcou = $data['cou'];
									//Log InUp Controller
									/////////////////////
									$spamkey = 'Comment';
									$spamvalue = 'Blocked Chinese Char by online RBL. Char: ' . $blacklist_chinese_char_current . ', Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
									$SpamMasterLogController = new SpamMasterLogController;
									$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								}
								//Spam Buffer Controller
								////////////////////////
								$SpamMasterBufferController = new SpamMasterBufferController;
								$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

								//Spam Buffer Controller
								////////////////////////
								$SpamMasterBufferController = new SpamMasterBufferController;
								$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

								$approved = 'spam';
								return new WP_Error( 'require_valid_email', __( '<strong>SPAM MASTER</strong>'. $spam_master_message.'' ), 200 );
							}
						return $approved;
						//end stripos
						}
					//end for
					}
				}
				if ($comment_asian_char == 'true'){
					$blacklist_asian_char_string = $comment_asian_char_set;
					$blacklist_asian_char_array = explode("\n", $blacklist_asian_char_string);
					$blacklist_asian_char_size = sizeof($blacklist_asian_char_array);
					// Analyse List
					for($i = 0; $i < $blacklist_asian_char_size; $i++){
						$blacklist_asian_char_current = trim($blacklist_asian_char_array[$i]);
						//check buffer
						if(stripos($commentdata['comment_content'], $blacklist_asian_char_current) !== false){
							//Report
							$spam_master_learning_post = array(
																'blog_license_key' => $blog_license_key,
																'blog_threat_ip' => $remote_ip,
																'blog_threat_type' => $blog_threat_type,
																'blog_threat_email' => $blog_threat_email,
																'blog_threat_content' => 'Asian Char: '. $blacklist_asian_char_current . 'Text: ' .$result_comment_content_clean,
																'blog_threat_agent' => $remote_agent,
																'blog_threat_refe' => $remote_referer,
																'blog_threat_dest' => $dest_url,
																'blog_web_adress' => $address,
																'blog_server_ip' => $blog_server_ip
							);
							$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																										'method' => 'POST',
																										'timeout' => 90,
																										'body' => $spam_master_learning_post
							));
							if ( is_wp_error( $response ) ) {
								$error_message = $response->get_error_message();
								//Log InUp Controller
								/////////////////////
								$spamkey = 'System';
								$spamco = 'localhost';
								$spamcou = 'localhost';
								$spamvalue = 'Blocked Asian Char comment with error: Learning Comment. '.$error_message.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								echo "Something went wrong, please get in touch with TechGasp Support: $error_message";

								$approved = 'spam';
								return new WP_Error( 'require_valid_email', __( '<strong>SPAM MASTER</strong>'. $spam_master_message.'' ), 200 );
							}
							else{
								$data = json_decode( wp_remote_retrieve_body( $response ), true );
								if(empty($data['threat'])){
									$spamco = $data['co'];
									$spamcou = $data['cou'];
									//Log InUp Controller
									/////////////////////
									$spamkey = 'Comment';
									$spamvalue = 'Blocked Asian Char by online RBL. Char: ' . $blacklist_asian_char_current . ', Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
									$SpamMasterLogController = new SpamMasterLogController;
									$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								}
								else{
									$remote_ip = $data['threat'];
									$spamco = $data['co'];
									$spamcou = $data['cou'];
									//Log InUp Controller
									/////////////////////
									$spamkey = 'Comment';
									$spamvalue = 'Blocked Asian Char by online RBL. Char: ' . $blacklist_asian_char_current . ', Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
									$SpamMasterLogController = new SpamMasterLogController;
									$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								}
								//Spam Buffer Controller
								////////////////////////
								$SpamMasterBufferController = new SpamMasterBufferController;
								$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

								//Spam Buffer Controller
								////////////////////////
								$SpamMasterBufferController = new SpamMasterBufferController;
								$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

								$approved = 'spam';
								return new WP_Error( 'require_valid_email', __( '<strong>SPAM MASTER</strong>'. $spam_master_message.'' ), 200 );
							}
						return $approved;
						//end stripos
						}
					//end for
					}
				}
				if ($comment_arabic_char == 'true'){
					$blacklist_arabic_char_string = $comment_arabic_char_set;
					$blacklist_arabic_char_array = explode("\n", $blacklist_arabic_char_string);
					$blacklist_arabic_char_size = sizeof($blacklist_arabic_char_array);
					// Analyse List
					for($i = 0; $i < $blacklist_arabic_char_size; $i++){
						$blacklist_arabic_char_current = trim($blacklist_arabic_char_array[$i]);
						//check buffer
						if(stripos($commentdata['comment_content'], $blacklist_arabic_char_current) !== false){
							//Report
							$spam_master_learning_post = array(
																'blog_license_key' => $blog_license_key,
																'blog_threat_ip' => $remote_ip,
																'blog_threat_type' => $blog_threat_type,
																'blog_threat_email' => $blog_threat_email,
																'blog_threat_content' => 'Arabic Char: '. $blacklist_arabic_char_current . 'Text: ' .$result_comment_content_clean,
																'blog_threat_agent' => $remote_agent,
																'blog_threat_refe' => $remote_referer,
																'blog_threat_dest' => $dest_url,
																'blog_web_adress' => $address,
																'blog_server_ip' => $blog_server_ip
							);
							$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																										'method' => 'POST',
																										'timeout' => 90,
																										'body' => $spam_master_learning_post
							));
							if ( is_wp_error( $response ) ) {
								$error_message = $response->get_error_message();
								//Log InUp Controller
								/////////////////////
								$spamkey = 'System';
								$spamco = 'localhost';
								$spamcou = 'localhost';
								$spamvalue = 'Blocked Arabic Char comment with error: Learning Comment. '.$error_message.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								echo "Something went wrong, please get in touch with TechGasp Support: $error_message";

								$approved = 'spam';
								return new WP_Error( 'require_valid_email', __( '<strong>SPAM MASTER</strong>'. $spam_master_message.'' ), 200 );
							}
							else{
								$data = json_decode( wp_remote_retrieve_body( $response ), true );
								if(empty($data['threat'])){
									$spamco = $data['co'];
									$spamcou = $data['cou'];
									//Log InUp Controller
									/////////////////////
									$spamkey = 'Comment';
									$spamvalue = 'Blocked Arabic Char by online RBL. Char: ' . $blacklist_arabic_char_current . ', Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
									$SpamMasterLogController = new SpamMasterLogController;
									$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								}
								else{
									$remote_ip = $data['threat'];
									$spamco = $data['co'];
									$spamcou = $data['cou'];
									//Log InUp Controller
									/////////////////////
									$spamkey = 'Comment';
									$spamvalue = 'Blocked Arabic Char by online RBL. Char: ' . $blacklist_arabic_char_current . ', Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
									$SpamMasterLogController = new SpamMasterLogController;
									$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								}
								//Spam Buffer Controller
								////////////////////////
								$SpamMasterBufferController = new SpamMasterBufferController;
								$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

								//Spam Buffer Controller
								////////////////////////
								$SpamMasterBufferController = new SpamMasterBufferController;
								$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

								$approved = 'spam';
								return new WP_Error( 'require_valid_email', __( '<strong>SPAM MASTER</strong>'. $spam_master_message.'' ), 200 );
							}
						return $approved;
						//end stripos
						}
					//end for
					}
				}
				if ($comment_spam_char == 'true'){
					$blacklist_spam_char_string = $comment_spam_char_set;
					$blacklist_spam_char_array = explode("\n", $blacklist_spam_char_string);
					$blacklist_spam_char_size = sizeof($blacklist_spam_char_array);
					// Analyse List
					for($i = 0; $i < $blacklist_spam_char_size; $i++){
						$blacklist_spam_char_current = trim($blacklist_spam_char_array[$i]);
						//check buffer
						if(stripos($commentdata['comment_content'], $blacklist_spam_char_current) !== false){
							//Report
							$spam_master_learning_post = array(
																'blog_license_key' => $blog_license_key,
																'blog_threat_ip' => $remote_ip,
																'blog_threat_type' => $blog_threat_type,
																'blog_threat_email' => $blog_threat_email,
																'blog_threat_content' => 'Spam Char: '. $blacklist_spam_char_current . 'Text: ' .$result_comment_content_clean,
																'blog_threat_agent' => $remote_agent,
																'blog_threat_refe' => $remote_referer,
																'blog_threat_dest' => $dest_url,
																'blog_web_adress' => $address,
																'blog_server_ip' => $blog_server_ip
							);
							$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																										'method' => 'POST',
																										'timeout' => 90,
																										'body' => $spam_master_learning_post
							));
							if ( is_wp_error( $response ) ) {
								$error_message = $response->get_error_message();
								//Log InUp Controller
								/////////////////////
								$spamkey = 'System';
								$spamco = 'localhost';
								$spamcou = 'localhost';
								$spamvalue = 'Blocked Spam Char comment with error: Learning Comment. '.$error_message.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								echo "Something went wrong, please get in touch with TechGasp Support: $error_message";

								$approved = 'spam';
								return new WP_Error( 'require_valid_email', __( '<strong>SPAM MASTER</strong>'. $spam_master_message.'' ), 200 );
							}
							else{
								$data = json_decode( wp_remote_retrieve_body( $response ), true );
								if(empty($data['threat'])){
									$spamco = $data['co'];
									$spamcou = $data['cou'];
									//Log InUp Controller
									/////////////////////
									$spamkey = 'Comment';
									$spamvalue = 'Blocked Spam Char by online RBL. Char: ' . $blacklist_spam_char_current . ', Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
									$SpamMasterLogController = new SpamMasterLogController;
									$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								}
								else{
									$remote_ip = $data['threat'];
									$spamco = $data['co'];
									$spamcou = $data['cou'];
									//Log InUp Controller
									/////////////////////
									$spamkey = 'Comment';
									$spamvalue = 'Blocked Spam Char by online RBL. Char: ' . $blacklist_spam_char_current . ', Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
									$SpamMasterLogController = new SpamMasterLogController;
									$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
								}
								//Spam Buffer Controller
								////////////////////////
								$SpamMasterBufferController = new SpamMasterBufferController;
								$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

								//Spam Buffer Controller
								////////////////////////
								$SpamMasterBufferController = new SpamMasterBufferController;
								$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

								$approved = 'spam';
								return new WP_Error( 'require_valid_email', __( '<strong>SPAM MASTER</strong>'. $spam_master_message.'' ), 200 );
							}
						return $approved;
						//End Stripos
						}
					//End for
					}
				}
			//End Char Check
			}

			/////////////////////////////////
			//lets process RBL check
			//Report
			$spam_master_learning_post = array(
												'blog_license_key' => $blog_license_key,
												'blog_threat_ip' => $remote_ip,
												'blog_threat_type' => $blog_threat_type,
												'blog_threat_email' => $blog_threat_email,
												'blog_threat_content' => $result_comment_content_clean,
												'blog_threat_agent' => $remote_agent,
												'blog_threat_refe' => $remote_referer,
												'blog_threat_dest' => $dest_url,
												'blog_web_adress' => $address,
												'blog_server_ip' => $blog_server_ip
			);
			$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																						'method' => 'POST',
																						'timeout' => 90,
																						'body' => $spam_master_learning_post
			));
			if ( is_wp_error( $response ) ) {
				$error_message = $response->get_error_message();
				//Log InUp Controller
				/////////////////////
				$spamkey = 'System';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Error: Learning Comment. '.$error_message.'';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
				//Log InUp Controller
				/////////////////////
				$spamkey = 'Comment';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Approved with error, Email: ' . $blog_threat_email .  ', Text: ' . $result_comment_content_clean.'';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

				$approved = '0';
				echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
				return $approved;
			}
			else{
				$data = json_decode( wp_remote_retrieve_body( $response ), true );
				if(empty($data['threat'])){
					$spamco = $data['co'];
					$spamcou = $data['cou'];
					//Log InUp Controller
					/////////////////////
					$spamkey = 'Comment';
					$spamvalue = 'Approved, Email: ' . $blog_threat_email .  ', Text: ' . $result_comment_content_clean.'';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

					$approved = '0';
				}
				else{
					$remote_ip = $data['threat'];
					$spamco = $data['co'];
					$spamcou = $data['cou'];
					//Spam Buffer Controller
					////////////////////////
					$SpamMasterBufferController = new SpamMasterBufferController;
					$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

					//Spam Buffer Controller
					////////////////////////
					$SpamMasterBufferController = new SpamMasterBufferController;
					$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

					//Log InUp Controller
					/////////////////////
					$spamkey = 'Comment';
					$spamvalue = 'Blocked by online RBL, Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

					$approved = 'spam';
					return new WP_Error( 'require_valid_email', __( '<strong>SPAM MASTER</strong>'. $spam_master_message.'' ), 200 );
				}
				return $approved;
			}
		//end func comments
		}
	//end spam_master_comment_strict_on
	}
//end valid
}
?>
