<?php
if(is_multisite()){
	$response_key = get_blog_option($blog_id, 'spam_master_status');
	$spam_master_cache_proxie = get_blog_option($blog_id, 'spam_master_cache_proxie');
	$spam_master_firewall_on = get_blog_option($blog_id, 'spam_master_firewall_on');
}
else{
	$response_key = get_option('spam_master_status');
	$spam_master_cache_proxie = get_option('spam_master_cache_proxie');
	$spam_master_firewall_on = get_option('spam_master_firewall_on');
}
if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){

	//Add Controllers
	require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterBufferController.php');
	require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
	require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterFloodController.php');
	require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterWhiteController.php');

	///////////////////////////////
	//IMPLEMENT FIREWALL FRONTEND//
	///////////////////////////////
	if ($spam_master_firewall_on == 'true'){

		add_action('init', 'spam_master_frontend_firewall', 1);
		function spam_master_frontend_firewall(){
		global $wpdb, $blog_id;

			if(is_multisite()){
				$spam_license_key = get_blog_option($blog_id, 'spam_license_key');
			}
			else{
				$blog_license_key = get_option('spam_license_key');
			}
			
			//Remote Ip
			$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
			//Remote Agent
			if(isset($_SERVER['HTTP_USER_AGENT'])){
				$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
			}
			else{
				$remote_agent = 'Sniffer';
			}
			// Remote Referer
			if(isset($_SERVER['HTTP_REFERER'])){
				$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
			}
			else{
				$remote_referer = 'Direct';
			}
			// DEST URL
			if(isset($_SERVER['REQUEST_URI'])){
				$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
			}
			else{
				$dest_url = 'Weird';
			}
			//exempt admins from check
			if(!function_exists('wp_get_current_user')) {
				include(ABSPATH . "wp-includes/pluggable.php"); 
			}
			// Current User
			$current_user_id = get_current_user_id();
			if(isset($current_user_id)){
				$current_user_id = $current_user_id;
			}
			else{
				$current_user_id = 'none';
			}

			
			//Spam White Controller
			////////////////////////
			$blog_threat_email = false;
			$SpamMasterWhiteController = new SpamMasterWhiteController;
			$is_spamadmin = $SpamMasterWhiteController->SpamMasterWhiteAdmin();
			if(!empty($is_spamadmin)){
				if ( ! is_admin() ) {
					//Log InUp Controller
					$spamkey = 'Firewall';
					$spamco = 'localhost';
					$spamcou = 'localhost';
					$spamvalue = 'Approved by capable user and exempt from spam check.';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
				}
			}
			else{
				//Spam White Controller
				////////////////////////
				$blog_threat_email = false;
				$SpamMasterWhiteController = new SpamMasterWhiteController;
				$is_white = $SpamMasterWhiteController->SpamMasterWhiteSearch($remote_ip, $blog_threat_email);
				if(!empty($is_white)){
					if ( ! is_admin() ) {
						//Log InUp Controller
						$spamkey = 'Firewall';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Approved by whitelist and exempt from spam check.';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
					}
				}
				else{
					//Spam Buffer Controller
					////////////////////////
					$blog_threat_email = false;
					$SpamMasterBufferController = new SpamMasterBufferController;
					$is_buffer = $SpamMasterBufferController->SpamMasterBufferSearch($remote_ip, $blog_threat_email);
					if(!empty($is_buffer)){

						//Log InUp Controller
						$spamkey = 'Firewall';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Firewall Trigger Blocked in Spam Buffer.';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

						//Firewall Page
						$page = home_url( '/firewall/' );
						wp_safe_redirect($page);
						exit();

					}
					else{
						//Token
						$pam_master_length = 25;
						$spam_master_token = bin2hex(random_bytes($pam_master_length));
						//Session
						session_start();
						if(isset($_SESSION["spam-master-token"])){
						}
						else{
							$_SESSION["spam-master-token"] = $spam_master_token;
						}
						//Cookie
						if(isset($_COOKIE["spam-master-token"])) {
						}
						else{
							$cookie_options = array(
							  'expires' => time() + 3600,
							  'path' => '/',
							  'domain' => '.'.$_SERVER['SERVER_NAME'],
							  'secure' => true,
							  'httponly' => false,
							  'samesite' => 'None'
							);
							setcookie("spam-master-token", $spam_master_token, $cookie_options);
						}
					}
				}
			}
		// End Firewall Func
		}
	// End Firewall True
	}

	////////////////////////////
	//IMPLEMENT PROXY FRONTEND//
	////////////////////////////
	if($spam_master_cache_proxie == 'true'){
		//Cache Control
		add_action( 'init', 'spam_master_no_cache' );
		function spam_master_no_cache() {
		global $wpdb, $blog_id;

			session_cache_limiter("");
			header("Cache-Control: no-store, no-cache, must-revalidate, max-age=0");
			header("Cache-Control: post-check=0, pre-check=0", false);
			header("Pragma: no-cache");
			if( !session_id() ){
				session_start();
			}
		}
	}

// End Valid
}
?>
