<?php
if(is_multisite()){
	$response_key = get_blog_option($blog_id, 'spam_master_status');
	$spam_master_honeypot_timetrap = get_blog_option($blog_id, 'spam_master_honeypot_timetrap');
	$spam_master_honeypot_timetrap_speed = get_blog_option($blog_id, 'spam_master_honeypot_timetrap_speed');
}
else{
	$response_key = get_option('spam_master_status');
	$spam_master_honeypot_timetrap = get_option('spam_master_honeypot_timetrap');
	$spam_master_honeypot_timetrap_speed = get_option('spam_master_honeypot_timetrap_speed');
}
if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){

	if ($spam_master_honeypot_timetrap == 'true'){
		//MULTISITE HOOKS
		if(is_multisite()){
			add_action('signup_extra_fields', 'spam_master_honeypot_register_field', 20 );
			add_filter('wpmu_validate_user_signup', 'spam_master_honeypot_register_errors_multi', 20);
			add_action('comment_form_after_fields', 'spam_master_honeypot_register_field', 1);
			add_action('comment_form_logged_in_after', 'spam_master_honeypot_register_field', 1);
			add_filter('preprocess_comment', 'spam_master_verify_honey_comment_data', 10, 3 );
			add_filter('wpcf7_form_elements', 'spam_master_add_honeypot_to_form', 10, 1 );
			add_filter('wpcf7_spam', 'spam_master_contact_form_7_honeypot');
		}
		//SINGLE SITE HOOKS
		else{
			add_action('register_form', 'spam_master_honeypot_register_field' );
			add_action('login_form', 'spam_master_honeypot_register_field');
			add_action('comment_form_after_fields', 'spam_master_honeypot_register_field', 1);
			add_action('comment_form_logged_in_after', 'spam_master_honeypot_register_field', 1);
			add_filter('registration_errors', 'spam_master_honeypot_register_single_errors', 10, 3 );
			add_filter('login_errors', 'spam_master_honeypot_login_single_errors', 11, 1 );
			add_filter('preprocess_comment', 'spam_master_verify_honey_comment_data', 10, 3 );
			add_filter('wpcf7_form_elements', 'spam_master_add_honeypot_to_form', 10, 1 );
			add_filter('wpcf7_spam', 'spam_master_contact_form_7_honeypot');
			}

		//INSERT FIELD
		function spam_master_honeypot_register_field(){
			global $wpdb, $blog_id;

			//Reversed Ip
			$reverse_ip = strrev($_SERVER['REMOTE_ADDR']).'.'.bin2hex(random_bytes(12));

			?>
			<p class="spam-master-hidden">
			<label for="<?php echo $reverse_ip; ?>" class="spam-master-hidden"><?php echo $reverse_ip; ?><br>
			<input class="spam-master-hidden input" type="text" name="<?php echo $reverse_ip; ?>" id="<?php echo $reverse_ip; ?>" placeholder="<?php echo $reverse_ip; ?>" autocomplete="off" value="<?php echo $reverse_ip; ?>" />
			</label>
			</p>
			<noscript>
			<p class="spam-master-hidden">
			<label for="spammasterscript" class="spam-master-hidden">Js<br>
			<input class="input" type="text" name="spammasterscript" id="spammasterscript" placeholder="Spam Master Script" autocomplete="off" value="369golden" />
			</label>
			</p>
			</noscript>
			<p class="spam-master-hidden">
			<label for="mothers_name" class="spam-master-hidden"><?php _e( 'Mother Name', 'spam_master' ); ?><br>
			<input class="spam-master-hidden input" type="text" name="mothers_name" id="mothers_name" placeholder="Mother Name" autocomplete="off" value="" />
			</label>
			</p>
			<p class="spam-master-hidden">
			<label for="mothers_last_name" class="spam-master-hidden"><?php _e( 'Mother Last Name', 'spam_master' ); ?><br>
			<input class="spam-master-hidden input" type="text" name="mothers_last_name" id="mothers_last_name" placeholder="Mother Last Name" autocomplete="off" value="" />
			</label>
			</p>
			<?php
			if(isset($_SESSION["spam-master-token"]) && !empty($_SESSION["spam-master-token"])){
			?>
			<p class="spam-master-hidden">
			<label for="spam-master-token" class="spam-master-hidden"><?php _e( 'Spam Master Token', 'spam_master' ); ?><br>
			<input class="input" type="hidden" name="spam-master-token" id="spam-master-token" placeholder="Spam Master Token" autocomplete="off" value="<?php echo $_SESSION["spam-master-token"]; ?>" />
			</label>
			</p>
			<?php
			}
			if(isset($_COOKIE["spam-master-token"]) && !empty($_COOKIE["spam-master-token"])){
			?>
			<p class="spam-master-hidden">
			<label for="spam-master-token2" class="spam-master-hidden"><?php _e( 'Spam Master Token2', 'spam_master' ); ?><br>
			<input class="input" type="hidden" name="spam-master-token2" id="spam-master-token2" placeholder="Spam Master Token2" autocomplete="off" value="<?php echo $_COOKIE["spam-master-token"]; ?>" />
			</label>
			</p>
			<?php
			}
		//END FIELD
		}

		//START REGISTRATION ERRORS VALIDATION MULTI SITE
		function spam_master_honeypot_register_errors_multi($result){
			global $wpdb, $blog_id;
			
			//Remote Ip
			$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
			//Remote Agent
			if(isset($_SERVER['HTTP_USER_AGENT'])){
				$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
			}
			else{
				$remote_agent = 'Sniffer';
			}
			// Remote Referer
			if(isset($_SERVER['HTTP_REFERER'])){
				$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
			}
			else{
				$remote_referer = 'Direct';
			}
			// DEST URL
			if(isset($_SERVER['REQUEST_URI'])){
				$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
			}
			else{
				$dest_url = 'Weird';
			}
			//exempt admins from check
			if(!function_exists('wp_get_current_user')) {
				include(ABSPATH . "wp-includes/pluggable.php"); 
			}
			// Current User
			$current_user_id = get_current_user_id();
			if(isset($current_user_id)){
				$current_user_id = $current_user_id;
			}
			else{
				$current_user_id = 'none';
			}

			//Add Controllers
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterBufferController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterFloodController.php');

			//Create data to be posted
			$blog_threat_type = 'honeypot';
			$blog_threat_type2 = 'honeypot 2';
			$blog_threat_type3 = 'flood';
			$spam_master_learn_h_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2hvbmV5XzIucGhw';
			$spam_master_learn_h2_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2hvbmV5Ml8yLnBocA==';
			$blog_license_key = substr(get_blog_option($blog_id, 'spam_license_key'),0,64);
			$blog_web_address = get_site_url();
			$address_unclean = $blog_web_address;
			$address_long = preg_replace('#^https?://#', '', $address_unclean);
			$address = substr($address_long,0,256);
			@$blog_server_ip = substr($_SERVER['SERVER_ADDR'],0,48);
			//if empty ip
			if(empty($blog_server_ip) || $blog_server_ip == '0'){
				@$blog_server_ip = 'I '.substr(gethostbyname($_SERVER['SERVER_NAME']),0,48);
			}

			//prepare threat buffer
			if (!empty($result['user_email'])) {
				if (filter_var($result['user_email'], FILTER_VALIDATE_EMAIL)) {
					$blog_threat_email = wp_strip_all_tags(substr($result['user_email'],0,256));
				}
				else{
					$blog_threat_email = 'honey_bot@'.rand(10000000, 99999999).'.wp';
				}
			}
			else{
				$blog_threat_email = 'honey_bot@'.rand(10000000, 99999999).'.wp';
			}

			//Spam Buffer Controller
			////////////////////////
			$SpamMasterBufferController = new SpamMasterBufferController;
			$is_buffer = $SpamMasterBufferController->SpamMasterBufferSearch($remote_ip, $blog_threat_email);
			if(!empty($is_buffer)){
				//Log InUp Controller
				/////////////////////
				$spamkey = 'Honeypot';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Blocked in registration by Spam Buffer.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

				//Spam Buffer Controller
				////////////////////////
				$SpamMasterBufferController = new SpamMasterBufferController;
				$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

				echo '<p class="error"><strong>SPAM MASTER</strong>'.get_blog_option($blog_id, 'spam_master_message').'</p>';
				exit();
			}
			else{
				//Check Alert or Flooding
				$spam_master_alert_level = get_blog_option($blog_id, 'spam_master_alert_level');
				if ($spam_master_alert_level == 'ALERT_3'){
					//Flood Controller
					///////////////////////
					$spamkey = 'Honeypot';
					$SpamMasterFloodController = new SpamMasterFloodController;
					$is_flood_3 = $SpamMasterFloodController->SpamMasterAlert3($spamkey);
					if(!empty($is_flood_3)){
						//Log InUp Controller
						/////////////////////
						$spamkey = 'Honeypot';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Alert 2/3 warning, honeypot registration flooding detected. Administration Exploit Attempt.';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

						echo '<p class="error"><strong>SPAM MASTER</strong> Flood detected. Please wait a few minutes.</p>';
						exit();
					}
				}
				else{
					//Flood Controller
					///////////////////////
					$spamkey = 'Honeypot';
					$SpamMasterFloodController = new SpamMasterFloodController;
					$is_flood = $SpamMasterFloodController->SpamMasterFlood($spamkey, $remote_ip);
					if(!empty($is_flood)){
						$spam_master_learning_post = array(
															'blog_license_key' => $blog_license_key,
															'blog_threat_ip' => $remote_ip,
															'blog_threat_type' => $blog_threat_type3,
															'blog_threat_email' => $blog_threat_email,
															'blog_threat_content' => 'Honeypot Registration Flood Count: ' . $is_flood,
															'blog_threat_agent' => $remote_agent,
															'blog_threat_refe' => $remote_referer,
															'blog_threat_dest' => $dest_url,
															'blog_web_adress' => $address,
															'blog_server_ip' => $blog_server_ip
						);										
						$response = wp_remote_post( base64_decode($spam_master_learn_h_url), array(
																									'method' => 'POST',
																									'timeout' => 90,
																									'body' => $spam_master_learning_post
																							));
						if ( is_wp_error( $response ) ) {
							$error_message = $response->get_error_message();
							//Log InUp Controller
							/////////////////////
							$spamkey = 'System';
							$spamco = 'localhost';
							$spamcou = 'localhost';
							$spamvalue = 'Error: Honeypot Flood. '.$error_message.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
						}
						else{
							$data = json_decode( wp_remote_retrieve_body( $response ), true );
							if(empty($data['threat'])){
								$spamco = $data['co'];
								$spamcou = $data['cou'];
								//Log InUp Controller
								/////////////////////
								$spamkey = 'Honeypot';
								$spamvalue = 'Blocked in registration by online RBL. Flood Count :' . $is_flood.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							}
							else{
								$remote_ip = $data['threat'];
								$spamco = $data['co'];
								$spamcou = $data['cou'];							
								//Log InUp Controller
								/////////////////////
								$spamkey = 'Honeypot';
								$spamvalue = 'Blocked in registration by online RBL. Flood Count :' . $is_flood.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							}
						}
						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

						echo '<p class="error"><strong>SPAM MASTER</strong> Flood detected. Please wait a few minutes.</p>';
						exit();
					}
				}
				//Check Fields
				if(!empty($_POST['mothers_name']) || !empty($_POST['mothers_last_name'])){
					if(!isset($_POST['mothers_name']) || empty($_POST['mothers_name'])){
						$mothers_name = 'empty';
					}
					else{
						$mothers_name = $_POST['mothers_name'];
					}
					if(!isset($_POST['mothers_last_name']) || empty($_POST['mothers_last_name'])){
						$mothers_last_name = 'empty';
					}
					else{
						$mothers_last_name = $_POST['mothers_last_name'];
					}
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $remote_ip,
														'blog_threat_type' => $blog_threat_type,
														'blog_threat_email' => $blog_threat_email,
														'blog_threat_content' => 'Honeypot Registration Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name,
														'blog_threat_agent' => $remote_agent,
														'blog_threat_refe' => $remote_referer,
														'blog_threat_dest' => $dest_url,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					
					$response = wp_remote_post( base64_decode($spam_master_learn_h_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_learning_post
																						));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Honeypot Flood. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
					}
					else{
						$data = json_decode( wp_remote_retrieve_body( $response ), true );
						if(empty($data['threat'])){
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Blocked in registration by online RBL fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						else{
							$remote_ip = $data['threat'];
							$spamco = $data['co'];
							$spamcou = $data['cou'];							
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Blocked in registration by online RBL fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();
					}

					echo '<p class="error"><strong>SPAM MASTER</strong>'.get_blog_option($blog_id, 'spam_master_message').'</p>';
					exit();
					
				}
				if(isset($_POST['spammasterscript']) && !empty($_POST['spammasterscript'])){
					$triggerJ = 'J';
				}
				else{
					$triggerJ = false;
				}
				if(!isset($_SESSION["spam-master-token"]) || empty($_SESSION["spam-master-token"]) || !isset($_POST['spam-master-token']) || empty($_POST['spam-master-token'])){
					$triggerS = 'S';
				}
				else{
					$triggerS = false;
				}
				if(!isset($_COOKIE["spam-master-token"]) || empty($_COOKIE["spam-master-token"])|| !isset($_POST['spam-master-token2']) || empty($_POST['spam-master-token2'])){
					$triggerC = 'C';
				}
				else{
					$triggerC = false;
				}
				if($triggerJ == 'J' || $triggerS == 'S' || $triggerC == 'C'){
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $remote_ip,
														'blog_threat_type' => $blog_threat_type2,
														'blog_threat_email' => $blog_threat_email,
														'blog_threat_content' => 'Honeypot V2'.$triggerJ.$triggerS.$triggerC.' Registration',
														'blog_threat_agent' => $remote_agent,
														'blog_threat_refe' => $remote_referer,
														'blog_threat_dest' => $dest_url,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					
					$response = wp_remote_post( base64_decode($spam_master_learn_h2_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_learning_post
																						));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Honeypot V2. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
					}
					else{
						$data = json_decode( wp_remote_retrieve_body( $response ), true );
						if(empty($data['threat'])){
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Honeypot V2 - Suspicious registration. Administration Exploit Injection Attempt.';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						else{
							$remote_ip = $data['threat'];
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Honeypot V2 - Blocked registration by online RBL. Administration Exploit Injection Attempt.';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

							echo '<p class="error"><strong>SPAM MASTER</strong>'.get_blog_option($blog_id, 'spam_master_message').'</p>';
							exit();
						}
					}
				}
			}
			return $result;
		// End Honey multi validation.
		}

		//START REGISTRATION ERRORS VALIDATION SINGLE SITE
		function spam_master_honeypot_register_single_errors($errors, $sanitized_user_login, $user_email){
			global $wpdb, $blog_id;

			//Remote Ip
			$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
			//Remote Agent
			if(isset($_SERVER['HTTP_USER_AGENT'])){
				$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
			}
			else{
				$remote_agent = 'Sniffer';
			}
			// Remote Referer
			if(isset($_SERVER['HTTP_REFERER'])){
				$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
			}
			else{
				$remote_referer = 'Direct';
			}
			// DEST URL
			if(isset($_SERVER['REQUEST_URI'])){
				$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
			}
			else{
				$dest_url = 'Weird';
			}
			//exempt admins from check
			if(!function_exists('wp_get_current_user')) {
				include(ABSPATH . "wp-includes/pluggable.php"); 
			}
			// Current User
			$current_user_id = get_current_user_id();
			if(isset($current_user_id)){
				$current_user_id = $current_user_id;
			}
			else{
				$current_user_id = 'none';
			}

			//prepare threat buffer
			if (!empty($user_email)) {
				if (filter_var($user_email, FILTER_VALIDATE_EMAIL)) {
					$blog_threat_email = wp_strip_all_tags(substr($user_email,0,256));
				}
				else{
					$blog_threat_email = 'honey_bot@'.rand(10000000, 99999999).'.wp';
				}
			}
			else{
				$blog_threat_email = 'honey_bot@'.rand(10000000, 99999999).'.wp';
			}

			//Add Controllers
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterBufferController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterFloodController.php');

			//Create data to be posted
			$blog_threat_type = 'honeypot';
			$blog_threat_type2 = 'honeypot 2';
			$blog_threat_type3 = 'flood';
			$spam_master_learn_h_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2hvbmV5XzIucGhw';
			$spam_master_learn_h2_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2hvbmV5Ml8yLnBocA==';
			$blog_license_key = substr(get_option('spam_license_key'),0,64);
			$blog_web_address = get_site_url();
			$address_unclean = $blog_web_address;
			$address_long = preg_replace('#^https?://#', '', $address_unclean);
			$address = substr($address_long,0,256);
			@$blog_server_ip = substr($_SERVER['SERVER_ADDR'],0,48);
			//if empty ip
			if(empty($blog_server_ip) || $blog_server_ip == '0'){
				@$blog_server_ip = 'I '.substr(gethostbyname($_SERVER['SERVER_NAME']),0,48);
			}

			//Spam Buffer Controller
			////////////////////////
			$SpamMasterBufferController = new SpamMasterBufferController;
			$is_buffer = $SpamMasterBufferController->SpamMasterBufferSearch($remote_ip, $blog_threat_email);
			if(!empty($is_buffer)){
				//Log InUp Controller
				/////////////////////
				$spamkey = 'Honeypot';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Blocked in registration by Spam Buffer.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

				//Spam Buffer Controller
				////////////////////////
				$SpamMasterBufferController = new SpamMasterBufferController;
				$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

				$errors->add('invalid_email', __('<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master') );
				return $errors;
			}
			else{
				//Check Alert or Flooding
				$spam_master_alert_level = get_option('spam_master_alert_level');
				if ($spam_master_alert_level == 'ALERT_3'){
					//Flood Controller
					///////////////////////
					$spamkey = 'Honeypot';
					$SpamMasterFloodController = new SpamMasterFloodController;
					$is_flood_3 = $SpamMasterFloodController->SpamMasterAlert3($spamkey);

					if(!empty($is_flood_3)){
						//Log InUp Controller
						/////////////////////
						$spamkey = 'Honeypot';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Alert 2/3 warning, honeypot registration flooding detected. Administration Exploit Attempt.';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

						$errors->add('invalid_email', __('<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master') );
						return $errors;
					}
				}
				else{
					//Flood Controller
					///////////////////////
					$spamkey = 'Honeypot';
					$SpamMasterFloodController = new SpamMasterFloodController;
					$is_flood = $SpamMasterFloodController->SpamMasterFlood($spamkey, $remote_ip);
					if(!empty($is_flood)){
						$spam_master_learning_post = array(
															'blog_license_key' => $blog_license_key,
															'blog_threat_ip' => $remote_ip,
															'blog_threat_type' => $blog_threat_type3,
															'blog_threat_email' => $blog_threat_email,
															'blog_threat_content' => 'Honeypot Registration Flood Count: ' . $is_flood,
															'blog_threat_agent' => $remote_agent,
															'blog_threat_refe' => $remote_referer,
															'blog_threat_dest' => $dest_url,
															'blog_web_adress' => $address,
															'blog_server_ip' => $blog_server_ip
						);										
						$response = wp_remote_post( base64_decode($spam_master_learn_h_url), array(
																									'method' => 'POST',
																									'timeout' => 90,
																									'body' => $spam_master_learning_post
																							));
						if ( is_wp_error( $response ) ) {
							$error_message = $response->get_error_message();
							//Log InUp Controller
							/////////////////////
							$spamkey = 'System';
							$spamco = 'localhost';
							$spamcou = 'localhost';
							$spamvalue = 'Error: Honeypot Flood. '.$error_message.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
						}
						else{
							$data = json_decode( wp_remote_retrieve_body( $response ), true );
							if(empty($data['threat'])){
								$spamco = $data['co'];
								$spamcou = $data['cou'];
								//Log InUp Controller
								/////////////////////
								$spamkey = 'Honeypot';
								$spamvalue = 'Blocked in registration by online RBL. Flood Count :' . $is_flood.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							}
							else{
								$remote_ip = $data['threat'];
								$spamco = $data['co'];
								$spamcou = $data['cou'];							
								//Log InUp Controller
								/////////////////////
								$spamkey = 'Honeypot';
								$spamvalue = 'Blocked in registration by online RBL. Flood Count :' . $is_flood.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							}
							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();
						}

						$errors->add('invalid_email', __('<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master') );
						return $errors;
					}
				}
				if(!empty($_POST['mothers_name']) || !empty($_POST['mothers_last_name'])){
					if(!isset($_POST['mothers_name']) || empty($_POST['mothers_name'])){
						$mothers_name = 'empty';
					}
					else{
						$mothers_name = $_POST['mothers_name'];
					}
					if(!isset($_POST['mothers_last_name']) || empty($_POST['mothers_last_name'])){
						$mothers_last_name = 'empty';
					}
					else{
						$mothers_last_name = $_POST['mothers_last_name'];
					}
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $remote_ip,
														'blog_threat_type' => $blog_threat_type,
														'blog_threat_email' => $blog_threat_email,
														'blog_threat_content' => 'Honeypot Registration Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name,
														'blog_threat_agent' => $remote_agent,
														'blog_threat_refe' => $remote_referer,
														'blog_threat_dest' => $dest_url,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					$response = wp_remote_post( base64_decode($spam_master_learn_h_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_learning_post
																						));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Honeypot. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
					}
					else{
						$data = json_decode( wp_remote_retrieve_body( $response ), true );
						if(empty($data['threat'])){
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Blocked in registration by online RBL fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						else{
							$remote_ip = $data['threat'];
							$spamco = $data['co'];
							$spamcou = $data['cou'];																												
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Blocked in registration by online RBL fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();
					}

					$errors->add('invalid_email', __('<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master') );
					return $errors;
				}
				if(isset($_POST['spammasterscript']) && !empty($_POST['spammasterscript'])){
					$triggerJ = 'J';
				}
				else{
					$triggerJ = false;
				}
				if(!isset($_SESSION["spam-master-token"]) || empty($_SESSION["spam-master-token"]) || !isset($_POST['spam-master-token']) || empty($_POST['spam-master-token'])){
					$triggerS = 'S';
				}
				else{
					$triggerS = false;
				}
				if(!isset($_COOKIE["spam-master-token"]) || empty($_COOKIE["spam-master-token"])|| !isset($_POST['spam-master-token2']) || empty($_POST['spam-master-token2'])){
					$triggerC = 'C';
				}
				else{
					$triggerC = false;
				}
				if($triggerJ == 'J' || $triggerS == 'S' || $triggerC == 'C'){
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $remote_ip,
														'blog_threat_type' => $blog_threat_type2,
														'blog_threat_email' => $blog_threat_email,
														'blog_threat_content' => 'Honeypot V2'.$triggerJ.$triggerS.$triggerC.' Registration',
														'blog_threat_agent' => $remote_agent,
														'blog_threat_refe' => $remote_referer,
														'blog_threat_dest' => $dest_url,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					$response = wp_remote_post( base64_decode($spam_master_learn_h2_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_learning_post
																						));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Honeypot V2. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
					}
					else{
						$data = json_decode( wp_remote_retrieve_body( $response ), true );
						if(empty($data['threat'])){
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Honeypot V2 - Suspicious registration. Administration Exploit Injection Attempt.';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						else{
							$remote_ip = $data['threat'];
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Honeypot V2 - Blocked registration by online RBL. Administration Exploit Injection Attempt.';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

							$errors->add('invalid_email', __('<strong>SPAM MASTER</strong>: Browser issues Detected. Are you in Private mode? If so, please deactivate it for an improved website experience.','spam_master') );
							return $errors;
						}
					}
				}
			}
		return $errors;
		// End Honey single validation.
		}

		//START LOGIN ERRORS VALIDATION SINGLE SITE
		function spam_master_honeypot_login_single_errors($error){
		global $wpdb, $blog_id, $errors, $user_email;
			$err_codes = $errors->get_error_codes();

			//Remote Ip
			$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
			//Remote Agent
			if(isset($_SERVER['HTTP_USER_AGENT'])){
				$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
			}
			else{
				$remote_agent = 'Sniffer';
			}
			// Remote Referer
			if(isset($_SERVER['HTTP_REFERER'])){
				$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
			}
			else{
				$remote_referer = 'Direct';
			}
			// DEST URL
			if(isset($_SERVER['REQUEST_URI'])){
				$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
			}
			else{
				$dest_url = 'Weird';
			}
			//exempt admins from check
			if(!function_exists('wp_get_current_user')) {
				include(ABSPATH . "wp-includes/pluggable.php"); 
			}
			// Current User
			$current_user_id = get_current_user_id();
			if(isset($current_user_id)){
				$current_user_id = $current_user_id;
			}
			else{
				$current_user_id = 'none';
			}

			//Add Controllers
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterBufferController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterFloodController.php');

			//Create data to be posted
			$blog_threat_type = 'honeypot';
			$blog_threat_type2 = 'honeypot 2';
			$blog_threat_type3 = 'flood';
			$spam_master_learn_h_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2hvbmV5XzIucGhw';
			$spam_master_learn_h2_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2hvbmV5Ml8yLnBocA==';
			$blog_license_key = substr(get_option('spam_license_key'),0,64);
			$blog_web_address = get_site_url();
			$address_unclean = $blog_web_address;
			$address_long = preg_replace('#^https?://#', '', $address_unclean);
			$address = substr($address_long,0,256);
			@$blog_server_ip = substr($_SERVER['SERVER_ADDR'],0,48);
			//if empty ip
			if(empty($blog_server_ip) || $blog_server_ip == '0'){
				@$blog_server_ip = 'I '.substr(gethostbyname($_SERVER['SERVER_NAME']),0,48);
			}

			//Prepare Email if any
			if(!empty($user_email)){
				if (filter_var($user_email, FILTER_VALIDATE_EMAIL)) {
					$blog_threat_email = wp_strip_all_tags(substr($user_email,0,256));
				}
				else{
					$blog_threat_email = 'honey_bot@'.rand(10000000, 99999999).'.wp';
				}
			}
			else{
				if(!empty($_REQUEST['log'])){
					if (filter_var($_REQUEST['log'], FILTER_VALIDATE_EMAIL)) {
						$blog_threat_email = wp_strip_all_tags(substr($_REQUEST['log'],0,256));
					}
					else{
						$blog_threat_email = 'honey_bot@'.rand(10000000, 99999999).'.wp';
					}
				}
				else{
					$blog_threat_email = 'honey_bot@'.rand(10000000, 99999999).'.wp';
				}
			}

			//Spam Buffer Controller
			////////////////////////
			$SpamMasterBufferController = new SpamMasterBufferController;
			$is_buffer = $SpamMasterBufferController->SpamMasterBufferSearch($remote_ip, $blog_threat_email);
			if(!empty($is_buffer)){
				//Log InUp Controller
				/////////////////////
				$spamkey = 'Honeypot';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Blocked in login/registration by Spam Buffer.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

				//Spam Buffer Controller
				////////////////////////
				$SpamMasterBufferController = new SpamMasterBufferController;
				$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

				$error = '<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email';
			}
			else{
				//Check Alert or Flooding
				$spam_master_alert_level = get_option('spam_master_alert_level');
				if ($spam_master_alert_level == 'ALERT_3'){
					//Flood Controller
					///////////////////////
					$spamkey = 'Honeypot';
					$SpamMasterFloodController = new SpamMasterFloodController;
					$is_flood_3 = $SpamMasterFloodController->SpamMasterAlert3($spamkey);

					if(!empty($is_flood_3)){
						//Log InUp Controller
						/////////////////////
						$spamkey = 'Honeypot';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Alert 2/3 warning, honeypot login/registration flooding detected. Administration Exploit Attempt.';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

						$error = '<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email';
					}
				}
				else{
					//Flood Controller
					///////////////////////
					$spamkey = 'Honeypot';
					$SpamMasterFloodController = new SpamMasterFloodController;
					$is_flood = $SpamMasterFloodController->SpamMasterFlood($spamkey, $remote_ip);
					if(!empty($is_flood)){
						$spam_master_learning_post = array(
															'blog_license_key' => $blog_license_key,
															'blog_threat_ip' => $remote_ip,
															'blog_threat_type' => $blog_threat_type3,
															'blog_threat_email' => $blog_threat_email,
															'blog_threat_content' => 'Honeypot login/registration Flood Count: ' . $is_flood,
															'blog_threat_agent' => $remote_agent,
															'blog_threat_refe' => $remote_referer,
															'blog_threat_dest' => $dest_url,
															'blog_web_adress' => $address,
															'blog_server_ip' => $blog_server_ip
						);										
						$response = wp_remote_post( base64_decode($spam_master_learn_h_url), array(
																									'method' => 'POST',
																									'timeout' => 90,
																									'body' => $spam_master_learning_post
																							));
						if ( is_wp_error( $response ) ) {
							$error_message = $response->get_error_message();
							//Log InUp Controller
							/////////////////////
							$spamkey = 'System';
							$spamco = 'localhost';
							$spamcou = 'localhost';
							$spamvalue = 'Error: Honeypot Flood. '.$error_message.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
						}
						else{
							$data = json_decode( wp_remote_retrieve_body( $response ), true );
							if(empty($data['threat'])){
								$spamco = $data['co'];
								$spamcou = $data['cou'];
								//Log InUp Controller
								/////////////////////
								$spamkey = 'Honeypot';
								$spamvalue = 'Blocked in login/registration by online RBL. Flood Count :' . $is_flood.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							}
							else{
								$remote_ip = $data['threat'];
								$spamco = $data['co'];
								$spamcou = $data['cou'];							
								//Log InUp Controller
								/////////////////////
								$spamkey = 'Honeypot';
								$spamvalue = 'Blocked in login/registration by online RBL. Flood Count :' . $is_flood.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							}
							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();
						}

						$error = '<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email';
					}
				}
				if(!empty($_POST['mothers_name']) || !empty($_POST['mothers_last_name'])){
					if(!isset($_POST['mothers_name']) || empty($_POST['mothers_name'])){
						$mothers_name = 'empty';
					}
					else{
						$mothers_name = $_POST['mothers_name'];
					}
					if(!isset($_POST['mothers_last_name']) || empty($_POST['mothers_last_name'])){
						$mothers_last_name = 'empty';
					}
					else{
						$mothers_last_name = $_POST['mothers_last_name'];
					}
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $remote_ip,
														'blog_threat_type' => $blog_threat_type,
														'blog_threat_email' => $blog_threat_email,
														'blog_threat_content' => 'Honeypot login/registration Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name,
														'blog_threat_agent' => $remote_agent,
														'blog_threat_refe' => $remote_referer,
														'blog_threat_dest' => $dest_url,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					$response = wp_remote_post( base64_decode($spam_master_learn_h_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_learning_post
																						));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Honeypot Flood. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
					}
					else{
						$data = json_decode( wp_remote_retrieve_body( $response ), true );
						if(empty($data['threat'])){
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Blocked in login/registration by online RBL fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						else{
							$remote_ip = $data['threat'];
							$spamco = $data['co'];
							$spamcou = $data['cou'];	
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Blocked in login/registration by online RBL fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);																								
						}
						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();
					}

					$error = '<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email';
				}
				if(isset($_POST['spammasterscript']) && !empty($_POST['spammasterscript'])){
					$triggerJ = 'J';
				}
				else{
					$triggerJ = false;
				}
				if(!isset($_SESSION["spam-master-token"]) || empty($_SESSION["spam-master-token"]) || !isset($_POST['spam-master-token']) || empty($_POST['spam-master-token'])){
					$triggerS = 'S';
				}
				else{
					$triggerS = false;
				}
				if(!isset($_COOKIE["spam-master-token"]) || empty($_COOKIE["spam-master-token"])|| !isset($_POST['spam-master-token2']) || empty($_POST['spam-master-token2'])){
					$triggerC = 'C';
				}
				else{
					$triggerC = false;
				}
				if($triggerJ == 'J' || $triggerS == 'S' || $triggerC == 'C'){
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $remote_ip,
														'blog_threat_type' => $blog_threat_type2,
														'blog_threat_email' => $blog_threat_email,
														'blog_threat_content' => 'Honeypot V2'.$triggerJ.$triggerS.$triggerC.' Login/Registration',
														'blog_threat_agent' => $remote_agent,
														'blog_threat_refe' => $remote_referer,
														'blog_threat_dest' => $dest_url,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					$response = wp_remote_post( base64_decode($spam_master_learn_h2_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_learning_post
																						));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Honeypot V2. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
					}
					else{
						$data = json_decode( wp_remote_retrieve_body( $response ), true );
						if(empty($data['threat'])){
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Honeypot V2 - Suspicious login/registration. Administration Exploit Injection Attempt.';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						else{
							$remote_ip = $data['threat'];
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Honeypot V2 - Blocked login/registration by online RBL. Administration Exploit Injection Attempt.';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

							$error = '<strong>SPAM MASTER</strong>: Browser issues Detected. Are you in Private mode? If so, please deactivate it for an improved website experience.';
						}
					}
				}
			}
		return $error;
		// End Honey single validation.
		}

		//COMMENT VERIFICATION
		function spam_master_verify_honey_comment_data($commentdata){
		global $wpdb, $blog_id;

			//Remote Ip
			$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
			//Remote Agent
			if(isset($_SERVER['HTTP_USER_AGENT'])){
				$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
			}
			else{
				$remote_agent = 'Sniffer';
			}
			// Remote Referer
			if(isset($_SERVER['HTTP_REFERER'])){
				$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
			}
			else{
				$remote_referer = 'Direct';
			}
			// DEST URL
			if(isset($_SERVER['REQUEST_URI'])){
				$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
			}
			else{
				$dest_url = 'Weird';
			}
			//exempt admins from check
			if(!function_exists('wp_get_current_user')) {
				include(ABSPATH . "wp-includes/pluggable.php"); 
			}
			// Current User
			$current_user_id = get_current_user_id();
			if(isset($current_user_id)){
				$current_user_id = $current_user_id;
			}
			else{
				$current_user_id = 'none';
			}

			//prepare threat buffer
			if (!empty($commentdata['comment_author_email'])) {
				if (filter_var($commentdata['comment_author_email'], FILTER_VALIDATE_EMAIL)) {
					$blog_threat_email = wp_strip_all_tags(substr($commentdata['comment_author_email'],0,256));
				}
				else{
					$blog_threat_email = 'honey_bot@'.rand(10000000, 99999999).'.wp';
				}
			}
			else{
				$blog_threat_email = 'honey_bot@'.rand(10000000, 99999999).'.wp';
			}
			if (!empty($commentdata['comment_content'])) {
				$result_comment_content_trim = substr($commentdata['comment_content'],0,360);
				$result_comment_content_clean = wp_strip_all_tags(stripslashes_deep($result_comment_content_trim), true);
			}
			else{
				$result_comment_content_clean = 'empty';
			}

			//Add Controllers
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterBufferController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterFloodController.php');

			//Create data to be posted
			$blog_threat_type = 'honeypot';
			$blog_threat_type2 = 'honeypot 2';
			$blog_threat_type3 = 'flood';
			$spam_master_learn_h_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2hvbmV5XzIucGhw';
			$spam_master_learn_h2_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2hvbmV5Ml8yLnBocA==';
			$blog_license_key = substr(get_option('spam_license_key'),0,64);
			$blog_web_address = get_site_url();
			$address_unclean = $blog_web_address;
			$address_long = preg_replace('#^https?://#', '', $address_unclean);
			$address = substr($address_long,0,256);
			@$blog_server_ip = substr($_SERVER['SERVER_ADDR'],0,48);
			//if empty ip
			if(empty($blog_server_ip) || $blog_server_ip == '0'){
				@$blog_server_ip = 'I '.substr(gethostbyname($_SERVER['SERVER_NAME']),0,48);
			}

			//Spam Buffer Controller
			////////////////////////
			$SpamMasterBufferController = new SpamMasterBufferController;
			$is_buffer = $SpamMasterBufferController->SpamMasterBufferSearch($remote_ip, $blog_threat_email);
			if(!empty($is_buffer)){
				//Log InUp Controller
				/////////////////////
				$spamkey = 'Honeypot';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Blocked in comment by Spam Buffer. Email: '.$blog_threat_email.', Text: '.$result_comment_content_clean.'';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

				//Spam Buffer Controller
				////////////////////////
				$SpamMasterBufferController = new SpamMasterBufferController;
				$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

				return wp_die( __( '<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master' ) );
			}
			else{
				//Check Alert or Flooding
				$spam_master_alert_level = get_option('spam_master_alert_level');
				if ($spam_master_alert_level == 'ALERT_3'){
					//Flood Controller
					///////////////////////
					$spamkey = 'Honeypot';
					$SpamMasterFloodController = new SpamMasterFloodController;
					$is_flood_3 = $SpamMasterFloodController->SpamMasterAlert3($spamkey);

					if(!empty($is_flood_3)){
						//Log InUp Controller
						/////////////////////
						$spamkey = 'Honeypot';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Alert 2/3 warning, honeypot comment flooding detected. Administration Exploit Attempt.';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

						return wp_die( __( '<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master' ) );
					}
				}
				else{
					//Flood Controller
					///////////////////////
					$spamkey = 'Honeypot';
					$SpamMasterFloodController = new SpamMasterFloodController;
					$is_flood = $SpamMasterFloodController->SpamMasterFlood($spamkey, $remote_ip);
					if(!empty($is_flood)){
						$spam_master_learning_post = array(
															'blog_license_key' => $blog_license_key,
															'blog_threat_ip' => $remote_ip,
															'blog_threat_type' => $blog_threat_type3,
															'blog_threat_email' => $blog_threat_email,
															'blog_threat_content' => 'Honeypot comment Flood Count: ' . $is_flood,
															'blog_threat_agent' => $remote_agent,
															'blog_threat_refe' => $remote_referer,
															'blog_threat_dest' => $dest_url,
															'blog_web_adress' => $address,
															'blog_server_ip' => $blog_server_ip
						);										
						$response = wp_remote_post( base64_decode($spam_master_learn_h_url), array(
																									'method' => 'POST',
																									'timeout' => 90,
																									'body' => $spam_master_learning_post
																							));
						if ( is_wp_error( $response ) ) {
							$error_message = $response->get_error_message();
							//Log InUp Controller
							/////////////////////
							$spamkey = 'System';
							$spamco = 'localhost';
							$spamcou = 'localhost';
							$spamvalue = 'Error: Honeypot Flood. '.$error_message.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
						}
						else{
							$data = json_decode( wp_remote_retrieve_body( $response ), true );
							if(empty($data['threat'])){
								$spamco = $data['co'];
								$spamcou = $data['cou'];
								//Log InUp Controller
								/////////////////////
								$spamkey = 'Honeypot';
								$spamvalue = 'Blocked in comment by online RBL. Flood Count :' . $is_flood.' Email: '.$blog_threat_email.', Text: '.$result_comment_content_clean.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							}
							else{
								$remote_ip = $data['threat'];
								$spamco = $data['co'];
								$spamcou = $data['cou'];							
								//Log InUp Controller
								/////////////////////
								$spamkey = 'Honeypot';
								$spamvalue = 'Blocked in comment by online RBL. Flood Count :' . $is_flood.' Email: '.$blog_threat_email.', Text: '.$result_comment_content_clean.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							}
							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();
						}

						return wp_die( __( '<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master' ) );
					}
				}
				if(!empty($_POST['mothers_name']) || !empty($_POST['mothers_last_name'])){
					if(!isset($_POST['mothers_name']) || empty($_POST['mothers_name'])){
						$mothers_name = 'empty';
					}
					else{
						$mothers_name = $_POST['mothers_name'];
					}
					if(!isset($_POST['mothers_last_name']) || empty($_POST['mothers_last_name'])){
						$mothers_last_name = 'empty';
					}
					else{
						$mothers_last_name = $_POST['mothers_last_name'];
					}
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $remote_ip,
														'blog_threat_type' => $blog_threat_type,
														'blog_threat_email' => $blog_threat_email,
														'blog_threat_content' => 'Honeypot Comment Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name,
														'blog_threat_agent' => $remote_agent,
														'blog_threat_refe' => $remote_referer,
														'blog_threat_dest' => $dest_url,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					$response = wp_remote_post( base64_decode($spam_master_learn_h_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_learning_post
																						));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Honeypot. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
					}
					else{
						$data = json_decode( wp_remote_retrieve_body( $response ), true );
						if(empty($data['threat'])){
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Blocked in comment by online RBL fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						else{
							$remote_ip = $data['threat'];
							$spamco = $data['co'];
							$spamcou = $data['cou'];																										
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Blocked in comment by online RBL fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();
					}

					return wp_die( __( '<strong>SPAM MASTER</strong>: Blocked IP, Domain, Email','spam_master' ) );
				}
				if(isset($_POST['spammasterscript']) && !empty($_POST['spammasterscript'])){
					$triggerJ = 'J';
				}
				else{
					$triggerJ = false;
				}
				if(!isset($_SESSION["spam-master-token"]) || empty($_SESSION["spam-master-token"]) || !isset($_POST['spam-master-token']) || empty($_POST['spam-master-token'])){
					$triggerS = 'S';
				}
				else{
					$triggerS = false;
				}
				if(!isset($_COOKIE["spam-master-token"]) || empty($_COOKIE["spam-master-token"])|| !isset($_POST['spam-master-token2']) || empty($_POST['spam-master-token2'])){
					$triggerC = 'C';
				}
				else{
					$triggerC = false;
				}
				if($triggerJ == 'J' || $triggerS == 'S' || $triggerC == 'C'){
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $remote_ip,
														'blog_threat_type' => $blog_threat_type2,
														'blog_threat_email' => $blog_threat_email,
														'blog_threat_content' => 'Honeypot V2'.$triggerJ.$triggerS.$triggerC.' Comment',
														'blog_threat_agent' => $remote_agent,
														'blog_threat_refe' => $remote_referer,
														'blog_threat_dest' => $dest_url,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					$response = wp_remote_post( base64_decode($spam_master_learn_h2_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_learning_post
																						));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Honeypot V2. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
					}
					else{
						$data = json_decode( wp_remote_retrieve_body( $response ), true );
						if(empty($data['threat'])){
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Honeypot V2 - Suspicious comment. Administration Exploit Injection Attempt.';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						else{
							$remote_ip = $data['threat'];
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Honeypot V2 - Blocked comment by online RBL. Administration Exploit Injection Attempt. Email: '.$blog_threat_email.', Text: '.$result_comment_content_clean.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

							return wp_die( __( '<strong>SPAM MASTER</strong>: Browser issues Detected. Are you in Private mode? If so, please deactivate it for an improved website experience.','spam_master' ) );
						}
					}
				}
			}
			return $commentdata;
		}

		//Contact Form 7
		function spam_master_add_honeypot_to_form( $content ) {
			//Reversed Ip
			$reverse_ip = strrev($_SERVER['REMOTE_ADDR']).'.'.bin2hex(random_bytes(12));

			$content .= '<p class="spam-master-hidden">
						<label class="spam-master-hidden" for="'.$reverse_ip.'">'.$reverse_ip.'<br>
						<input class="spam-master-hidden input" type="text" name="'.$reverse_ip.'" id="'.$reverse_ip.'" autocomplete="off" value="'.$reverse_ip.'" />
						</label>
						</p>';
			$content .= '<p class="spam-master-hidden">
						<label class="spam-master-hidden" for="mothers_name">Mother Name<br>
						<input class="spam-master-hidden input" type="text" name="mothers_name" id="mothers_name" autocomplete="off" value="" />
						</label>
						</p>';
			$content .= '<p class="spam-master-hidden">
						<label class="spam-master-hidden" for="mothers_last_name">Mother Last Name<br>
						<input class="spam-master-hidden input" type="text" name="mothers_last_name" id="mothers_last_name" autocomplete="off" value="" />
						</label>
						</p>';
			$content .= '<noscript>
						<p class="spam-master-hidden">
						<label class="spam-master-hidden" for="spammasterscript">Js<br>
						<input class="spam-master-hidden input" type="text" name="spammasterscript" id="spammasterscript" autocomplete="off" value="369golden" />
						</label>
						</p>
						</noscript>';
			if(isset($_SESSION["spam-master-token"]) && !empty($_SESSION["spam-master-token"])){
				$content .= '<p class="spam-master-hidden">
							<label for="spam-master-token" class="spam-master-hidden">Spam Master Token<br>
							<input class="input" type="hidden" name="spam-master-token" id="spam-master-token" placeholder="Spam Master Token" autocomplete="off" value="'.$_SESSION["spam-master-token"].'" />
							</label>
							</p>';
			}
			if(isset($_COOKIE["spam-master-token"]) && !empty($_COOKIE["spam-master-token"])){
				$content .= '<p class="spam-master-hidden">
							<label for="spam-master-token2" class="spam-master-hidden">Spam Master Token2<br>
							<input class="input" type="hidden" name="spam-master-token2" id="spam-master-token2" placeholder="Spam Master Token2" autocomplete="off" value="'.$_COOKIE["spam-master-token"].'" />
							</label>
							</p>';
			}
			return $content;        
		}
		function spam_master_contact_form_7_honeypot($spam){
		global $wpdb, $blog_id;

			//Remote Ip
			$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
			//Remote Agent
			if(isset($_SERVER['HTTP_USER_AGENT'])){
				$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
			}
			else{
				$remote_agent = 'Sniffer';
			}
			// Remote Referer
			if(isset($_SERVER['HTTP_REFERER'])){
				$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
			}
			else{
				$remote_referer = 'Direct';
			}
			// DEST URL
			if(isset($_SERVER['REQUEST_URI'])){
				$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
			}
			else{
				$dest_url = 'Weird';
			}
			//exempt admins from check
			if(!function_exists('wp_get_current_user')) {
				include(ABSPATH . "wp-includes/pluggable.php"); 
			}
			// Current User
			$current_user_id = get_current_user_id();
			if(isset($current_user_id)){
				$current_user_id = $current_user_id;
			}
			else{
				$current_user_id = 'none';
			}

			//prepare threat buffer
			if (!empty($_POST['your-email'])) {
				if (filter_var($_POST['your-email'], FILTER_VALIDATE_EMAIL)) {
					$blog_threat_email = wp_strip_all_tags(substr($_POST['your-email'],0,256));
				}
				else{
					$blog_threat_email = 'honey_bot@'.rand(10000000, 99999999).'.wp';
				}
			}
			else{
				$blog_threat_email = 'honey_bot@'.rand(10000000, 99999999).'.wp';
			}
			if (!empty($_POST['your-message'])) {
				$result_comment_content_trim = substr($_POST['your-message'],0,360);
				$result_comment_content_clean = wp_strip_all_tags(stripslashes_deep($result_comment_content_trim), true);
			}
			else{
				$result_comment_content_clean = 'your-message';
			}

			//Add Controllers
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterBufferController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterFloodController.php');

			//Create data to be posted
			$blog_threat_type = 'honeypot';
			$blog_threat_type2 = 'honeypot 2';
			$blog_threat_type3 = 'flood';
			$spam_master_learn_h_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2hvbmV5XzIucGhw';
			$spam_master_learn_h2_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2hvbmV5Ml8yLnBocA==';
			$blog_license_key = substr(get_option('spam_license_key'),0,64);
			$blog_web_address = get_site_url();
			$address_unclean = $blog_web_address;
			$address_long = preg_replace('#^https?://#', '', $address_unclean);
			$address = substr($address_long,0,256);
			@$blog_server_ip = substr($_SERVER['SERVER_ADDR'],0,48);
			//if empty ip
			if(empty($blog_server_ip) || $blog_server_ip == '0'){
				@$blog_server_ip = 'I '.substr(gethostbyname($_SERVER['SERVER_NAME']),0,48);
			}

			//Spam Buffer Controller
			////////////////////////
			$SpamMasterBufferController = new SpamMasterBufferController;
			$is_buffer = $SpamMasterBufferController->SpamMasterBufferSearch($remote_ip, $blog_threat_email);
			if(!empty($is_buffer)){
				//Log InUp Controller
				/////////////////////
				$spamkey = 'Honeypot';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Blocked in contact form by Spam Buffer. Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

				//Spam Buffer Controller
				////////////////////////
				$SpamMasterBufferController = new SpamMasterBufferController;
				$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

				return  $result['reason'] = array( 'spam' => wpcf7_get_message( 'spam' ) );
				exit();
			}
			else{
				//Check Alert or Flooding
				$spam_master_alert_level = get_option('spam_master_alert_level');
				if ($spam_master_alert_level == 'ALERT_3'){
					//Flood Controller
					///////////////////////
					$spamkey = 'Honeypot';
					$SpamMasterFloodController = new SpamMasterFloodController;
					$is_flood_3 = $SpamMasterFloodController->SpamMasterAlert3($spamkey);

					if(!empty($is_flood_3)){
						//Log InUp Controller
						/////////////////////
						$spamkey = 'Honeypot';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Alert 2/3 warning, honeypot contact form flooding detected. Administration Exploit Attempt.';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

						return  $result['reason'] = array( 'spam' => wpcf7_get_message( 'spam' ) );
						exit();
					}
				}
				else{
					//Flood Controller
					///////////////////////
					$spamkey = 'Honeypot';
					$SpamMasterFloodController = new SpamMasterFloodController;
					$is_flood = $SpamMasterFloodController->SpamMasterFlood($spamkey, $remote_ip);
					if(!empty($is_flood)){
						$spam_master_learning_post = array(
															'blog_license_key' => $blog_license_key,
															'blog_threat_ip' => $remote_ip,
															'blog_threat_type' => $blog_threat_type3,
															'blog_threat_email' => $blog_threat_email,
															'blog_threat_content' => 'Honeypot contact form Flood Count: ' . $is_flood,
															'blog_threat_agent' => $remote_agent,
															'blog_threat_refe' => $remote_referer,
															'blog_threat_dest' => $dest_url,
															'blog_web_adress' => $address,
															'blog_server_ip' => $blog_server_ip
						);										
						$response = wp_remote_post( base64_decode($spam_master_learn_h_url), array(
																									'method' => 'POST',
																									'timeout' => 90,
																									'body' => $spam_master_learning_post
																							));
						if ( is_wp_error( $response ) ) {
							$error_message = $response->get_error_message();
							//Log InUp Controller
							/////////////////////
							$spamkey = 'System';
							$spamco = 'localhost';
							$spamcou = 'localhost';
							$spamvalue = 'Error: Honeypot Flood. '.$error_message.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
						}
						else{
							$data = json_decode( wp_remote_retrieve_body( $response ), true );
							if(empty($data['threat'])){
								$spamco = $data['co'];
								$spamcou = $data['cou'];
								//Log InUp Controller
								/////////////////////
								$spamkey = 'Honeypot';
								$spamvalue = 'Blocked in contact form by online RBL. Flood Count :' . $is_flood.' Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							}
							else{
								$remote_ip = $data['threat'];
								$spamco = $data['co'];
								$spamcou = $data['cou'];							
								//Log InUp Controller
								/////////////////////
								$spamkey = 'Honeypot';
								$spamvalue = 'Blocked in contact form by online RBL. Flood Count :' . $is_flood.' Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							}
							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();
						}

						return  $result['reason'] = array( 'spam' => wpcf7_get_message( 'spam' ) );
						exit();
					}
				}
				if(!empty($_POST['mothers_name']) || !empty($_POST['mothers_last_name'])){
					if(!isset($_POST['mothers_name']) || empty($_POST['mothers_name'])){
						$mothers_name = 'empty';
					}
					else{
						$mothers_name = $_POST['mothers_name'];
					}
					if(!isset($_POST['mothers_last_name']) || empty($_POST['mothers_last_name'])){
						$mothers_last_name = 'empty';
					}
					else{
						$mothers_last_name = $_POST['mothers_last_name'];
					}
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $remote_ip,
														'blog_threat_type' => $blog_threat_type,
														'blog_threat_email' => $blog_threat_email,
														'blog_threat_content' => 'Honeypot Contact Form Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name,
														'blog_threat_agent' => $remote_agent,
														'blog_threat_refe' => $remote_referer,
														'blog_threat_dest' => $dest_url,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					$response = wp_remote_post( base64_decode($spam_master_learn_h_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_learning_post
																						));														
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Honeypot. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
					}
					else{
						$data = json_decode( wp_remote_retrieve_body( $response ), true );
						if(empty($data['threat'])){
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Blocked in contact form by online RBL fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						else{
							$remote_ip = $data['threat'];
							$spamco = $data['co'];
							$spamcou = $data['cou'];																											
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Blocked in contact form by online RBL fields not empty. Field 1: ' . $mothers_name . ', Field 2: ' . $mothers_last_name.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();
					}

					return  $result['reason'] = array( 'spam' => wpcf7_get_message( 'spam' ) );
					exit();
				}
				if(isset($_POST['spammasterscript']) && !empty($_POST['spammasterscript'])){
					$triggerJ = 'J';
				}
				else{
					$triggerJ = false;
				}
				if(!isset($_SESSION["spam-master-token"]) || empty($_SESSION["spam-master-token"]) || !isset($_POST['spam-master-token']) || empty($_POST['spam-master-token'])){
					$triggerS = 'S';
				}
				else{
					$triggerS = false;
				}
				if(!isset($_COOKIE["spam-master-token"]) || empty($_COOKIE["spam-master-token"])|| !isset($_POST['spam-master-token2']) || empty($_POST['spam-master-token2'])){
					$triggerC = 'C';
				}
				else{
					$triggerC = false;
				}
				if($triggerJ == 'J' || $triggerS == 'S' || $triggerC == 'C'){
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $remote_ip,
														'blog_threat_type' => $blog_threat_type2,
														'blog_threat_email' => $blog_threat_email,
														'blog_threat_content' => 'Honeypot V2'.$triggerJ.$triggerS.$triggerC.' Contact Form 7',
														'blog_threat_agent' => $remote_agent,
														'blog_threat_refe' => $remote_referer,
														'blog_threat_dest' => $dest_url,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					$response = wp_remote_post( base64_decode($spam_master_learn_h2_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_learning_post
																						));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Honeypot V2. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
					}
					else{
						$data = json_decode( wp_remote_retrieve_body( $response ), true );
						if(empty($data['threat'])){
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Honeypot V2 - Suspicious contact form. Administration Exploit Injection Attempt.';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						else{
							$remote_ip = $data['threat'];
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'Honeypot';
							$spamvalue = 'Honeypot V2 - Blocked contact form by online RBL. Administration Exploit Injection Attempt. Email: ' . $blog_threat_email . ', Text: ' . $result_comment_content_clean.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

							//Spam Buffer Controller
							////////////////////////
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

							return  $result['reason'] = array( 'spam' => wpcf7_get_message( 'spam' ) );
							exit();
						}
					}
				}
			}
		}

	//end honeypot true
	}
// end valid
}
?>
