<?php
global $wpdb, $blog_id;
if(is_multisite()){
	$response_key = get_blog_option($blog_id, 'spam_master_status');
	$spam_master_recaptcha_registration = get_blog_option($blog_id, 'spam_master_recaptcha_registration');
	$spam_master_recaptcha_login = get_blog_option($blog_id, 'spam_master_recaptcha_login');
	$spam_master_recaptcha_comments = get_blog_option($blog_id, 'spam_master_recaptcha_comments');
	$spam_master_recaptcha_public_key = get_blog_option($blog_id, 'spam_master_recaptcha_public_key');
	$spam_master_recaptcha_secret_key = get_blog_option($blog_id, 'spam_master_recaptcha_secret_key');
	$spam_master_recaptcha_ampoff = get_blog_option($blog_id, 'spam_master_recaptcha_ampoff');
}
else{
	$response_key = get_option('spam_master_status');
	$spam_master_recaptcha_registration = get_option('spam_master_recaptcha_registration');
	$spam_master_recaptcha_login = get_option('spam_master_recaptcha_login');
	$spam_master_recaptcha_comments = get_option('spam_master_recaptcha_comments');
	$spam_master_recaptcha_public_key = get_option('spam_master_recaptcha_public_key');
	$spam_master_recaptcha_secret_key = get_option('spam_master_recaptcha_secret_key');
	$spam_master_recaptcha_ampoff = get_option('spam_master_recaptcha_ampoff');
}
if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){

	//HOOK AMP FUNCTION
	require_once( WP_PLUGIN_DIR . '/spam-master/includes/protection/spam-master-amp-fun.php');

	//////////////////////////////////////////////
	//IMPLEMENT RECAPTCHA FRONTEND REGISTRATIONS//
	if ($spam_master_recaptcha_registration == 'true'){
		if ($spam_master_recaptcha_public_key !== ''){
			if ( !('true' == spam_master_amp_check() && !( 'true' == $spam_master_recaptcha_ampoff ) ) ) {
				//MULTISITE HOOKS
				if(is_multisite()){
					add_action('signup_extra_fields', 'spam_master_recaptcha_register_field' );
					add_action('register_form', 'spam_master_recaptcha_register_field' );
					add_action('wpmu_validate_user_signup', 'spam_master_recaptcha_register_multi_errors', 99);
				}
				//SINGLE SITE HOOKS
				else{
					add_action('login_enqueue_scripts', 'spam_master_recaptcha_css');
					add_action('register_form', 'spam_master_recaptcha_register_field' );
					add_action( 'registration_errors', 'spam_master_recaptcha_register_single_errors', 10, 3 );
				}
			}
			//CSS FOR SINGLE SITE
			function spam_master_recaptcha_css(){
				wp_register_style( 'spam_master_recaptcha_css', plugins_url('../../css/spam-master-recaptcha.css',  __FILE__) );
				wp_enqueue_style( 'spam_master_recaptcha_css' );
			}
			//END CSS

			//INSERT FIELD
			function spam_master_recaptcha_register_field(){
			global $wpdb, $blog_id;
			if(is_multisite()){
			$spam_master_recaptcha_public_key = get_blog_option($blog_id, 'spam_master_recaptcha_public_key');
			$spam_master_recaptcha_theme = get_blog_option($blog_id, 'spam_master_recaptcha_theme');
			}
			else{
			$spam_master_recaptcha_public_key = get_option('spam_master_recaptcha_public_key');
			$spam_master_recaptcha_theme = get_option('spam_master_recaptcha_theme');
			}
				?>
				<label>Re-CAPTCHA Code</label>
				<?php
				echo '<script src="https://www.google.com/recaptcha/api.js" async defer></script>';
				echo '<div class="g-recaptcha" data-theme="' . $spam_master_recaptcha_theme . '" data-sitekey="' . $spam_master_recaptcha_public_key . '"></div>';
				if (is_multisite()){
				?>
				<p>Press <b>Next</b> after verifying captcha.</p>
				<br>
				<?php
				}
				else{
				?>
				<p>Press <b>Register</b> after verifying captcha.</p>
				<br>
				<?php
				}
			}
			//CAPTCH VERIFICATION 
			function captcha_verification() {
			global $wpdb, $blog_id;
			if(is_multisite()){
			$spam_master_recaptcha_public_key = get_blog_option($blog_id, 'spam_master_recaptcha_public_key');
			}
			else{
			$spam_master_recaptcha_secret_key = get_option('spam_master_recaptcha_secret_key');
			}
				$response = isset( $_POST['g-recaptcha-response'] ) ? esc_attr( $_POST['g-recaptcha-response'] ) : '';

				$remote_ip = $_SERVER["REMOTE_ADDR"];

				// make a GET request to the Google reCAPTCHA Server
				$request = wp_remote_get(
					'https://www.google.com/recaptcha/api/siteverify?secret=' . $spam_master_recaptcha_secret_key . '&response=' . $response . '&remoteip=' . $remote_ip
				);

				// get the request response body
				$response_body = wp_remote_retrieve_body( $request );

				$result = json_decode( $response_body, true );

				return $result['success'];
			}
			//START ERRORS VALIDATION MULTI SITE
			function spam_master_recaptcha_register_multi_errors($result){
			global $wpdb, $blog_id;
				if(isset($_POST['g-recaptcha-response'])){
					$captcha=$_POST['g-recaptcha-response'];

					//Remote Ip
					$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
					//Remote Agent
					if(isset($_SERVER['HTTP_USER_AGENT'])){
						$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
					}
					else{
						$remote_agent = 'Sniffer';
					}
					// Remote Referer
					if(isset($_SERVER['HTTP_REFERER'])){
						$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
					}
					else{
						$remote_referer = 'Direct';
					}
					// DEST URL
					if(isset($_SERVER['REQUEST_URI'])){
						$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
					}
					else{
						$dest_url = 'Weird';
					}
					//exempt admins from check
					if(!function_exists('wp_get_current_user')) {
						include(ABSPATH . "wp-includes/pluggable.php"); 
					}
					// Current User
					$current_user_id = get_current_user_id();
					if(isset($current_user_id)){
						$current_user_id = $current_user_id;
					}
					else{
						$current_user_id = 'none';
					}

					//Add Controllers
					require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterBufferController.php');
					require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');

					//Log InUp Controller
					$spamkey = 'Firewall';
					$spamco = 'localhost';
					$spamcou = 'localhost';
					$spamvalue = 'reCaptcha Registration Spam Check Triggered.';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

					if(!$captcha){
						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

						//Create data to be posted
						$blog_threat_type = 'captcha';
						$spam_master_leaning_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2NhcHRjaGFfMi5waHA=';
						$blog_license_key = substr(get_blog_option($blog_id, 'spam_license_key'),0,64);
						$blog_web_address = get_site_url();
						$address_unclean = $blog_web_address;
						$address_long = preg_replace('#^https?://#', '', $address_unclean);
						$address = substr($address_long,0,256);
						@$blog_server_ip = substr($_SERVER['SERVER_ADDR'],0,48);
						//if empty ip
						if(empty($blog_server_ip) || $blog_server_ip == '0'){
							@$blog_server_ip = 'I '.substr(gethostbyname($_SERVER['SERVER_NAME']),0,48);
						}
						$spam_master_learning_post = array(
															'blog_license_key' => $blog_license_key,
															'blog_threat_ip' => $remote_ip,
															'blog_threat_type' => $blog_threat_type,
															'blog_threat_email' => 'captcha@'.rand(10000000, 99999999).'.wp',
															'blog_threat_content' => 'Page: registration.',
															'blog_threat_agent' => $remote_agent,
															'blog_threat_refe' => $remote_referer,
															'blog_threat_dest' => $dest_url,
															'blog_web_adress' => $address,
															'blog_server_ip' => $blog_server_ip
													);										
						$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																									'method' => 'POST',
																									'timeout' => 90,
																									'body' => $spam_master_learning_post
																							));
						if ( is_wp_error( $response ) ) {
							$error_message = $response->get_error_message();
							//Log InUp Controller
							/////////////////////
							$spamkey = 'System';
							$spamco = 'localhost';
							$spamcou = 'localhost';
							$spamvalue = 'Error: reCaptcha. '.$error_message.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
						}
						else{
							$data = json_decode( wp_remote_retrieve_body( $response ), true );
							if(empty($data['threat'])){
								$spamco = $data['co'];
								$spamcou = $data['cou'];
								//Log InUp Controller
								/////////////////////
								$spamkey = 'reCaptcha';
								$spamvalue = 'Wrong reCaptcha in registration.';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							}
							else{
								$remote_ip = $data['threat'];
								$spamco = $data['co'];
								$spamcou = $data['cou'];																										
								//Log InUp Controller
								/////////////////////
								$spamkey = 'reCaptcha';
								$spamvalue = 'Blocked reCaptcha in registration by online RBL.';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

								//Spam Buffer Controller
								////////////////////////
								$blog_threat_email = false;
								$SpamMasterBufferController = new SpamMasterBufferController;
								$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);
							}
						}
						echo '<p class="error"><strong>SPAM MASTER</strong>: Insert Correct Captcha</p>';
					}
				}
			return $result;
			}
			//START ERRORS VALIDATION SINGLE SITE
			function spam_master_recaptcha_register_single_errors($errors, $sanitized_user_login, $user_email){
			global $wpdb, $blog_id;

				//Remote Ip
				$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
				//Remote Agent
				if(isset($_SERVER['HTTP_USER_AGENT'])){
					$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
				}
				else{
					$remote_agent = 'Sniffer';
				}
				// Remote Referer
				if(isset($_SERVER['HTTP_REFERER'])){
					$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
				}
				else{
					$remote_referer = 'Direct';
				}
				// DEST URL
				if(isset($_SERVER['REQUEST_URI'])){
					$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
				}
				else{
					$dest_url = 'Weird';
				}
				//exempt admins from check
				if(!function_exists('wp_get_current_user')) {
					include(ABSPATH . "wp-includes/pluggable.php"); 
				}
				// Current User
				$current_user_id = get_current_user_id();
				if(isset($current_user_id)){
					$current_user_id = $current_user_id;
				}
				else{
					$current_user_id = 'none';
				}

				//Add Controllers
				require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterBufferController.php');
				require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');

				//Log InUp Controller
				$spamkey = 'Firewall';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'reCaptcha Registration Spam Check Triggered.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

				if ( isset( $_POST['g-recaptcha-response'] ) && !captcha_verification() ) {
					//Spam Buffer Controller
					////////////////////////
					$SpamMasterBufferController = new SpamMasterBufferController;
					$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

					//Create data to be posted
					$blog_threat_type = 'captcha';
					$spam_master_leaning_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2NhcHRjaGFfMi5waHA=';
					$blog_license_key = substr(get_option('spam_license_key'),0,64);
					$blog_web_address = get_site_url();
					$address_unclean = $blog_web_address;
					$address_long = preg_replace('#^https?://#', '', $address_unclean);
					$address = substr($address_long,0,256);
					@$blog_server_ip = substr($_SERVER['SERVER_ADDR'],0,48);
					//if empty ip
					if(empty($blog_server_ip) || $blog_server_ip == '0'){
						@$blog_server_ip = 'I '.substr(gethostbyname($_SERVER['SERVER_NAME']),0,48);
					}
					$spam_master_learning_post = array(
														'blog_license_key' => $blog_license_key,
														'blog_threat_ip' => $remote_ip,
														'blog_threat_type' => $blog_threat_type,
														'blog_threat_email' => 'captcha@'.rand(10000000, 99999999).'.wp',
														'blog_threat_content' => 'Page: registration.',
														'blog_threat_agent' => $remote_agent,
														'blog_threat_refe' => $remote_referer,
														'blog_threat_dest' => $dest_url,
														'blog_web_adress' => $address,
														'blog_server_ip' => $blog_server_ip
												);										
					$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																									'method' => 'POST',
																									'timeout' => 90,
																									'body' => $spam_master_learning_post
																							));															
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: reCaptcha. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
					}
					else{
						$data = json_decode( wp_remote_retrieve_body( $response ), true );
						if(empty($data['threat'])){
							$spamco = $data['co'];
							$spamcou = $data['cou'];
							//Log InUp Controller
							/////////////////////
							$spamkey = 'reCaptcha';
							$spamvalue = 'Wrong reCaptcha in registration.';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
						}
						else{
							$remote_ip = $data['threat'];
							$spamco = $data['co'];
							$spamcou = $data['cou'];																											
							//Log InUp Controller
							/////////////////////
							$spamkey = 'reCaptcha';
							$spamvalue = 'Blocked reCaptcha in registration by online RBL.';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

							//Spam Buffer Controller
							////////////////////////
							$blog_threat_email = false;
							$SpamMasterBufferController = new SpamMasterBufferController;
							$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);
						}
					}
					$errors->add('invalid_email', __('<strong>SPAM MASTER</strong>: Insert Correct Captcha','spam_master') );
					return $errors;
				}
			return $errors;
			//END ERRORS VALIDATION
			}
		//END public key
		}
	//END $spam_master_recaptcha_registration - true
	}

	//////////////////////////////////////
	//IMPLEMENT RECAPTCHA FRONTEND LOGIN//
	if ($spam_master_recaptcha_login == 'true'){
		if ($spam_master_recaptcha_public_key !== ''){
			if ( !('true' == spam_master_amp_check() && !( 'true' == $spam_master_recaptcha_ampoff ) ) ) {
				//MULTISITE HOOKS
				if(is_multisite()){
					add_action('signup_extra_fields', 'spam_master_recaptcha_login_field' );
					add_action('login_form', 'spam_master_recaptcha_login_field');
					add_action('login_head', 'spam_master_recaptcha_login_errors', 99);
				}
				//SINGLE SITE HOOKS
				else{
					add_action('login_enqueue_scripts', 'spam_master_recaptcha_login_css');
					add_action('login_form', 'spam_master_recaptcha_login_field');
					add_filter( 'login_errors', 'spam_master_recaptcha_login_errors', 10, 3 );
				}
			}
			//CSS FOR SINGLE SITE
			function spam_master_recaptcha_login_css(){
				wp_register_style( 'spam_master_recaptcha_login_css', plugins_url('../../css/spam-master-recaptcha.css',  __FILE__) );
				wp_enqueue_style( 'spam_master_recaptcha_login_css' );
			}
			//END CSS
			//INSERT FIELD
			function spam_master_recaptcha_login_field(){
			global $wpdb, $blog_id;
				if(is_multisite()){
					$spam_master_recaptcha_public_key = get_blog_option($blog_id, 'spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_blog_option($blog_id, 'spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_blog_option($blog_id, 'spam_master_recaptcha_theme');
				}
				else{
					$spam_master_recaptcha_public_key = get_option('spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_option('spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_option('spam_master_recaptcha_theme');
				}
					echo	'<script src="https://www.google.com/recaptcha/api.js"></script>';
					echo	'<label>Re-CAPTCHA Code</label>' .
							'<div class="g-recaptcha" data-theme="'.$spam_master_recaptcha_theme.'" data-sitekey="' . $spam_master_recaptcha_public_key . '"></div>';
				//END FIELD
				}
				//START ERRORS VALIDATION
				function spam_master_recaptcha_login_errors($error) {
				global $wpdb, $blog_id, $errors;
				$err_codes = $errors->get_error_codes();
				if(is_multisite()){
					$spam_master_recaptcha_public_key = get_blog_option($blog_id, 'spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_blog_option($blog_id, 'spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_blog_option($blog_id, 'spam_master_recaptcha_theme');
					$blog_license_key = get_blog_option($blog_id, 'spam_license_key');
				}
				else{
					$spam_master_recaptcha_public_key = get_option('spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_option('spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_option('spam_master_recaptcha_theme');
					$blog_license_key = get_option('spam_license_key');
				}
				if ( isset( $_POST['g-recaptcha-response'] ) ) {
					$response = wp_remote_get( 'https://www.google.com/recaptcha/api/siteverify?secret=' . $spam_master_recaptcha_secret_key . '&response=' . $_POST['g-recaptcha-response'] );
					$response = json_decode( $response['body'], true );
					
					//Remote Ip
					$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
					//Remote Agent
					if(isset($_SERVER['HTTP_USER_AGENT'])){
						$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
					}
					else{
						$remote_agent = 'Sniffer';
					}
					// Remote Referer
					if(isset($_SERVER['HTTP_REFERER'])){
						$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
					}
					else{
						$remote_referer = 'Direct';
					}
					// DEST URL
					if(isset($_SERVER['REQUEST_URI'])){
						$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
					}
					else{
						$dest_url = 'Weird';
					}
					//exempt admins from check
					if(!function_exists('wp_get_current_user')) {
						include(ABSPATH . "wp-includes/pluggable.php"); 
					}
					// Current User
					$current_user_id = get_current_user_id();
					if(isset($current_user_id)){
						$current_user_id = $current_user_id;
					}
					else{
						$current_user_id = 'none';
					}

					//Add Controllers
					require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterBufferController.php');
					require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');

					//Log InUp Controller
					$spamkey = 'Firewall';
					$spamco = 'localhost';
					$spamcou = 'localhost';
					$spamvalue = 'reCaptcha login Spam Check Triggered.';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
					
					if ( false === $response['success'] ) {
						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

						//Create data to be posted
						$blog_threat_type = 'captcha';
						$spam_master_leaning_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2NhcHRjaGFfMi5waHA=';
						$blog_license_key = substr($blog_license_key,0,64);
						$blog_web_address = get_site_url();
						$address_unclean = $blog_web_address;
						$address_long = preg_replace('#^https?://#', '', $address_unclean);
						$address = substr($address_long,0,256);
						@$blog_server_ip = substr($_SERVER['SERVER_ADDR'],0,48);
						//if empty ip
						if(empty($blog_server_ip) || $blog_server_ip == '0'){
							@$blog_server_ip = 'I '.substr(gethostbyname($_SERVER['SERVER_NAME']),0,48);
						}
						$spam_master_learning_post = array(
															'blog_license_key' => $blog_license_key,
															'blog_threat_ip' => $remote_ip,
															'blog_threat_type' => $blog_threat_type,
															'blog_threat_email' => 'captcha@'.rand(10000000, 99999999).'.wp',
															'blog_threat_content' => 'Page: login.',
															'blog_threat_agent' => $remote_agent,
															'blog_threat_refe' => $remote_referer,
															'blog_threat_dest' => $dest_url,
															'blog_web_adress' => $address,
															'blog_server_ip' => $blog_server_ip
													);										
						$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																									'method' => 'POST',
																									'timeout' => 90,
																									'body' => $spam_master_learning_post
																							));
						if ( is_wp_error( $response ) ) {
							$error_message = $response->get_error_message();
							//Log InUp Controller
							/////////////////////
							$spamkey = 'System';
							$spamco = 'localhost';
							$spamcou = 'localhost';
							$spamvalue = 'Error: reCaptcha. '.$error_message.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
						}
						else{
							$data = json_decode( wp_remote_retrieve_body( $response ), true );
							if(empty($data['threat'])){
								$spamco = $data['co'];
								$spamcou = $data['cou'];
								//Log InUp Controller
								/////////////////////
								$spamkey = 'reCaptcha';
								$spamvalue = 'Wrong reCaptcha in login.';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							}
							else{
								$remote_ip = $data['threat'];
								$spamco = $data['co'];
								$spamcou = $data['cou'];																											
								//Log InUp Controller
								/////////////////////
								$spamkey = 'reCaptcha';
								$spamvalue = 'Blocked reCaptcha in login by online RBL.';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

								//Spam Buffer Controller
								////////////////////////
								$blog_threat_email = false;
								$SpamMasterBufferController = new SpamMasterBufferController;
								$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);
							}
						}
						$error = '<strong>SPAM MASTER:</strong> Insert Correct Captcha';
					}
				}
			return $error;
			}
		//END public key
		}
	//END $spam_master_recaptcha_login - true
	}

	/////////////////////////////////////////
	//IMPLEMENT RECAPTCHA FRONTEND COMMENTS//
	if ($spam_master_recaptcha_comments == 'true'){
		if ($spam_master_recaptcha_public_key !== ''){
			if ( !('true' == spam_master_amp_check() && !( 'true' == $spam_master_recaptcha_ampoff ) ) ) {
				//MULTISITE HOOKS
				if(is_multisite()){
					add_action( 'comment_form_after_fields', 'spam_master_comment_field', 1);
					add_filter( 'preprocess_comment', 'spam_master_verify_comment_data' );
				}
				//SINGLE SITE HOOKS
				else{
					add_action('wp_enqueue_scripts', 'spam_master_recaptcha_comments_css');
					add_action( 'comment_form_after_fields', 'spam_master_comment_field', 1);
					add_filter( 'preprocess_comment', 'spam_master_verify_comment_data' );
				}
			}

			//CSS FOR SINGLE SITE
			function spam_master_recaptcha_comments_css(){
				wp_register_style( 'spam_master_recaptcha_comments_css', plugins_url('../../css/spam-master-recaptcha.css',  __FILE__) );
				wp_enqueue_style( 'spam_master_recaptcha_comments_css' );
			}
			//END CSS
			function spam_master_comment_field(){
			global $wpdb, $blog_id;
				if(is_multisite()){
					$spam_master_recaptcha_public_key = get_blog_option($blog_id, 'spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_blog_option($blog_id, 'spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_blog_option($blog_id, 'spam_master_recaptcha_theme');
				}
				else{
					$spam_master_recaptcha_public_key = get_option('spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_option('spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_option('spam_master_recaptcha_theme');
				}
				echo	'<script src="https://www.google.com/recaptcha/api.js"></script>';
				echo	'<p class="comment-form-recaptcha">' .
						'<label>Re-CAPTCHA Code</label>' .
						'<div class="g-recaptcha" data-theme="'.$spam_master_recaptcha_theme.'" data-sitekey="' . $spam_master_recaptcha_public_key . '"></div></p>';
			}
			//COMMENT VERIFICATION
			function spam_master_verify_comment_data($commentdata){
			global $wpdb, $blog_id;
				if(is_multisite()){
					$spam_master_recaptcha_public_key = get_blog_option($blog_id, 'spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_blog_option($blog_id, 'spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_blog_option($blog_id, 'spam_master_recaptcha_theme');
					$blog_license_key = get_blog_option($blog_id, 'spam_license_key');
				}
				else{
					$spam_master_recaptcha_public_key = get_option('spam_master_recaptcha_public_key');
					$spam_master_recaptcha_secret_key = get_option('spam_master_recaptcha_secret_key');
					$spam_master_recaptcha_theme = get_option('spam_master_recaptcha_theme');
					$blog_license_key = get_option('spam_license_key');
				}
				if ( isset( $_POST['g-recaptcha-response'] ) ) {
					$response = wp_remote_get( 'https://www.google.com/recaptcha/api/siteverify?secret=' . $spam_master_recaptcha_secret_key . '&response=' . $_POST['g-recaptcha-response'] );
					$response = json_decode( $response['body'], true );

					//Remote Ip
					$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
					//Remote Agent
					if(isset($_SERVER['HTTP_USER_AGENT'])){
						$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
					}
					else{
						$remote_agent = 'Sniffer';
					}
					// Remote Referer
					if(isset($_SERVER['HTTP_REFERER'])){
						$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
					}
					else{
						$remote_referer = 'Direct';
					}
					// DEST URL
					if(isset($_SERVER['REQUEST_URI'])){
						$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
					}
					else{
						$dest_url = 'Weird';
					}
					//exempt admins from check
					if(!function_exists('wp_get_current_user')) {
						include(ABSPATH . "wp-includes/pluggable.php"); 
					}
					// Current User
					$current_user_id = get_current_user_id();
					if(isset($current_user_id)){
						$current_user_id = $current_user_id;
					}
					else{
						$current_user_id = 'none';
					}

					//Add Controllers
					require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterBufferController.php');
					require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');

					//Log InUp Controller
					$spamkey = 'Firewall';
					$spamco = 'localhost';
					$spamcou = 'localhost';
					$spamvalue = 'reCaptcha comment Spam Check Triggered.';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

					if ( true === $response['success'] ) {
						return $commentdata;
					}
					else{
						//Spam Buffer Controller
						////////////////////////
						$SpamMasterBufferController = new SpamMasterBufferController;
						$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

						//Create data to be posted
						$blog_threat_type = 'captcha';
						$spam_master_leaning_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX2NhcHRjaGFfMi5waHA=';
						$blog_license_key = substr($blog_license_key,0,64);
						$blog_web_address = get_site_url();
						$address_unclean = $blog_web_address;
						$address_long = preg_replace('#^https?://#', '', $address_unclean);
						$address = substr($address_long,0,256);
						@$blog_server_ip = substr($_SERVER['SERVER_ADDR'],0,48);
						//if empty ip
						if(empty($blog_server_ip) || $blog_server_ip == '0'){
							@$blog_server_ip = 'I '.substr(gethostbyname($_SERVER['SERVER_NAME']),0,48);
						}
						$spam_master_learning_post = array(
															'blog_license_key' => $blog_license_key,
															'blog_threat_ip' => $remote_ip,
															'blog_threat_type' => $blog_threat_type,
															'blog_threat_email' => 'captcha@'.rand(10000000, 99999999).'.wp',
															'blog_threat_content' => 'Page: comment.',
															'blog_threat_agent' => $remote_agent,
															'blog_threat_refe' => $remote_referer,
															'blog_threat_dest' => $dest_url,
															'blog_web_adress' => $address,
															'blog_server_ip' => $blog_server_ip
													);										
						$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																									'method' => 'POST',
																									'timeout' => 90,
																									'body' => $spam_master_learning_post
																							));
						if ( is_wp_error( $response ) ) {
							$error_message = $response->get_error_message();
							//Log InUp Controller
							/////////////////////
							$spamkey = 'System';
							$spamco = 'localhost';
							$spamcou = 'localhost';
							$spamvalue = 'Error: reCaptcha. '.$error_message.'';
							$SpamMasterLogController = new SpamMasterLogController;
							$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
						}
						else{
							$data = json_decode( wp_remote_retrieve_body( $response ), true );
							if(empty($data['threat'])){
								$spamco = $data['co'];
								$spamcou = $data['cou'];
								//Log InUp Controller
								/////////////////////
								$spamkey = 'reCaptcha';
								$spamvalue = 'Wrong reCaptcha in comment.';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
							}
							else{
								$remote_ip = $data['threat'];
								$spamco = $data['co'];
								$spamcou = $data['cou'];																											
								//Log InUp Controller
								/////////////////////
								$spamkey = 'reCaptcha';
								$spamvalue = 'Blocked reCaptcha in comment by online RBL.';
								$SpamMasterLogController = new SpamMasterLogController;
								$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

								//Spam Buffer Controller
								////////////////////////
								$blog_threat_email = false;
								$SpamMasterBufferController = new SpamMasterBufferController;
								$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);
							}
						}
						return wp_die( __( '<strong>SPAM MASTER</strong>: Insert Correct Captcha' ) );
					}
				}
				return $commentdata;
			}
		//END public key
		}
	//END $spam_master_recaptcha_comments - true	
	}

// end valid
}
?>
