<?php
// Multisite Block
if( is_multisite()){
	$response_key = get_blog_option($blog_id, 'spam_master_status');
	//Set malfunctions as VALID
	//post data if license status is valid
	if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
		add_filter('wpmu_validate_user_signup', 'spam_master_registration_multi', 99);
		function spam_master_registration_multi($result){
		global $wpdb, $blog_id;

			//Remote Ip
			$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
			//Remote Agent
			if(isset($_SERVER['HTTP_USER_AGENT'])){
				$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
			}
			else{
				$remote_agent = 'Sniffer';
			}
			// Remote Referer
			if(isset($_SERVER['HTTP_REFERER'])){
				$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
			}
			else{
				$remote_referer = 'Direct';
			}
			// DEST URL
			if(isset($_SERVER['REQUEST_URI'])){
				$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
			}
			else{
				$dest_url = 'Weird';
			}
			//exempt admins from check
			if(!function_exists('wp_get_current_user')) {
				include(ABSPATH . "wp-includes/pluggable.php"); 
			}
			// Current User
			$current_user_id = get_current_user_id();
			if(isset($current_user_id)){
				$current_user_id = $current_user_id;
			}
			else{
				$current_user_id = 'none';
			}

			//prepare threat buffer
			if (!empty($result['user_email'])) {
				if (filter_var($result['user_email'], FILTER_VALIDATE_EMAIL)) {
					$blog_threat_email = wp_strip_all_tags(substr($result['user_email'],0,256));
				}
				else{
					$blog_threat_email = 'registration@'.rand(10000000, 99999999).'.wp';
				}
			}
			else{
				$blog_threat_email = 'registration@'.rand(10000000, 99999999).'.wp';
			}

			//Add Controllers
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterBufferController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterFloodController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterWhiteController.php');

			//create data to be posted
			$blog_license_key = substr(get_blog_option($blog_id, 'spam_license_key'),0,64);
			$blog_threat_content = 'registration';
			$blog_threat_type = 'registration';
			$spam_master_leaning_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX3JlZ18yLnBocA==';
			$blog_web_address = get_site_url();
			$address_unclean = $blog_web_address;
			$address_long = preg_replace('#^https?://#', '', $address_unclean);
			$address = substr($address_long,0,256);
			@$blog_server_ip = substr($_SERVER['SERVER_ADDR'],0,48);
			//if empty ip
			if(empty($blog_server_ip) || $blog_server_ip == '0'){
				@$blog_server_ip = 'I '.substr(gethostbyname($_SERVER['SERVER_NAME']),0,48);
			}

			//Spam White Controller
			////////////////////////
			$SpamMasterWhiteController = new SpamMasterWhiteController;
			$is_spamadmin = $SpamMasterWhiteController->SpamMasterWhiteAdmin();
			if(!empty($is_spamadmin)){
				//Log InUp Controller
				$spamkey = 'Registration';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Approved by capable user and exempt from spam check.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
			}

			//Spam White Controller
			////////////////////////
			$SpamMasterWhiteController = new SpamMasterWhiteController;
			$is_white = $SpamMasterWhiteController->SpamMasterWhiteSearch($remote_ip, $blog_threat_email);
			if(!empty($is_white)){
				//Log InUp Controller
				$spamkey = 'Registration';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Approved by whitelist and exempt from spam check.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
			}

			//Spam Buffer Controller
			////////////////////////
			$SpamMasterBufferController = new SpamMasterBufferController;
			$is_buffer = $SpamMasterBufferController->SpamMasterBufferSearch($remote_ip, $blog_threat_email);
			if(!empty($is_buffer)){
				//Log InUp Controller
				/////////////////////
				$spamkey = 'Registration';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Blocked in registration by Spam Buffer.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

				//Spam Buffer Controller
				////////////////////////
				$SpamMasterBufferController = new SpamMasterBufferController;
				$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

				echo '<p class="error"><strong>SPAM MASTER</strong>'.get_blog_option($blog_id, 'spam_master_message').'</p>';
				exit();
			}

			//Alert 3
			$spam_master_alert_level = get_blog_option($blog_id, 'spam_master_alert_level');
			if ($spam_master_alert_level == 'ALERT_3'){
				//Flood Controller
				///////////////////////
				$spamkey = 'Registration';
				$SpamMasterFloodController = new SpamMasterFloodController;
				$is_flood_3 = $SpamMasterFloodController->SpamMasterAlert3($spamkey);
				if(!empty($is_flood_3)){
					//Log InUp Controller
					/////////////////////
					$spamkey = 'Registration';
					$spamco = 'localhost';
					$spamcou = 'localhost';
					$spamvalue = 'Alert 2/3 warning, registration flooding detected. Administration Exploit Attempt.';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

					//Spam Buffer Controller
					////////////////////////
					$SpamMasterBufferController = new SpamMasterBufferController;
					$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

					echo '<p class="error"><strong>SPAM MASTER</strong> Flood detected. Please wait a few minutes.</p>';
					exit();
				}
			}

			//Flood Controller
			///////////////////////
			$spamkey = 'Registration';
			$SpamMasterFloodController = new SpamMasterFloodController;
			$is_flood = $SpamMasterFloodController->SpamMasterFlood($spamkey, $remote_ip);
			if(!empty($is_flood)){
				$spam_master_learning_post = array(
													'blog_license_key' => $blog_license_key,
													'blog_threat_ip' => $remote_ip,
													'blog_threat_type' => $blog_threat_type,
													'blog_threat_email' => $blog_threat_email,
													'blog_threat_content' => 'Registration Flood Count: ' . $is_flood,
													'blog_threat_agent' => $remote_agent,
													'blog_threat_refe' => $remote_referer,
													'blog_threat_dest' => $dest_url,
													'blog_web_adress' => $address,
													'blog_server_ip' => $blog_server_ip
				);
				$response = wp_remote_post( base64_decode($spam_master_learn_h_url), array(
																							'method' => 'POST',
																							'timeout' => 90,
																							'body' => $spam_master_learning_post
				));
				if ( is_wp_error( $response ) ) {
					$error_message = $response->get_error_message();
					//Log InUp Controller
					/////////////////////
					$spamkey = 'System';
					$spamco = 'localhost';
					$spamcou = 'localhost';
					$spamvalue = 'Error: Registration Flood. '.$error_message.'';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
					echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
				}
				else{
					$data = json_decode( wp_remote_retrieve_body( $response ), true );
					if(empty($data['threat'])){
						$spamco = $data['co'];
						$spamcou = $data['cou'];
						//Log InUp Controller
						/////////////////////
						$spamkey = 'Registration';
						$spamvalue = 'Blocked in registration by online RBL. Flood Count :' . $is_flood.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
					}
					else{
						$remote_ip = $data['threat'];
						$spamco = $data['co'];
						$spamcou = $data['cou'];							
						//Log InUp Controller
						/////////////////////
						$spamkey = 'Registration';
						$spamvalue = 'Blocked in registration by online RBL. Flood Count :' . $is_flood.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
					}
				}
				//Spam Buffer Controller
				////////////////////////
				$SpamMasterBufferController = new SpamMasterBufferController;
				$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

				//Spam Buffer Controller
				////////////////////////
				$SpamMasterBufferController = new SpamMasterBufferController;
				$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

				echo '<p class="error"><strong>SPAM MASTER</strong> Flood detected. Please wait a few minutes.</p>';
				exit();
			}

			$spam_master_learning_post = array(
												'blog_license_key' => $blog_license_key,
												'blog_threat_ip' => $remote_ip,
												'blog_threat_type' => $blog_threat_type,
												'blog_threat_email' => $blog_threat_email,
												'blog_threat_content' => $blog_threat_content,
												'blog_threat_agent' => $remote_agent,
												'blog_threat_refe' => $remote_referer,
												'blog_threat_dest' => $dest_url,
												'blog_web_adress' => $address,
												'blog_server_ip' => $blog_server_ip
			);										
			$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																						'method' => 'POST',
																						'timeout' => 90,
																						'body' => $spam_master_learning_post
			));
			if ( is_wp_error( $response ) ) {
				$error_message = $response->get_error_message();
				//Log InUp Controller
				/////////////////////
				$spamkey = 'System';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Error: Learning Registration. '.$error_message.'';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
				//Log InUp Controller
				/////////////////////
				$spamkey = 'Registration';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Approved with error, Email: ' . $blog_threat_email.'';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
				echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
			}
			else{
				$data = json_decode( wp_remote_retrieve_body( $response ), true );
				if(empty($data['threat'])){
					$spamco = $data['co'];
					$spamcou = $data['cou'];
					//Log InUp Controller
					/////////////////////
					$spamkey = 'Registration';
					$spamvalue = 'Approved, Email: ' . $blog_threat_email .'';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
				}
				else{
					$remote_ip = $data['threat'];
					$spamco = $data['co'];
					$spamcou = $data['cou'];
					//Spam Buffer Controller
					////////////////////////
					$SpamMasterBufferController = new SpamMasterBufferController;
					$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

					//Spam Buffer Controller
					////////////////////////
					$SpamMasterBufferController = new SpamMasterBufferController;
					$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

					//Log InUp Controller
					/////////////////////
					$spamkey = 'Registration';
					$spamvalue = 'Blocked by online RBL, Email: ' . $blog_threat_email .'';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

					echo '<p class="error"><strong>SPAM MASTER</strong>'.get_blog_option($blog_id, 'spam_master_message').'</p>';
					exit();
				}
			}
			return $result;
		//end func
		}
	//end valid
	}
//end multi
}
//SingleSite Block
else{
	//post data if license status is valid
	$response_key = get_option('spam_master_status');
	//Set malfunctions as VALID
	if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
		add_action( 'register_post', 'spam_master_registration', 11, 3 );
		function spam_master_registration($user_login, $user_email, $errors){
		global $wpdb;

			//Remote Ip
			$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
			//Remote Agent
			if(isset($_SERVER['HTTP_USER_AGENT'])){
				$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
			}
			else{
				$remote_agent = 'Sniffer';
			}
			// Remote Referer
			if(isset($_SERVER['HTTP_REFERER'])){
				$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
			}
			else{
				$remote_referer = 'Direct';
			}
			// DEST URL
			if(isset($_SERVER['REQUEST_URI'])){
				$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
			}
			else{
				$dest_url = 'Weird';
			}
			//exempt admins from check
			if(!function_exists('wp_get_current_user')) {
				include(ABSPATH . "wp-includes/pluggable.php"); 
			}
			// Current User
			$current_user_id = get_current_user_id();
			if(isset($current_user_id)){
				$current_user_id = $current_user_id;
			}
			else{
				$current_user_id = 'none';
			}

			//prepare threat buffer
			if (!empty($user_email)) {
				if (filter_var($user_email, FILTER_VALIDATE_EMAIL)) {
					$blog_threat_email = wp_strip_all_tags(substr($user_email,0,256));
				}
				else{
					$blog_threat_email = 'registration@'.rand(10000000, 99999999).'.wp';
				}
			}
			else{
				$blog_threat_email = 'registration@'.rand(10000000, 99999999).'.wp';
			}

			//Add Controllers
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterBufferController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterFloodController.php');
			require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterWhiteController.php');

			//create data to be posted
			$blog_license_key = substr(get_option('spam_license_key'),0,64);
			$blog_threat_type = 'registration';
			$blog_threat_content = 'registration';
			$spam_master_leaning_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX3JlZ18yLnBocA==';
			$blog_web_address = get_site_url();
			$address_unclean = $blog_web_address;
			$address_long = preg_replace('#^https?://#', '', $address_unclean);
			$address = substr($address_long,0,256);
			@$blog_server_ip = substr($_SERVER['SERVER_ADDR'],0,48);
			//if empty ip
			if(empty($blog_server_ip) || $blog_server_ip == '0'){
				@$blog_server_ip = 'I '.substr(gethostbyname($_SERVER['SERVER_NAME']),0,48);
			}

			//Spam White Controller
			////////////////////////
			$SpamMasterWhiteController = new SpamMasterWhiteController;
			$is_spamadmin = $SpamMasterWhiteController->SpamMasterWhiteAdmin();
			if(!empty($is_spamadmin)){
				//Log InUp Controller
				$spamkey = 'Registration';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Approved by capable user and exempt from spam check.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

				return;
			}

			//Spam White Controller
			////////////////////////
			$SpamMasterWhiteController = new SpamMasterWhiteController;
			$is_white = $SpamMasterWhiteController->SpamMasterWhiteSearch($remote_ip, $blog_threat_email);
			if(!empty($is_white)){
				//Log InUp Controller
				$spamkey = 'Registration';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Approved by whitelist and exempt from spam check.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

				return;
			}

			//Alert 3
			$spam_master_alert_level = get_option('spam_master_alert_level');
			if ($spam_master_alert_level == 'ALERT_3'){
				//Flood Controller
				///////////////////////
				$spamkey = 'Registration';
				$SpamMasterFloodController = new SpamMasterFloodController;
				$is_flood_3 = $SpamMasterFloodController->SpamMasterAlert3($spamkey);
				if(!empty($is_flood_3)){
					//Log InUp Controller
					/////////////////////
					$spamkey = 'Registration';
					$spamco = 'localhost';
					$spamcou = 'localhost';
					$spamvalue = 'Alert 2/3 warning, registration flooding detected. Administration Exploit Attempt.';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

					//Spam Buffer Controller
					////////////////////////
					$SpamMasterBufferController = new SpamMasterBufferController;
					$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

					$errors->add('invalid_email', '<strong>SPAM MASTER</strong> Flood detected. Please wait a few minutes.');
					return;
				}
			}

			//Flood Controller
			///////////////////////
			$spamkey = 'Registration';
			$SpamMasterFloodController = new SpamMasterFloodController;
			$is_flood = $SpamMasterFloodController->SpamMasterFlood($spamkey, $remote_ip);
			if(!empty($is_flood)){
				$spam_master_learning_post = array(
													'blog_license_key' => $blog_license_key,
													'blog_threat_ip' => $remote_ip,
													'blog_threat_type' => $blog_threat_type,
													'blog_threat_email' => $blog_threat_email,
													'blog_threat_content' => 'Registration Flood Count: ' . $is_flood,
													'blog_threat_agent' => $remote_agent,
													'blog_threat_refe' => $remote_referer,
													'blog_threat_dest' => $dest_url,
													'blog_web_adress' => $address,
													'blog_server_ip' => $blog_server_ip
				);
				$response = wp_remote_post( base64_decode($spam_master_learn_h_url), array(
																							'method' => 'POST',
																							'timeout' => 90,
																							'body' => $spam_master_learning_post
				));
				if ( is_wp_error( $response ) ) {
					$error_message = $response->get_error_message();
					//Log InUp Controller
					/////////////////////
					$spamkey = 'System';
					$spamco = 'localhost';
					$spamcou = 'localhost';
					$spamvalue = 'Error: Registration Flood. '.$error_message.'';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
					echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
				}
				else{
					$data = json_decode( wp_remote_retrieve_body( $response ), true );
					if(empty($data['threat'])){
						$spamco = $data['co'];
						$spamcou = $data['cou'];
						//Log InUp Controller
						/////////////////////
						$spamkey = 'Registration';
						$spamvalue = 'Blocked in registration by online RBL. Flood Count :' . $is_flood.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
					}
					else{
						$remote_ip = $data['threat'];
						$spamco = $data['co'];
						$spamcou = $data['cou'];							
						//Log InUp Controller
						/////////////////////
						$spamkey = 'Registration';
						$spamvalue = 'Blocked in registration by online RBL. Flood Count :' . $is_flood.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
					}
				}
				//Spam Buffer Controller
				////////////////////////
				$SpamMasterBufferController = new SpamMasterBufferController;
				$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

				//Spam Buffer Controller
				////////////////////////
				$SpamMasterBufferController = new SpamMasterBufferController;
				$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

				$errors->add('invalid_email', '<strong>SPAM MASTER</strong> Flood detected. Please wait a few minutes.');
				return;
			}
			$spam_master_learning_post = array(
												'blog_license_key' => $blog_license_key,
												'blog_threat_ip' => $remote_ip,
												'blog_threat_type' => $blog_threat_type,
												'blog_threat_email' => $blog_threat_email,
												'blog_threat_content' => $blog_threat_content,
												'blog_threat_agent' => $remote_agent,
												'blog_threat_refe' => $remote_referer,
												'blog_threat_dest' => $dest_url,
												'blog_web_adress' => $address,
												'blog_server_ip' => $blog_server_ip
			);										
			$response = wp_remote_post( base64_decode($spam_master_leaning_url), array(
																						'method' => 'POST',
																						'timeout' => 90,
																						'body' => $spam_master_learning_post
			));
			if ( is_wp_error( $response ) ) {
				$error_message = $response->get_error_message();
				//Log InUp Controller
				/////////////////////
				$spamkey = 'System';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Error: Learning Registration. '.$error_message.'';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
				//Log InUp Controller
				/////////////////////
				$spamkey = 'Registration';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Approved with error, Email: ' . $blog_threat_email.'';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
				echo "Something went wrong, please get in touch with TechGasp Support: $error_message";
				return;
			}
			else{
				$data = json_decode( wp_remote_retrieve_body( $response ), true );
				if(empty($data['threat'])){
					$spamco = $data['co'];
					$spamcou = $data['cou'];
					//Log InUp Controller
					/////////////////////
					$spamkey = 'Registration';
					$spamvalue = 'Approved, Email: ' . $blog_threat_email .'';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
					return;
				}
				else{
					$remote_ip = $data['threat'];
					$spamco = $data['co'];
					$spamcou = $data['cou'];
					//Spam Buffer Controller
					////////////////////////
					$SpamMasterBufferController = new SpamMasterBufferController;
					$is_threat = $SpamMasterBufferController->SpamMasterBufferInsert($remote_ip, $blog_threat_email, $spamco, $spamcou);

					//Spam Buffer Controller
					////////////////////////
					$SpamMasterBufferController = new SpamMasterBufferController;
					$is_buffer_count = $SpamMasterBufferController->SpamMasterBufferCount();

					//Log InUp Controller
					/////////////////////
					$spamkey = 'Registration';
					$spamvalue = 'Blocked by online RBL, Email: ' . $blog_threat_email .'';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

					$errors->add('invalid_email', '<strong>SPAM MASTER</strong>'.__( get_option('spam_master_message') ));
					return;
				}
			}
		//end func
		}
	//end valid
	}
//end single
}
?>
