<?php
		/** function/method
		* Usage: hooking (registering) the plugin menu
		* Arg(0): null
		* Return: void
		*/
		function menu_white_single(){
		if ( is_admin() )
		add_submenu_page( 'spam-master', 'Whitelist', 'Whitelist', 'manage_options', 'spam-master-whitelist', 'spam_master_whitelist' );
		}

		///////////////////////
		// WORDPRESS ACTIONS //
		///////////////////////
		if( is_multisite() ) {
		add_action( 'admin_menu', 'menu_white_single' );
		}
		else{
		add_action( 'admin_menu', 'menu_white_single' );
		}

function spam_master_whitelist(){
global $wp_nonce, $wpdb, $blog_id;

$plugin_master_name = constant('SPAM_MASTER_NAME');
$plugin_master_domain = constant('SPAM_MASTER_DOMAIN');

if( is_multisite() ){
	$blogname = substr(get_blog_option($blog_id, 'blogname'),0,256);
	$response_key = get_blog_option($blog_id, 'spam_master_status');
	$spam_license_key = esc_html(substr(get_blog_option($blog_id, 'spam_license_key'),0,64));
	//Load Tables
	$table_spam_master_white = $wpdb->get_blog_prefix($blog_id)."spam_master_white";
	$table_spam_master_threats = $wpdb->get_blog_prefix($blog_id)."spam_master_threats";
	$table_spam_master_keys = $wpdb->get_blog_prefix($blog_id)."spam_master_keys";
}
else{
	$blogname = substr(get_option('blogname'),0,256);
	$response_key = get_option('spam_master_status');
	$spam_license_key = esc_html(substr(get_option('spam_license_key'),0,64));
	//Load Tables
	$table_spam_master_white = $wpdb->prefix."spam_master_white";
	$table_spam_master_threats = $wpdb->prefix."spam_master_threats";
	$table_spam_master_keys = $wpdb->prefix."spam_master_keys";
}
if(empty($blogname)){
	$blogname = 'empty blog name';
}

//Add Controllers
require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterLogController.php');

//Remote Ip
$remote_ip = substr($_SERVER['REMOTE_ADDR'],0,48);
//Remote Agent
if(isset($_SERVER['HTTP_USER_AGENT'])){
	$remote_agent = substr($_SERVER['HTTP_USER_AGENT'],0,360);
}
else{
	$remote_agent = 'Sniffer';
}
// Remote Referer
if(isset($_SERVER['HTTP_REFERER'])){
	$remote_referer = substr($_SERVER['HTTP_REFERER'],0,360);
}
else{
	$remote_referer = 'Direct';
}
// DEST URL
if(isset($_SERVER['REQUEST_URI'])){
	$dest_url = substr($_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'],0,360);
}
else{
	$dest_url = 'Weird';
}
//exempt admins from check
if(!function_exists('wp_get_current_user')) {
	include(ABSPATH . "wp-includes/pluggable.php"); 
}
// Current User
$current_user_id = get_current_user_id();
if(isset($current_user_id)){
	$current_user_id = $current_user_id;
}
else{
	$current_user_id = 'none';
}

//Add Whitelist
if(isset($_POST['add_whitelist'])){
	check_admin_referer( 'save-settings_spam_master_add_whitelist' );
	if(isset($_POST['spam_master_add_whitelist'])){
		$add_to_white = sanitize_text_field($_POST['spam_master_add_whitelist']);
		if(empty($add_to_white)){
			$add_to_white = '(add none)';
		}
		//Email Validation
		if ( (filter_var($add_to_white, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6)) || (filter_var($add_to_white, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)) ){
			//First check whitelist to see if exists
			$exists_white = $wpdb->get_var(
							$wpdb->prepare("SELECT white FROM $table_spam_master_white WHERE white = %s",
							$add_to_white
							));
			//Exists error
			if($exists_white){
				//Log InUp Controller
				$spamkey = 'System';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Whitelist add entry '.$add_to_white.' failed because it exists.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
?>
<div id="message" class="error">
<p><?php echo __($add_to_white . ' already exists in whitelist.', 'spam_master'); ?></p>
</div>
<?php
			}
			else{
				//Log InUp Controller
				$spamkey = 'System';
				$spamco = 'localhost';
				$spamcou = 'localhost';
				$spamvalue = 'Whitelist successful add entry '.$add_to_white.' and all Emails associated.';
				$SpamMasterLogController = new SpamMasterLogController;
				$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

				//Search for all emails in keys spamvalue and insert
				$white_get_emails = $wpdb->get_results( 
									$wpdb->prepare( 
													"SELECT DISTINCT(REGEXP_SUBSTR(spamvalue, '([a-zA-Z0-9._%+\-]+)@([a-zA-Z0-9.-]+)\.([a-zA-Z]{2,4})')) AS emails FROM $table_spam_master_keys WHERE spamkey != 'System' AND spamip = %s AND LOCATE('@', spamvalue)", $add_to_white
				));
				if(!empty($white_get_emails)){
					foreach($white_get_emails as $white_insert_email){
						$whiteemail = $white_insert_email->emails;
						$wpdb->insert( $table_spam_master_white, array( 'time' => current_time( 'mysql' ), 'white' => $whiteemail, 'whiteco' => 'email', 'whitecou' => 'Email' ));
						//Delete Emails from threats
						$wpdb->delete( $table_spam_master_threats, array( 'threat' => $whiteemail ) );
					}
				}
				//Delete from threats
				$wpdb->delete( $table_spam_master_threats, array( 'threat' => $add_to_white ) );

				if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
					//Report data
					$white_emails_if_any = $wpdb->get_var( 
										$wpdb->prepare( 
														"SELECT GROUP_CONCAT(DISTINCT(REGEXP_SUBSTR(spamvalue, '([a-zA-Z0-9._%+\-]+)@([a-zA-Z0-9.-]+)\.([a-zA-Z]{2,4})')) SEPARATOR '-') AS emails FROM $table_spam_master_keys WHERE spamkey != 'System' AND spamip = %s AND LOCATE('@', spamvalue)", $add_to_white
					));
					if(empty($white_emails_if_any)){
						$white_emails_if_any = 'none';
					}
					$spam_master_learn_r_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX3JlcC5waHA=';
					$spam_master_report_post = array(
														'blog_license_key' => $spam_license_key,
														'blog_type' => 'Whitelist Ip Addition',
														'blog_primary' => substr($add_to_white, 0,256),
														'blog_secondary' => $white_emails_if_any.' - Remote Ip: '.$remote_ip,
														'blog_name' => $blogname,
														'blog_agent' => $remote_agent
					);
					$response = wp_remote_post( base64_decode($spam_master_learn_r_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_report_post
					));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Whitelist RBL Reporting. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

						$wpdb->insert( $table_spam_master_white, array( 'time' => current_time( 'mysql' ), 'white' => $add_to_white, 'whiteco' => '_unknown', 'whitecou' => '_unknown' ));
?>
<div id="message" class="error">
<p><?php echo __('Something went wrong, please get in touch with spammaster.org support ERROR: '.$error_message, 'spam_master'); ?></p>
</div>
<?php
					}
					else{
						$data = json_decode( wp_remote_retrieve_body( $response ), true );
						//Insert flag for ip
						$spamco = $data['co'];
						$spamcou = $data['cou'];
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamvalue = $add_to_white . ' successfully whitelisted and all Emails associated. RBL server report successful.';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);

						$wpdb->insert( $table_spam_master_white, array( 'time' => current_time( 'mysql' ), 'white' => $add_to_white, 'whiteco' => $spamco, 'whitecou' => $spamcou ));
?>
<div id="message" class="updated fade">
<p><?php echo __($add_to_white . ' successfully whitelisted and all Emails associated. RBL server report successful.', 'spam_master'); ?></p>
</div>
<?php
					}
				}
				else{

					$wpdb->insert( $table_spam_master_white, array( 'time' => current_time( 'mysql' ), 'white' => $add_to_white, 'whiteco' => '_unknown', 'whitecou' => '_unknown' ));
?>
<div id="message" class="error">
<p><?php echo __($add_to_white . ' successfully whitelisted and all Emails associated. License ERROR, no connection, could not report to RBL Servers.', 'spam_master'); ?></p>
</div>
<?php
				}
			}
		}
		else{
			if ( (filter_var($add_to_white, FILTER_VALIDATE_EMAIL)) ){
				//First check whitelist to see if exists
				$exists_white = $wpdb->get_var(
								$wpdb->prepare("SELECT white FROM $table_spam_master_white WHERE white = %s",
								$add_to_white
								));
				//Exists error
				if($exists_white){
					//Log InUp Controller
					$spamkey = 'System';
					$spamco = 'localhost';
					$spamcou = 'localhost';
					$spamvalue = 'Whitelist add entry '.$add_to_white.' failed because it exists.';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
?>
<div id="message" class="error">
<p><?php echo __($add_to_white . ' already exists in whitelist.', 'spam_master'); ?></p>
</div>
<?php
				}
				else{
					//Log InUp Controller
					$spamkey = 'System';
					$spamco = 'localhost';
					$spamcou = 'localhost';
					$spamvalue = 'Whitelist successful add entry '.$add_to_white.' and all Ips associated.';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
					//Insert to white and Email co & cou
					$wpdb->insert( $table_spam_master_white, array( 'time' => current_time( 'mysql' ), 'white' => $add_to_white, 'whiteco' => 'email', 'whitecou' => 'Email' ));
					//Search for all ips in keys spamvalue and insert
					$white_get_ips = $wpdb->get_results( 
										$wpdb->prepare( 
														"SELECT spamip,spamco,spamcou FROM $table_spam_master_keys WHERE spamkey != 'System' AND LOCATE(%s, spamvalue) GROUP BY spamip", $add_to_white
					));
					if(!empty($white_get_ips)){
						foreach($white_get_ips as $white_insert_ip){
							$whiteip = $white_insert_ip->spamip;
							$whiteco = $white_insert_ip->spamco;
							$whitecou = $white_insert_ip->spamcou;
							$wpdb->insert( $table_spam_master_white, array( 'time' => current_time( 'mysql' ), 'white' => $whiteip, 'whiteco' => $whiteco, 'whitecou' => $whitecou ));
							//Delete Ips from threats
							$wpdb->delete( $table_spam_master_threats, array( 'threat' => $whiteip ) );
						}
					}
					//Delete Email from threats
					$wpdb->delete( $table_spam_master_threats, array( 'threat' => $add_to_white ) );

				if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
					//Report data
					$white_get_ips_if_any = $wpdb->get_var( 
										$wpdb->prepare( 
														"SELECT GROUP_CONCAT(DISTINCT(spamip)  SEPARATOR '-') FROM $table_spam_master_keys WHERE spamkey != 'System' AND LOCATE(%s, spamvalue)", $add_to_white
					));
					if(empty($white_get_ips_if_any)){
						$white_get_ips_if_any = 'none';
					}
					$spam_master_learn_r_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX3JlcC5waHA=';
					$spam_master_report_post = array(
														'blog_license_key' => $spam_license_key,
														'blog_type' => 'Whitelist Email Addition',
														'blog_primary' => substr($add_to_white, 0,256),
														'blog_secondary' => $white_get_ips_if_any.' - Remote Ip: '.$remote_ip,
														'blog_name' => $blogname,
														'blog_agent' => $remote_agent
					);
					$response = wp_remote_post( base64_decode($spam_master_learn_r_url), array(
																								'method' => 'POST',
																								'timeout' => 90,
																								'body' => $spam_master_report_post
					));
					if ( is_wp_error( $response ) ) {
						$error_message = $response->get_error_message();
						//Log InUp Controller
						/////////////////////
						$spamkey = 'System';
						$spamco = 'localhost';
						$spamcou = 'localhost';
						$spamvalue = 'Error: Whitelist RBL Reporting. '.$error_message.'';
						$SpamMasterLogController = new SpamMasterLogController;
						$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
?>
<div id="message" class="error">
<p><?php echo __('Something went wrong, please get in touch with spammaster.org support ERROR: '.$error_message, 'spam_master'); ?></p>
</div>
<?php
					}
					else{
?>
<div id="message" class="updated fade">
<p><?php echo __($add_to_white . ' successfully whitelisted and all Ip\'s associated. RBL server report successful.', 'spam_master'); ?></p>
</div>
<?php
					}
				}
				else{
?>
<div id="message" class="error">
<p><?php echo __($add_to_white . ' successfully whitelisted and all Ip\'s associated. License ERROR, no connection, could not report to RBL Servers.', 'spam_master'); ?></p>
</div>
<?php
				}
			}
		}
		else{
			//Log InUp Controller
			$spamkey = 'System';
			$spamco = 'localhost';
			$spamcou = 'localhost';
			$spamvalue = 'Whitelist add entry '.$add_to_white.' failed validation.';
			$SpamMasterLogController = new SpamMasterLogController;
			$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
?>
<div id="message" class="error">
<p><?php echo __('Error! Could not validate your Email, IPV6 or IPV4 for whitelist addition. Please insert a valid Email or Ip.', 'spam_master'); ?></p>
</div>
<?php
			}
		}
	}
}

//Delete Whitelist
if(isset($_POST['delete_whitelist'])){
	check_admin_referer( 'save-settings_spam_master_delete_whitelist' );
	if(isset($_POST['spam_master_delete_whitelist'])){
		$delete_to_white = sanitize_text_field($_POST['spam_master_delete_whitelist']);
		if(empty($delete_to_white)){
			$delete_to_white = '(delete none)';
		}
		//Email Validation
		if ( (!filter_var($delete_to_white, FILTER_VALIDATE_EMAIL)) && (!filter_var($delete_to_white, FILTER_VALIDATE_IP, FILTER_FLAG_IPV6)) && (!filter_var($delete_to_white, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)) ){
			//Log InUp Controller
			$spamkey = 'System';
			$spamco = 'localhost';
			$spamcou = 'localhost';
			$spamvalue = 'Whitelist delete entry '.$delete_to_white.' failed validation.';
			$SpamMasterLogController = new SpamMasterLogController;
			$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
?>
<div id="message" class="error">
<p><?php echo __('Error! Could not validate your Email, IPV6 or IPV4 for whitelist deletion. Please insert a valid listed Email or Ip.', 'spam_master'); ?></p>
</div>
<?php
		}
		else{
			//Log InUp Controller
			$spamkey = 'System';
			$spamco = 'localhost';
			$spamcou = 'localhost';
			$spamvalue = 'Whitelist successful delete entry '.$delete_to_white.'.';
			$SpamMasterLogController = new SpamMasterLogController;
			$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
			//Delete from white
			$wpdb->delete( $table_spam_master_white, array( 'white' => $delete_to_white ) );

			if($response_key == 'VALID' || $response_key == 'MALFUNCTION_1' || $response_key == 'MALFUNCTION_2'){
				//Report data
				$spam_master_learn_r_url = 'aHR0cHM6Ly93d3cuc3BhbW1hc3Rlci5vcmcvd3AtY29udGVudC9wbHVnaW5zL3NwYW0tbWFzdGVyLWFkbWluaXN0cmF0b3IvaW5jbHVkZXMvbGVhcm5pbmcvZ2V0X2xlYXJuX3JlcC5waHA=';
				$spam_master_report_post = array(
												'blog_license_key' => $spam_license_key,
												'blog_type' => 'Whitelist Removal',
												'blog_primary' => substr($delete_to_white, 0,256),
												'blog_secondary' => 'Remote Ip: '.$remote_ip,
												'blog_name' => $blogname,
												'blog_agent' => $remote_agent
				);
				$response = wp_remote_post( base64_decode($spam_master_learn_r_url), array(
																							'method' => 'POST',
																							'timeout' => 90,
																							'body' => $spam_master_report_post
				));
				if ( is_wp_error( $response ) ) {
					$error_message = $response->get_error_message();
					//Log InUp Controller
					/////////////////////
					$spamkey = 'System';
					$spamco = 'localhost';
					$spamcou = 'localhost';
					$spamvalue = 'Error: Whitelist RBL Reporting. '.$error_message.'';
					$SpamMasterLogController = new SpamMasterLogController;
					$is_log = $SpamMasterLogController->SpamMasterLog($spamkey, $remote_ip, $spamco, $spamcou, $remote_referer, $dest_url, $remote_agent, $current_user_id, $spamvalue);
?>
<div id="message" class="error">
<p><?php echo __('Something went wrong, please get in touch with spammaster.org support ERROR: '.$error_message, 'spam_master'); ?></p>
</div>
<?php
					}
					else{
?>
<div id="message" class="updated fade">
<p><?php echo __($delete_to_white . ' successfully deleted from whitelist. RBL server report successful.', 'spam_master'); ?></p>
</div>
<?php
					}
				}
				else{
?>
<div id="message" class="error">
<p><?php echo __($delete_to_white . ' uccessfully deleted from whitelist. License ERROR, no connection, could not report to RBL Servers.', 'spam_master'); ?></p>
</div>
<?php
				}
		}
	}
}

?>
<div class="wrap">
<h1><?php echo $plugin_master_name; ?> <?php echo __('Whitelist', 'spam_master'); ?></h1>
<?php
//Add Controllers
require_once( WP_PLUGIN_DIR . '/spam-master/includes/controllers/SpamMasterInvitationController.php');
$SpamMasterInvitationController = new SpamMasterInvitationController;
$is_invited = $SpamMasterInvitationController->SpamMasterInvitation();
echo $is_invited;

if(!class_exists('spam_master_menu_table')){
	require_once( WP_PLUGIN_DIR . '/spam-master/includes/admin/spam-master-admin-menu-table.php');
}
//Prepare Table of elements
$wp_list_table = new spam_master_menu_table();
//Table of elements
$wp_list_table->display();
?>
<table class="wp-list-table widefat fixed striped table-view-list" cellspacing="0">
	<thead>
		<tr>
			<th colspan="2">
				<h2><img class="spam-master-admin-img" src="<?php echo plugins_url('../images/spammaster-logo.png', dirname(__FILE__)); ?>" /><?php echo __('&nbsp;Spam Master Whitelist Exclusions', 'spam_master'); ?></h2>
				<p><?php echo __('Spam Buffer Whitelisting excludes spam checks from safe Emails or Ip\'s, it also removes these safe Emails and Ip\'s from your local Spam Buffer.', 'spam_master'); ?></p>
			</th>
		</tr>
		<tr>
			<th colspan="2">
				<p><?php echo __('To add', 'spam_master'); ?> <span class="dashicons dashicons-shield-alt spam-master-admin-green"></span> <?php echo __('or remove', 'spam_master'); ?> <span class="dashicons dashicons-superhero spam-master-admin-green"></span> <?php echo __('Emails or Ip\'s from your local Whitelist you can manually add them here or use the', 'spam_master'); ?> <b><?php echo __('Firewall', 'spam_master'); ?></b>.</p>
				<p><p><a class="btn-spammaster orange roundedspam" href="https://www.spammaster.org/search-threat/" target="_blank"><span class="dashicons dashicons-search"></span> <?php echo __('Search RBL', 'spam_master'); ?></a></p></p>
			</th>
		</tr>
	</thead>

	<tfoot>
		<tr>
			<td colspan="2"></td>
		</tr>
	</tfoot>

	<tbody>
		<tr>
			<td class="alternate">
				<form method="post" width='1'>
					<fieldset class="options">
						<?php $sec_nonce = wp_nonce_field( 'save-settings_spam_master_add_whitelist' ); ?>
						<label for="spam_master_add_whitelist"><b><?php echo __('Add Email or Ip\'s to Whitelist:', 'spam_master'); ?></b></label>
						<input id="spam_master_add_whitelist" name="spam_master_add_whitelist" type="text" value="">&nbsp;&nbsp;<button type="submit" name="add_whitelist" id="add_whitelist" class="btn-spammaster blue roundedspam" href="#" title="<?php echo __('Add Whitelist', 'spam_master'); ?>"><?php echo __('Add Whitelist', 'spam_master'); ?></button>
					</fieldset>
				</form>
			</td>
			<td class="alternate">
				<form method="post" width='1'>
					<fieldset class="options">
						<?php $sec_nonce = wp_nonce_field( 'save-settings_spam_master_delete_whitelist' ); ?>
						<label for="spam_master_delete_whitelist"><b><?php echo __('Delete Email or Ip\'s from Whitelist:', 'spam_master'); ?></b></label>
						<input id="spam_master_delete_whitelist" name="spam_master_delete_whitelist" type="text" value="">&nbsp;&nbsp;<button type="submit" name="delete_whitelist" id="delete_whitelist" class="btn-spammaster blue roundedspam" href="#" title="<?php echo __('Delete Whitelist', 'spam_master'); ?>"><?php echo __('Delete Whitelist', 'spam_master'); ?></button>
					</fieldset>
				</form>
			</td>
		</tr>
	</tbody>
</table>

<div class="spam-master-pad-table"></div>

<?php
if(!class_exists('spam_master_whitelist_table')){
	require_once( WP_PLUGIN_DIR . '/spam-master/includes/whitelist/spam-master-admin-whitelist-table.php');
}
//Prepare Table of elements
$wp_list_table = new spam_master_whitelist_table();
$wp_list_table->prepare_items();
?>
<form method="get">
<input type="hidden" name="page" value="<?php echo esc_attr($_REQUEST['page']); ?>" />
<?php
$wp_list_table->search_box('search', '-search-input');
//Table of elements
$wp_list_table->display();
?>
</form>
<?php
//Footer
require_once( WP_PLUGIN_DIR . '/spam-master/includes/admin/spam-master-admin-footer.php');
?>
</div>
<?php
}
